// IFC SDK : IFC2X3 C++ Early Classes  
// Copyright (C) 2009 CSTB
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// The full license is in Licence.txt file included with this 
// distribution or is available at :
//     http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

#ifndef IFC2X3_FWDECL_H
#define IFC2X3_FWDECL_H
namespace ifc2x3 {

class Ifc2DCompositeCurve;
class IfcActionRequest;
class IfcActor;
class IfcActorRole;
class IfcActuatorType;
class IfcAddress;
class IfcAirTerminalBoxType;
class IfcAirTerminalType;
class IfcAirToAirHeatRecoveryType;
class IfcAlarmType;
class IfcAngularDimension;
class IfcAnnotation;
class IfcAnnotationCurveOccurrence;
class IfcAnnotationFillArea;
class IfcAnnotationFillAreaOccurrence;
class IfcAnnotationOccurrence;
class IfcAnnotationSurface;
class IfcAnnotationSurfaceOccurrence;
class IfcAnnotationSymbolOccurrence;
class IfcAnnotationTextOccurrence;
class IfcApplication;
class IfcAppliedValue;
class IfcAppliedValueRelationship;
class IfcApproval;
class IfcApprovalActorRelationship;
class IfcApprovalPropertyRelationship;
class IfcApprovalRelationship;
class IfcArbitraryClosedProfileDef;
class IfcArbitraryOpenProfileDef;
class IfcArbitraryProfileDefWithVoids;
class IfcAsset;
class IfcAsymmetricIShapeProfileDef;
class IfcAxis1Placement;
class IfcAxis2Placement2D;
class IfcAxis2Placement3D;
class IfcBSplineCurve;
class IfcBeam;
class IfcBeamType;
class IfcBezierCurve;
class IfcBlobTexture;
class IfcBlock;
class IfcBoilerType;
class IfcBooleanClippingResult;
class IfcBooleanResult;
class IfcBoundaryCondition;
class IfcBoundaryEdgeCondition;
class IfcBoundaryFaceCondition;
class IfcBoundaryNodeCondition;
class IfcBoundaryNodeConditionWarping;
class IfcBoundedCurve;
class IfcBoundedSurface;
class IfcBoundingBox;
class IfcBoxedHalfSpace;
class IfcBuilding;
class IfcBuildingElement;
class IfcBuildingElementComponent;
class IfcBuildingElementPart;
class IfcBuildingElementProxy;
class IfcBuildingElementProxyType;
class IfcBuildingElementType;
class IfcBuildingStorey;
class IfcCShapeProfileDef;
class IfcCableCarrierFittingType;
class IfcCableCarrierSegmentType;
class IfcCableSegmentType;
class IfcCalendarDate;
class IfcCartesianPoint;
class IfcCartesianTransformationOperator;
class IfcCartesianTransformationOperator2D;
class IfcCartesianTransformationOperator2DnonUniform;
class IfcCartesianTransformationOperator3D;
class IfcCartesianTransformationOperator3DnonUniform;
class IfcCenterLineProfileDef;
class IfcChamferEdgeFeature;
class IfcChillerType;
class IfcCircle;
class IfcCircleHollowProfileDef;
class IfcCircleProfileDef;
class IfcClassification;
class IfcClassificationItem;
class IfcClassificationItemRelationship;
class IfcClassificationNotation;
class IfcClassificationNotationFacet;
class IfcClassificationReference;
class IfcClosedShell;
class IfcCoilType;
class IfcColourRgb;
class IfcColourSpecification;
class IfcColumn;
class IfcColumnType;
class IfcComplexProperty;
class IfcCompositeCurve;
class IfcCompositeCurveSegment;
class IfcCompositeProfileDef;
class IfcCompressorType;
class IfcCondenserType;
class IfcCondition;
class IfcConditionCriterion;
class IfcConic;
class IfcConnectedFaceSet;
class IfcConnectionCurveGeometry;
class IfcConnectionGeometry;
class IfcConnectionPointEccentricity;
class IfcConnectionPointGeometry;
class IfcConnectionPortGeometry;
class IfcConnectionSurfaceGeometry;
class IfcConstraint;
class IfcConstraintAggregationRelationship;
class IfcConstraintClassificationRelationship;
class IfcConstraintRelationship;
class IfcConstructionEquipmentResource;
class IfcConstructionMaterialResource;
class IfcConstructionProductResource;
class IfcConstructionResource;
class IfcContextDependentUnit;
class IfcControl;
class IfcControllerType;
class IfcConversionBasedUnit;
class IfcCooledBeamType;
class IfcCoolingTowerType;
class IfcCoordinatedUniversalTimeOffset;
class IfcCostItem;
class IfcCostSchedule;
class IfcCostValue;
class IfcCovering;
class IfcCoveringType;
class IfcCraneRailAShapeProfileDef;
class IfcCraneRailFShapeProfileDef;
class IfcCrewResource;
class IfcCsgPrimitive3D;
class IfcCsgSolid;
class IfcCurrencyRelationship;
class IfcCurtainWall;
class IfcCurtainWallType;
class IfcCurve;
class IfcCurveBoundedPlane;
class IfcCurveStyle;
class IfcCurveStyleFont;
class IfcCurveStyleFontAndScaling;
class IfcCurveStyleFontPattern;
class IfcDamperType;
class IfcDateAndTime;
class IfcDefinedSymbol;
class IfcDerivedProfileDef;
class IfcDerivedUnit;
class IfcDerivedUnitElement;
class IfcDiameterDimension;
class IfcDimensionCalloutRelationship;
class IfcDimensionCurve;
class IfcDimensionCurveDirectedCallout;
class IfcDimensionCurveTerminator;
class IfcDimensionPair;
class IfcDimensionalExponents;
class IfcDirection;
class IfcDiscreteAccessory;
class IfcDiscreteAccessoryType;
class IfcDistributionChamberElement;
class IfcDistributionChamberElementType;
class IfcDistributionControlElement;
class IfcDistributionControlElementType;
class IfcDistributionElement;
class IfcDistributionElementType;
class IfcDistributionFlowElement;
class IfcDistributionFlowElementType;
class IfcDistributionPort;
class IfcDocumentElectronicFormat;
class IfcDocumentInformation;
class IfcDocumentInformationRelationship;
class IfcDocumentReference;
class IfcDoor;
class IfcDoorLiningProperties;
class IfcDoorPanelProperties;
class IfcDoorStyle;
class IfcDraughtingCallout;
class IfcDraughtingCalloutRelationship;
class IfcDraughtingPreDefinedColour;
class IfcDraughtingPreDefinedCurveFont;
class IfcDraughtingPreDefinedTextFont;
class IfcDuctFittingType;
class IfcDuctSegmentType;
class IfcDuctSilencerType;
class IfcEdge;
class IfcEdgeCurve;
class IfcEdgeFeature;
class IfcEdgeLoop;
class IfcElectricApplianceType;
class IfcElectricDistributionPoint;
class IfcElectricFlowStorageDeviceType;
class IfcElectricGeneratorType;
class IfcElectricHeaterType;
class IfcElectricMotorType;
class IfcElectricTimeControlType;
class IfcElectricalBaseProperties;
class IfcElectricalCircuit;
class IfcElectricalElement;
class IfcElement;
class IfcElementAssembly;
class IfcElementComponent;
class IfcElementComponentType;
class IfcElementQuantity;
class IfcElementType;
class IfcElementarySurface;
class IfcEllipse;
class IfcEllipseProfileDef;
class IfcEnergyConversionDevice;
class IfcEnergyConversionDeviceType;
class IfcEnergyProperties;
class IfcEnvironmentalImpactValue;
class IfcEquipmentElement;
class IfcEquipmentStandard;
class IfcEvaporativeCoolerType;
class IfcEvaporatorType;
class IfcExtendedMaterialProperties;
class IfcExternalReference;
class IfcExternallyDefinedHatchStyle;
class IfcExternallyDefinedSurfaceStyle;
class IfcExternallyDefinedSymbol;
class IfcExternallyDefinedTextFont;
class IfcExtrudedAreaSolid;
class IfcFace;
class IfcFaceBasedSurfaceModel;
class IfcFaceBound;
class IfcFaceOuterBound;
class IfcFaceSurface;
class IfcFacetedBrep;
class IfcFacetedBrepWithVoids;
class IfcFailureConnectionCondition;
class IfcFanType;
class IfcFastener;
class IfcFastenerType;
class IfcFeatureElement;
class IfcFeatureElementAddition;
class IfcFeatureElementSubtraction;
class IfcFillAreaStyle;
class IfcFillAreaStyleHatching;
class IfcFillAreaStyleTileSymbolWithStyle;
class IfcFillAreaStyleTiles;
class IfcFilterType;
class IfcFireSuppressionTerminalType;
class IfcFlowController;
class IfcFlowControllerType;
class IfcFlowFitting;
class IfcFlowFittingType;
class IfcFlowInstrumentType;
class IfcFlowMeterType;
class IfcFlowMovingDevice;
class IfcFlowMovingDeviceType;
class IfcFlowSegment;
class IfcFlowSegmentType;
class IfcFlowStorageDevice;
class IfcFlowStorageDeviceType;
class IfcFlowTerminal;
class IfcFlowTerminalType;
class IfcFlowTreatmentDevice;
class IfcFlowTreatmentDeviceType;
class IfcFluidFlowProperties;
class IfcFooting;
class IfcFuelProperties;
class IfcFurnishingElement;
class IfcFurnishingElementType;
class IfcFurnitureStandard;
class IfcFurnitureType;
class IfcGasTerminalType;
class IfcGeneralMaterialProperties;
class IfcGeneralProfileProperties;
class IfcGeometricCurveSet;
class IfcGeometricRepresentationContext;
class IfcGeometricRepresentationItem;
class IfcGeometricRepresentationSubContext;
class IfcGeometricSet;
class IfcGrid;
class IfcGridAxis;
class IfcGridPlacement;
class IfcGroup;
class IfcHalfSpaceSolid;
class IfcHeatExchangerType;
class IfcHumidifierType;
class IfcHygroscopicMaterialProperties;
class IfcIShapeProfileDef;
class IfcImageTexture;
class IfcInventory;
class IfcIrregularTimeSeries;
class IfcIrregularTimeSeriesValue;
class IfcJunctionBoxType;
class IfcLShapeProfileDef;
class IfcLaborResource;
class IfcLampType;
class IfcLibraryInformation;
class IfcLibraryReference;
class IfcLightDistributionData;
class IfcLightFixtureType;
class IfcLightIntensityDistribution;
class IfcLightSource;
class IfcLightSourceAmbient;
class IfcLightSourceDirectional;
class IfcLightSourceGoniometric;
class IfcLightSourcePositional;
class IfcLightSourceSpot;
class IfcLine;
class IfcLinearDimension;
class IfcLocalPlacement;
class IfcLocalTime;
class IfcLoop;
class IfcManifoldSolidBrep;
class IfcMappedItem;
class IfcMaterial;
class IfcMaterialClassificationRelationship;
class IfcMaterialDefinitionRepresentation;
class IfcMaterialLayer;
class IfcMaterialLayerSet;
class IfcMaterialLayerSetUsage;
class IfcMaterialList;
class IfcMaterialProperties;
class IfcMeasureWithUnit;
class IfcMechanicalConcreteMaterialProperties;
class IfcMechanicalFastener;
class IfcMechanicalFastenerType;
class IfcMechanicalMaterialProperties;
class IfcMechanicalSteelMaterialProperties;
class IfcMember;
class IfcMemberType;
class IfcMetric;
class IfcMonetaryUnit;
class IfcMotorConnectionType;
class IfcMove;
class IfcNamedUnit;
class IfcObject;
class IfcObjectDefinition;
class IfcObjectPlacement;
class IfcObjective;
class IfcOccupant;
class IfcOffsetCurve2D;
class IfcOffsetCurve3D;
class IfcOneDirectionRepeatFactor;
class IfcOpenShell;
class IfcOpeningElement;
class IfcOpticalMaterialProperties;
class IfcOrderAction;
class IfcOrganization;
class IfcOrganizationRelationship;
class IfcOrientedEdge;
class IfcOutletType;
class IfcOwnerHistory;
class IfcParameterizedProfileDef;
class IfcPath;
class IfcPerformanceHistory;
class IfcPermeableCoveringProperties;
class IfcPermit;
class IfcPerson;
class IfcPersonAndOrganization;
class IfcPhysicalComplexQuantity;
class IfcPhysicalQuantity;
class IfcPhysicalSimpleQuantity;
class IfcPile;
class IfcPipeFittingType;
class IfcPipeSegmentType;
class IfcPixelTexture;
class IfcPlacement;
class IfcPlanarBox;
class IfcPlanarExtent;
class IfcPlane;
class IfcPlate;
class IfcPlateType;
class IfcPoint;
class IfcPointOnCurve;
class IfcPointOnSurface;
class IfcPolyLoop;
class IfcPolygonalBoundedHalfSpace;
class IfcPolyline;
class IfcPort;
class IfcPostalAddress;
class IfcPreDefinedColour;
class IfcPreDefinedCurveFont;
class IfcPreDefinedDimensionSymbol;
class IfcPreDefinedItem;
class IfcPreDefinedPointMarkerSymbol;
class IfcPreDefinedSymbol;
class IfcPreDefinedTerminatorSymbol;
class IfcPreDefinedTextFont;
class IfcPresentationLayerAssignment;
class IfcPresentationLayerWithStyle;
class IfcPresentationStyle;
class IfcPresentationStyleAssignment;
class IfcProcedure;
class IfcProcess;
class IfcProduct;
class IfcProductDefinitionShape;
class IfcProductRepresentation;
class IfcProductsOfCombustionProperties;
class IfcProfileDef;
class IfcProfileProperties;
class IfcProject;
class IfcProjectOrder;
class IfcProjectOrderRecord;
class IfcProjectionCurve;
class IfcProjectionElement;
class IfcProperty;
class IfcPropertyBoundedValue;
class IfcPropertyConstraintRelationship;
class IfcPropertyDefinition;
class IfcPropertyDependencyRelationship;
class IfcPropertyEnumeratedValue;
class IfcPropertyEnumeration;
class IfcPropertyListValue;
class IfcPropertyReferenceValue;
class IfcPropertySet;
class IfcPropertySetDefinition;
class IfcPropertySingleValue;
class IfcPropertyTableValue;
class IfcProtectiveDeviceType;
class IfcProxy;
class IfcPumpType;
class IfcQuantityArea;
class IfcQuantityCount;
class IfcQuantityLength;
class IfcQuantityTime;
class IfcQuantityVolume;
class IfcQuantityWeight;
class IfcRadiusDimension;
class IfcRailing;
class IfcRailingType;
class IfcRamp;
class IfcRampFlight;
class IfcRampFlightType;
class IfcRationalBezierCurve;
class IfcRectangleHollowProfileDef;
class IfcRectangleProfileDef;
class IfcRectangularPyramid;
class IfcRectangularTrimmedSurface;
class IfcReferencesValueDocument;
class IfcRegularTimeSeries;
class IfcReinforcementBarProperties;
class IfcReinforcementDefinitionProperties;
class IfcReinforcingBar;
class IfcReinforcingElement;
class IfcReinforcingMesh;
class IfcRelAggregates;
class IfcRelAssigns;
class IfcRelAssignsTasks;
class IfcRelAssignsToActor;
class IfcRelAssignsToControl;
class IfcRelAssignsToGroup;
class IfcRelAssignsToProcess;
class IfcRelAssignsToProduct;
class IfcRelAssignsToProjectOrder;
class IfcRelAssignsToResource;
class IfcRelAssociates;
class IfcRelAssociatesAppliedValue;
class IfcRelAssociatesApproval;
class IfcRelAssociatesClassification;
class IfcRelAssociatesConstraint;
class IfcRelAssociatesDocument;
class IfcRelAssociatesLibrary;
class IfcRelAssociatesMaterial;
class IfcRelAssociatesProfileProperties;
class IfcRelConnects;
class IfcRelConnectsElements;
class IfcRelConnectsPathElements;
class IfcRelConnectsPortToElement;
class IfcRelConnectsPorts;
class IfcRelConnectsStructuralActivity;
class IfcRelConnectsStructuralElement;
class IfcRelConnectsStructuralMember;
class IfcRelConnectsWithEccentricity;
class IfcRelConnectsWithRealizingElements;
class IfcRelContainedInSpatialStructure;
class IfcRelCoversBldgElements;
class IfcRelCoversSpaces;
class IfcRelDecomposes;
class IfcRelDefines;
class IfcRelDefinesByProperties;
class IfcRelDefinesByType;
class IfcRelFillsElement;
class IfcRelFlowControlElements;
class IfcRelInteractionRequirements;
class IfcRelNests;
class IfcRelOccupiesSpaces;
class IfcRelOverridesProperties;
class IfcRelProjectsElement;
class IfcRelReferencedInSpatialStructure;
class IfcRelSchedulesCostItems;
class IfcRelSequence;
class IfcRelServicesBuildings;
class IfcRelSpaceBoundary;
class IfcRelVoidsElement;
class IfcRelationship;
class IfcRelaxation;
class IfcRepresentation;
class IfcRepresentationContext;
class IfcRepresentationItem;
class IfcRepresentationMap;
class IfcResource;
class IfcRevolvedAreaSolid;
class IfcRibPlateProfileProperties;
class IfcRightCircularCone;
class IfcRightCircularCylinder;
class IfcRoof;
class IfcRoot;
class IfcRoundedEdgeFeature;
class IfcRoundedRectangleProfileDef;
class IfcSIUnit;
class IfcSanitaryTerminalType;
class IfcScheduleTimeControl;
class IfcSectionProperties;
class IfcSectionReinforcementProperties;
class IfcSectionedSpine;
class IfcSensorType;
class IfcServiceLife;
class IfcServiceLifeFactor;
class IfcShapeAspect;
class IfcShapeModel;
class IfcShapeRepresentation;
class IfcShellBasedSurfaceModel;
class IfcSimpleProperty;
class IfcSite;
class IfcSlab;
class IfcSlabType;
class IfcSlippageConnectionCondition;
class IfcSolidModel;
class IfcSoundProperties;
class IfcSoundValue;
class IfcSpace;
class IfcSpaceHeaterType;
class IfcSpaceProgram;
class IfcSpaceThermalLoadProperties;
class IfcSpaceType;
class IfcSpatialStructureElement;
class IfcSpatialStructureElementType;
class IfcSphere;
class IfcStackTerminalType;
class IfcStair;
class IfcStairFlight;
class IfcStairFlightType;
class IfcStructuralAction;
class IfcStructuralActivity;
class IfcStructuralAnalysisModel;
class IfcStructuralConnection;
class IfcStructuralConnectionCondition;
class IfcStructuralCurveConnection;
class IfcStructuralCurveMember;
class IfcStructuralCurveMemberVarying;
class IfcStructuralItem;
class IfcStructuralLinearAction;
class IfcStructuralLinearActionVarying;
class IfcStructuralLoad;
class IfcStructuralLoadGroup;
class IfcStructuralLoadLinearForce;
class IfcStructuralLoadPlanarForce;
class IfcStructuralLoadSingleDisplacement;
class IfcStructuralLoadSingleDisplacementDistortion;
class IfcStructuralLoadSingleForce;
class IfcStructuralLoadSingleForceWarping;
class IfcStructuralLoadStatic;
class IfcStructuralLoadTemperature;
class IfcStructuralMember;
class IfcStructuralPlanarAction;
class IfcStructuralPlanarActionVarying;
class IfcStructuralPointAction;
class IfcStructuralPointConnection;
class IfcStructuralPointReaction;
class IfcStructuralProfileProperties;
class IfcStructuralReaction;
class IfcStructuralResultGroup;
class IfcStructuralSteelProfileProperties;
class IfcStructuralSurfaceConnection;
class IfcStructuralSurfaceMember;
class IfcStructuralSurfaceMemberVarying;
class IfcStructuredDimensionCallout;
class IfcStyleModel;
class IfcStyledItem;
class IfcStyledRepresentation;
class IfcSubContractResource;
class IfcSubedge;
class IfcSurface;
class IfcSurfaceCurveSweptAreaSolid;
class IfcSurfaceOfLinearExtrusion;
class IfcSurfaceOfRevolution;
class IfcSurfaceStyle;
class IfcSurfaceStyleLighting;
class IfcSurfaceStyleRefraction;
class IfcSurfaceStyleRendering;
class IfcSurfaceStyleShading;
class IfcSurfaceStyleWithTextures;
class IfcSurfaceTexture;
class IfcSweptAreaSolid;
class IfcSweptDiskSolid;
class IfcSweptSurface;
class IfcSwitchingDeviceType;
class IfcSymbolStyle;
class IfcSystem;
class IfcSystemFurnitureElementType;
class IfcTShapeProfileDef;
class IfcTable;
class IfcTableRow;
class IfcTankType;
class IfcTask;
class IfcTelecomAddress;
class IfcTendon;
class IfcTendonAnchor;
class IfcTerminatorSymbol;
class IfcTextLiteral;
class IfcTextLiteralWithExtent;
class IfcTextStyle;
class IfcTextStyleFontModel;
class IfcTextStyleForDefinedFont;
class IfcTextStyleTextModel;
class IfcTextStyleWithBoxCharacteristics;
class IfcTextureCoordinate;
class IfcTextureCoordinateGenerator;
class IfcTextureMap;
class IfcTextureVertex;
class IfcThermalMaterialProperties;
class IfcTimeSeries;
class IfcTimeSeriesReferenceRelationship;
class IfcTimeSeriesSchedule;
class IfcTimeSeriesValue;
class IfcTopologicalRepresentationItem;
class IfcTopologyRepresentation;
class IfcTransformerType;
class IfcTransportElement;
class IfcTransportElementType;
class IfcTrapeziumProfileDef;
class IfcTrimmedCurve;
class IfcTubeBundleType;
class IfcTwoDirectionRepeatFactor;
class IfcTypeObject;
class IfcTypeProduct;
class IfcUShapeProfileDef;
class IfcUnitAssignment;
class IfcUnitaryEquipmentType;
class IfcValveType;
class IfcVector;
class IfcVertex;
class IfcVertexBasedTextureMap;
class IfcVertexLoop;
class IfcVertexPoint;
class IfcVibrationIsolatorType;
class IfcVirtualElement;
class IfcVirtualGridIntersection;
class IfcWall;
class IfcWallStandardCase;
class IfcWallType;
class IfcWasteTerminalType;
class IfcWaterProperties;
class IfcWindow;
class IfcWindowLiningProperties;
class IfcWindowPanelProperties;
class IfcWindowStyle;
class IfcWorkControl;
class IfcWorkPlan;
class IfcWorkSchedule;
class IfcZShapeProfileDef;
class IfcZone;
class IfcActorSelect;
class IfcAppliedValueSelect;
class IfcAxis2Placement;
class IfcBooleanOperand;
class IfcCharacterStyleSelect;
class IfcClassificationNotationSelect;
class IfcColour;
class IfcColourOrFactor;
class IfcConditionCriterionSelect;
class IfcCsgSelect;
class IfcCurveFontOrScaledCurveFontSelect;
class IfcCurveOrEdgeCurve;
class IfcCurveStyleFontSelect;
class IfcDateTimeSelect;
class IfcDefinedSymbolSelect;
class IfcDerivedMeasureValue;
class IfcDocumentSelect;
class IfcDraughtingCalloutElement;
class IfcFillAreaStyleTileShapeSelect;
class IfcFillStyleSelect;
class IfcGeometricSetSelect;
class IfcHatchLineDistanceSelect;
class IfcLayeredItem;
class IfcLibrarySelect;
class IfcLightDistributionDataSourceSelect;
class IfcMaterialSelect;
class IfcMeasureValue;
class IfcMetricValueSelect;
class IfcObjectReferenceSelect;
class IfcOrientationSelect;
class IfcPointOrVertexPoint;
class IfcPresentationStyleSelect;
class IfcShell;
class IfcSimpleValue;
class IfcSizeSelect;
class IfcSpecularHighlightSelect;
class IfcStructuralActivityAssignmentSelect;
class IfcSurfaceOrFaceSurface;
class IfcSurfaceStyleElementSelect;
class IfcSymbolStyleSelect;
class IfcTextFontSelect;
class IfcTextStyleSelect;
class IfcTrimmingSelect;
class IfcUnit;
class IfcValue;
class IfcVectorOrDirection;
}

#endif // IFC2X3_FWDECL_H
