// IFC SDK : IFC2X3 C++ Early Classes  
// Copyright (C) 2009 CSTB
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// The full license is in Licence.txt file included with this 
// distribution or is available at :
//     http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

#ifndef IFC2X3_EXPRESSDATASET_H
#define IFC2X3_EXPRESSDATASET_H
#include <ifc2x3/ifc2x3DLL.h>

#include "ifc2x3/Ifc2DCompositeCurve.h"
#include "ifc2x3/IfcActionRequest.h"
#include "ifc2x3/IfcActor.h"
#include "ifc2x3/IfcActorRole.h"
#include "ifc2x3/IfcActuatorType.h"
#include "ifc2x3/IfcAddress.h"
#include "ifc2x3/IfcAirTerminalBoxType.h"
#include "ifc2x3/IfcAirTerminalType.h"
#include "ifc2x3/IfcAirToAirHeatRecoveryType.h"
#include "ifc2x3/IfcAlarmType.h"
#include "ifc2x3/IfcAngularDimension.h"
#include "ifc2x3/IfcAnnotation.h"
#include "ifc2x3/IfcAnnotationCurveOccurrence.h"
#include "ifc2x3/IfcAnnotationFillArea.h"
#include "ifc2x3/IfcAnnotationFillAreaOccurrence.h"
#include "ifc2x3/IfcAnnotationOccurrence.h"
#include "ifc2x3/IfcAnnotationSurface.h"
#include "ifc2x3/IfcAnnotationSurfaceOccurrence.h"
#include "ifc2x3/IfcAnnotationSymbolOccurrence.h"
#include "ifc2x3/IfcAnnotationTextOccurrence.h"
#include "ifc2x3/IfcApplication.h"
#include "ifc2x3/IfcAppliedValue.h"
#include "ifc2x3/IfcAppliedValueRelationship.h"
#include "ifc2x3/IfcApproval.h"
#include "ifc2x3/IfcApprovalActorRelationship.h"
#include "ifc2x3/IfcApprovalPropertyRelationship.h"
#include "ifc2x3/IfcApprovalRelationship.h"
#include "ifc2x3/IfcArbitraryClosedProfileDef.h"
#include "ifc2x3/IfcArbitraryOpenProfileDef.h"
#include "ifc2x3/IfcArbitraryProfileDefWithVoids.h"
#include "ifc2x3/IfcAsset.h"
#include "ifc2x3/IfcAsymmetricIShapeProfileDef.h"
#include "ifc2x3/IfcAxis1Placement.h"
#include "ifc2x3/IfcAxis2Placement2D.h"
#include "ifc2x3/IfcAxis2Placement3D.h"
#include "ifc2x3/IfcBSplineCurve.h"
#include "ifc2x3/IfcBeam.h"
#include "ifc2x3/IfcBeamType.h"
#include "ifc2x3/IfcBezierCurve.h"
#include "ifc2x3/IfcBlobTexture.h"
#include "ifc2x3/IfcBlock.h"
#include "ifc2x3/IfcBoilerType.h"
#include "ifc2x3/IfcBooleanClippingResult.h"
#include "ifc2x3/IfcBooleanResult.h"
#include "ifc2x3/IfcBoundaryCondition.h"
#include "ifc2x3/IfcBoundaryEdgeCondition.h"
#include "ifc2x3/IfcBoundaryFaceCondition.h"
#include "ifc2x3/IfcBoundaryNodeCondition.h"
#include "ifc2x3/IfcBoundaryNodeConditionWarping.h"
#include "ifc2x3/IfcBoundedCurve.h"
#include "ifc2x3/IfcBoundedSurface.h"
#include "ifc2x3/IfcBoundingBox.h"
#include "ifc2x3/IfcBoxedHalfSpace.h"
#include "ifc2x3/IfcBuilding.h"
#include "ifc2x3/IfcBuildingElement.h"
#include "ifc2x3/IfcBuildingElementComponent.h"
#include "ifc2x3/IfcBuildingElementPart.h"
#include "ifc2x3/IfcBuildingElementProxy.h"
#include "ifc2x3/IfcBuildingElementProxyType.h"
#include "ifc2x3/IfcBuildingElementType.h"
#include "ifc2x3/IfcBuildingStorey.h"
#include "ifc2x3/IfcCShapeProfileDef.h"
#include "ifc2x3/IfcCableCarrierFittingType.h"
#include "ifc2x3/IfcCableCarrierSegmentType.h"
#include "ifc2x3/IfcCableSegmentType.h"
#include "ifc2x3/IfcCalendarDate.h"
#include "ifc2x3/IfcCartesianPoint.h"
#include "ifc2x3/IfcCartesianTransformationOperator.h"
#include "ifc2x3/IfcCartesianTransformationOperator2D.h"
#include "ifc2x3/IfcCartesianTransformationOperator2DnonUniform.h"
#include "ifc2x3/IfcCartesianTransformationOperator3D.h"
#include "ifc2x3/IfcCartesianTransformationOperator3DnonUniform.h"
#include "ifc2x3/IfcCenterLineProfileDef.h"
#include "ifc2x3/IfcChamferEdgeFeature.h"
#include "ifc2x3/IfcChillerType.h"
#include "ifc2x3/IfcCircle.h"
#include "ifc2x3/IfcCircleHollowProfileDef.h"
#include "ifc2x3/IfcCircleProfileDef.h"
#include "ifc2x3/IfcClassification.h"
#include "ifc2x3/IfcClassificationItem.h"
#include "ifc2x3/IfcClassificationItemRelationship.h"
#include "ifc2x3/IfcClassificationNotation.h"
#include "ifc2x3/IfcClassificationNotationFacet.h"
#include "ifc2x3/IfcClassificationReference.h"
#include "ifc2x3/IfcClosedShell.h"
#include "ifc2x3/IfcCoilType.h"
#include "ifc2x3/IfcColourRgb.h"
#include "ifc2x3/IfcColourSpecification.h"
#include "ifc2x3/IfcColumn.h"
#include "ifc2x3/IfcColumnType.h"
#include "ifc2x3/IfcComplexProperty.h"
#include "ifc2x3/IfcCompositeCurve.h"
#include "ifc2x3/IfcCompositeCurveSegment.h"
#include "ifc2x3/IfcCompositeProfileDef.h"
#include "ifc2x3/IfcCompressorType.h"
#include "ifc2x3/IfcCondenserType.h"
#include "ifc2x3/IfcCondition.h"
#include "ifc2x3/IfcConditionCriterion.h"
#include "ifc2x3/IfcConic.h"
#include "ifc2x3/IfcConnectedFaceSet.h"
#include "ifc2x3/IfcConnectionCurveGeometry.h"
#include "ifc2x3/IfcConnectionGeometry.h"
#include "ifc2x3/IfcConnectionPointEccentricity.h"
#include "ifc2x3/IfcConnectionPointGeometry.h"
#include "ifc2x3/IfcConnectionPortGeometry.h"
#include "ifc2x3/IfcConnectionSurfaceGeometry.h"
#include "ifc2x3/IfcConstraint.h"
#include "ifc2x3/IfcConstraintAggregationRelationship.h"
#include "ifc2x3/IfcConstraintClassificationRelationship.h"
#include "ifc2x3/IfcConstraintRelationship.h"
#include "ifc2x3/IfcConstructionEquipmentResource.h"
#include "ifc2x3/IfcConstructionMaterialResource.h"
#include "ifc2x3/IfcConstructionProductResource.h"
#include "ifc2x3/IfcConstructionResource.h"
#include "ifc2x3/IfcContextDependentUnit.h"
#include "ifc2x3/IfcControl.h"
#include "ifc2x3/IfcControllerType.h"
#include "ifc2x3/IfcConversionBasedUnit.h"
#include "ifc2x3/IfcCooledBeamType.h"
#include "ifc2x3/IfcCoolingTowerType.h"
#include "ifc2x3/IfcCoordinatedUniversalTimeOffset.h"
#include "ifc2x3/IfcCostItem.h"
#include "ifc2x3/IfcCostSchedule.h"
#include "ifc2x3/IfcCostValue.h"
#include "ifc2x3/IfcCovering.h"
#include "ifc2x3/IfcCoveringType.h"
#include "ifc2x3/IfcCraneRailAShapeProfileDef.h"
#include "ifc2x3/IfcCraneRailFShapeProfileDef.h"
#include "ifc2x3/IfcCrewResource.h"
#include "ifc2x3/IfcCsgPrimitive3D.h"
#include "ifc2x3/IfcCsgSolid.h"
#include "ifc2x3/IfcCurrencyRelationship.h"
#include "ifc2x3/IfcCurtainWall.h"
#include "ifc2x3/IfcCurtainWallType.h"
#include "ifc2x3/IfcCurve.h"
#include "ifc2x3/IfcCurveBoundedPlane.h"
#include "ifc2x3/IfcCurveStyle.h"
#include "ifc2x3/IfcCurveStyleFont.h"
#include "ifc2x3/IfcCurveStyleFontAndScaling.h"
#include "ifc2x3/IfcCurveStyleFontPattern.h"
#include "ifc2x3/IfcDamperType.h"
#include "ifc2x3/IfcDateAndTime.h"
#include "ifc2x3/IfcDefinedSymbol.h"
#include "ifc2x3/IfcDerivedProfileDef.h"
#include "ifc2x3/IfcDerivedUnit.h"
#include "ifc2x3/IfcDerivedUnitElement.h"
#include "ifc2x3/IfcDiameterDimension.h"
#include "ifc2x3/IfcDimensionCalloutRelationship.h"
#include "ifc2x3/IfcDimensionCurve.h"
#include "ifc2x3/IfcDimensionCurveDirectedCallout.h"
#include "ifc2x3/IfcDimensionCurveTerminator.h"
#include "ifc2x3/IfcDimensionPair.h"
#include "ifc2x3/IfcDimensionalExponents.h"
#include "ifc2x3/IfcDirection.h"
#include "ifc2x3/IfcDiscreteAccessory.h"
#include "ifc2x3/IfcDiscreteAccessoryType.h"
#include "ifc2x3/IfcDistributionChamberElement.h"
#include "ifc2x3/IfcDistributionChamberElementType.h"
#include "ifc2x3/IfcDistributionControlElement.h"
#include "ifc2x3/IfcDistributionControlElementType.h"
#include "ifc2x3/IfcDistributionElement.h"
#include "ifc2x3/IfcDistributionElementType.h"
#include "ifc2x3/IfcDistributionFlowElement.h"
#include "ifc2x3/IfcDistributionFlowElementType.h"
#include "ifc2x3/IfcDistributionPort.h"
#include "ifc2x3/IfcDocumentElectronicFormat.h"
#include "ifc2x3/IfcDocumentInformation.h"
#include "ifc2x3/IfcDocumentInformationRelationship.h"
#include "ifc2x3/IfcDocumentReference.h"
#include "ifc2x3/IfcDoor.h"
#include "ifc2x3/IfcDoorLiningProperties.h"
#include "ifc2x3/IfcDoorPanelProperties.h"
#include "ifc2x3/IfcDoorStyle.h"
#include "ifc2x3/IfcDraughtingCallout.h"
#include "ifc2x3/IfcDraughtingCalloutRelationship.h"
#include "ifc2x3/IfcDraughtingPreDefinedColour.h"
#include "ifc2x3/IfcDraughtingPreDefinedCurveFont.h"
#include "ifc2x3/IfcDraughtingPreDefinedTextFont.h"
#include "ifc2x3/IfcDuctFittingType.h"
#include "ifc2x3/IfcDuctSegmentType.h"
#include "ifc2x3/IfcDuctSilencerType.h"
#include "ifc2x3/IfcEdge.h"
#include "ifc2x3/IfcEdgeCurve.h"
#include "ifc2x3/IfcEdgeFeature.h"
#include "ifc2x3/IfcEdgeLoop.h"
#include "ifc2x3/IfcElectricApplianceType.h"
#include "ifc2x3/IfcElectricDistributionPoint.h"
#include "ifc2x3/IfcElectricFlowStorageDeviceType.h"
#include "ifc2x3/IfcElectricGeneratorType.h"
#include "ifc2x3/IfcElectricHeaterType.h"
#include "ifc2x3/IfcElectricMotorType.h"
#include "ifc2x3/IfcElectricTimeControlType.h"
#include "ifc2x3/IfcElectricalBaseProperties.h"
#include "ifc2x3/IfcElectricalCircuit.h"
#include "ifc2x3/IfcElectricalElement.h"
#include "ifc2x3/IfcElement.h"
#include "ifc2x3/IfcElementAssembly.h"
#include "ifc2x3/IfcElementComponent.h"
#include "ifc2x3/IfcElementComponentType.h"
#include "ifc2x3/IfcElementQuantity.h"
#include "ifc2x3/IfcElementType.h"
#include "ifc2x3/IfcElementarySurface.h"
#include "ifc2x3/IfcEllipse.h"
#include "ifc2x3/IfcEllipseProfileDef.h"
#include "ifc2x3/IfcEnergyConversionDevice.h"
#include "ifc2x3/IfcEnergyConversionDeviceType.h"
#include "ifc2x3/IfcEnergyProperties.h"
#include "ifc2x3/IfcEnvironmentalImpactValue.h"
#include "ifc2x3/IfcEquipmentElement.h"
#include "ifc2x3/IfcEquipmentStandard.h"
#include "ifc2x3/IfcEvaporativeCoolerType.h"
#include "ifc2x3/IfcEvaporatorType.h"
#include "ifc2x3/IfcExtendedMaterialProperties.h"
#include "ifc2x3/IfcExternalReference.h"
#include "ifc2x3/IfcExternallyDefinedHatchStyle.h"
#include "ifc2x3/IfcExternallyDefinedSurfaceStyle.h"
#include "ifc2x3/IfcExternallyDefinedSymbol.h"
#include "ifc2x3/IfcExternallyDefinedTextFont.h"
#include "ifc2x3/IfcExtrudedAreaSolid.h"
#include "ifc2x3/IfcFace.h"
#include "ifc2x3/IfcFaceBasedSurfaceModel.h"
#include "ifc2x3/IfcFaceBound.h"
#include "ifc2x3/IfcFaceOuterBound.h"
#include "ifc2x3/IfcFaceSurface.h"
#include "ifc2x3/IfcFacetedBrep.h"
#include "ifc2x3/IfcFacetedBrepWithVoids.h"
#include "ifc2x3/IfcFailureConnectionCondition.h"
#include "ifc2x3/IfcFanType.h"
#include "ifc2x3/IfcFastener.h"
#include "ifc2x3/IfcFastenerType.h"
#include "ifc2x3/IfcFeatureElement.h"
#include "ifc2x3/IfcFeatureElementAddition.h"
#include "ifc2x3/IfcFeatureElementSubtraction.h"
#include "ifc2x3/IfcFillAreaStyle.h"
#include "ifc2x3/IfcFillAreaStyleHatching.h"
#include "ifc2x3/IfcFillAreaStyleTileSymbolWithStyle.h"
#include "ifc2x3/IfcFillAreaStyleTiles.h"
#include "ifc2x3/IfcFilterType.h"
#include "ifc2x3/IfcFireSuppressionTerminalType.h"
#include "ifc2x3/IfcFlowController.h"
#include "ifc2x3/IfcFlowControllerType.h"
#include "ifc2x3/IfcFlowFitting.h"
#include "ifc2x3/IfcFlowFittingType.h"
#include "ifc2x3/IfcFlowInstrumentType.h"
#include "ifc2x3/IfcFlowMeterType.h"
#include "ifc2x3/IfcFlowMovingDevice.h"
#include "ifc2x3/IfcFlowMovingDeviceType.h"
#include "ifc2x3/IfcFlowSegment.h"
#include "ifc2x3/IfcFlowSegmentType.h"
#include "ifc2x3/IfcFlowStorageDevice.h"
#include "ifc2x3/IfcFlowStorageDeviceType.h"
#include "ifc2x3/IfcFlowTerminal.h"
#include "ifc2x3/IfcFlowTerminalType.h"
#include "ifc2x3/IfcFlowTreatmentDevice.h"
#include "ifc2x3/IfcFlowTreatmentDeviceType.h"
#include "ifc2x3/IfcFluidFlowProperties.h"
#include "ifc2x3/IfcFooting.h"
#include "ifc2x3/IfcFuelProperties.h"
#include "ifc2x3/IfcFurnishingElement.h"
#include "ifc2x3/IfcFurnishingElementType.h"
#include "ifc2x3/IfcFurnitureStandard.h"
#include "ifc2x3/IfcFurnitureType.h"
#include "ifc2x3/IfcGasTerminalType.h"
#include "ifc2x3/IfcGeneralMaterialProperties.h"
#include "ifc2x3/IfcGeneralProfileProperties.h"
#include "ifc2x3/IfcGeometricCurveSet.h"
#include "ifc2x3/IfcGeometricRepresentationContext.h"
#include "ifc2x3/IfcGeometricRepresentationItem.h"
#include "ifc2x3/IfcGeometricRepresentationSubContext.h"
#include "ifc2x3/IfcGeometricSet.h"
#include "ifc2x3/IfcGrid.h"
#include "ifc2x3/IfcGridAxis.h"
#include "ifc2x3/IfcGridPlacement.h"
#include "ifc2x3/IfcGroup.h"
#include "ifc2x3/IfcHalfSpaceSolid.h"
#include "ifc2x3/IfcHeatExchangerType.h"
#include "ifc2x3/IfcHumidifierType.h"
#include "ifc2x3/IfcHygroscopicMaterialProperties.h"
#include "ifc2x3/IfcIShapeProfileDef.h"
#include "ifc2x3/IfcImageTexture.h"
#include "ifc2x3/IfcInventory.h"
#include "ifc2x3/IfcIrregularTimeSeries.h"
#include "ifc2x3/IfcIrregularTimeSeriesValue.h"
#include "ifc2x3/IfcJunctionBoxType.h"
#include "ifc2x3/IfcLShapeProfileDef.h"
#include "ifc2x3/IfcLaborResource.h"
#include "ifc2x3/IfcLampType.h"
#include "ifc2x3/IfcLibraryInformation.h"
#include "ifc2x3/IfcLibraryReference.h"
#include "ifc2x3/IfcLightDistributionData.h"
#include "ifc2x3/IfcLightFixtureType.h"
#include "ifc2x3/IfcLightIntensityDistribution.h"
#include "ifc2x3/IfcLightSource.h"
#include "ifc2x3/IfcLightSourceAmbient.h"
#include "ifc2x3/IfcLightSourceDirectional.h"
#include "ifc2x3/IfcLightSourceGoniometric.h"
#include "ifc2x3/IfcLightSourcePositional.h"
#include "ifc2x3/IfcLightSourceSpot.h"
#include "ifc2x3/IfcLine.h"
#include "ifc2x3/IfcLinearDimension.h"
#include "ifc2x3/IfcLocalPlacement.h"
#include "ifc2x3/IfcLocalTime.h"
#include "ifc2x3/IfcLoop.h"
#include "ifc2x3/IfcManifoldSolidBrep.h"
#include "ifc2x3/IfcMappedItem.h"
#include "ifc2x3/IfcMaterial.h"
#include "ifc2x3/IfcMaterialClassificationRelationship.h"
#include "ifc2x3/IfcMaterialDefinitionRepresentation.h"
#include "ifc2x3/IfcMaterialLayer.h"
#include "ifc2x3/IfcMaterialLayerSet.h"
#include "ifc2x3/IfcMaterialLayerSetUsage.h"
#include "ifc2x3/IfcMaterialList.h"
#include "ifc2x3/IfcMaterialProperties.h"
#include "ifc2x3/IfcMeasureWithUnit.h"
#include "ifc2x3/IfcMechanicalConcreteMaterialProperties.h"
#include "ifc2x3/IfcMechanicalFastener.h"
#include "ifc2x3/IfcMechanicalFastenerType.h"
#include "ifc2x3/IfcMechanicalMaterialProperties.h"
#include "ifc2x3/IfcMechanicalSteelMaterialProperties.h"
#include "ifc2x3/IfcMember.h"
#include "ifc2x3/IfcMemberType.h"
#include "ifc2x3/IfcMetric.h"
#include "ifc2x3/IfcMonetaryUnit.h"
#include "ifc2x3/IfcMotorConnectionType.h"
#include "ifc2x3/IfcMove.h"
#include "ifc2x3/IfcNamedUnit.h"
#include "ifc2x3/IfcObject.h"
#include "ifc2x3/IfcObjectDefinition.h"
#include "ifc2x3/IfcObjectPlacement.h"
#include "ifc2x3/IfcObjective.h"
#include "ifc2x3/IfcOccupant.h"
#include "ifc2x3/IfcOffsetCurve2D.h"
#include "ifc2x3/IfcOffsetCurve3D.h"
#include "ifc2x3/IfcOneDirectionRepeatFactor.h"
#include "ifc2x3/IfcOpenShell.h"
#include "ifc2x3/IfcOpeningElement.h"
#include "ifc2x3/IfcOpticalMaterialProperties.h"
#include "ifc2x3/IfcOrderAction.h"
#include "ifc2x3/IfcOrganization.h"
#include "ifc2x3/IfcOrganizationRelationship.h"
#include "ifc2x3/IfcOrientedEdge.h"
#include "ifc2x3/IfcOutletType.h"
#include "ifc2x3/IfcOwnerHistory.h"
#include "ifc2x3/IfcParameterizedProfileDef.h"
#include "ifc2x3/IfcPath.h"
#include "ifc2x3/IfcPerformanceHistory.h"
#include "ifc2x3/IfcPermeableCoveringProperties.h"
#include "ifc2x3/IfcPermit.h"
#include "ifc2x3/IfcPerson.h"
#include "ifc2x3/IfcPersonAndOrganization.h"
#include "ifc2x3/IfcPhysicalComplexQuantity.h"
#include "ifc2x3/IfcPhysicalQuantity.h"
#include "ifc2x3/IfcPhysicalSimpleQuantity.h"
#include "ifc2x3/IfcPile.h"
#include "ifc2x3/IfcPipeFittingType.h"
#include "ifc2x3/IfcPipeSegmentType.h"
#include "ifc2x3/IfcPixelTexture.h"
#include "ifc2x3/IfcPlacement.h"
#include "ifc2x3/IfcPlanarBox.h"
#include "ifc2x3/IfcPlanarExtent.h"
#include "ifc2x3/IfcPlane.h"
#include "ifc2x3/IfcPlate.h"
#include "ifc2x3/IfcPlateType.h"
#include "ifc2x3/IfcPoint.h"
#include "ifc2x3/IfcPointOnCurve.h"
#include "ifc2x3/IfcPointOnSurface.h"
#include "ifc2x3/IfcPolyLoop.h"
#include "ifc2x3/IfcPolygonalBoundedHalfSpace.h"
#include "ifc2x3/IfcPolyline.h"
#include "ifc2x3/IfcPort.h"
#include "ifc2x3/IfcPostalAddress.h"
#include "ifc2x3/IfcPreDefinedColour.h"
#include "ifc2x3/IfcPreDefinedCurveFont.h"
#include "ifc2x3/IfcPreDefinedDimensionSymbol.h"
#include "ifc2x3/IfcPreDefinedItem.h"
#include "ifc2x3/IfcPreDefinedPointMarkerSymbol.h"
#include "ifc2x3/IfcPreDefinedSymbol.h"
#include "ifc2x3/IfcPreDefinedTerminatorSymbol.h"
#include "ifc2x3/IfcPreDefinedTextFont.h"
#include "ifc2x3/IfcPresentationLayerAssignment.h"
#include "ifc2x3/IfcPresentationLayerWithStyle.h"
#include "ifc2x3/IfcPresentationStyle.h"
#include "ifc2x3/IfcPresentationStyleAssignment.h"
#include "ifc2x3/IfcProcedure.h"
#include "ifc2x3/IfcProcess.h"
#include "ifc2x3/IfcProduct.h"
#include "ifc2x3/IfcProductDefinitionShape.h"
#include "ifc2x3/IfcProductRepresentation.h"
#include "ifc2x3/IfcProductsOfCombustionProperties.h"
#include "ifc2x3/IfcProfileDef.h"
#include "ifc2x3/IfcProfileProperties.h"
#include "ifc2x3/IfcProject.h"
#include "ifc2x3/IfcProjectOrder.h"
#include "ifc2x3/IfcProjectOrderRecord.h"
#include "ifc2x3/IfcProjectionCurve.h"
#include "ifc2x3/IfcProjectionElement.h"
#include "ifc2x3/IfcProperty.h"
#include "ifc2x3/IfcPropertyBoundedValue.h"
#include "ifc2x3/IfcPropertyConstraintRelationship.h"
#include "ifc2x3/IfcPropertyDefinition.h"
#include "ifc2x3/IfcPropertyDependencyRelationship.h"
#include "ifc2x3/IfcPropertyEnumeratedValue.h"
#include "ifc2x3/IfcPropertyEnumeration.h"
#include "ifc2x3/IfcPropertyListValue.h"
#include "ifc2x3/IfcPropertyReferenceValue.h"
#include "ifc2x3/IfcPropertySet.h"
#include "ifc2x3/IfcPropertySetDefinition.h"
#include "ifc2x3/IfcPropertySingleValue.h"
#include "ifc2x3/IfcPropertyTableValue.h"
#include "ifc2x3/IfcProtectiveDeviceType.h"
#include "ifc2x3/IfcProxy.h"
#include "ifc2x3/IfcPumpType.h"
#include "ifc2x3/IfcQuantityArea.h"
#include "ifc2x3/IfcQuantityCount.h"
#include "ifc2x3/IfcQuantityLength.h"
#include "ifc2x3/IfcQuantityTime.h"
#include "ifc2x3/IfcQuantityVolume.h"
#include "ifc2x3/IfcQuantityWeight.h"
#include "ifc2x3/IfcRadiusDimension.h"
#include "ifc2x3/IfcRailing.h"
#include "ifc2x3/IfcRailingType.h"
#include "ifc2x3/IfcRamp.h"
#include "ifc2x3/IfcRampFlight.h"
#include "ifc2x3/IfcRampFlightType.h"
#include "ifc2x3/IfcRationalBezierCurve.h"
#include "ifc2x3/IfcRectangleHollowProfileDef.h"
#include "ifc2x3/IfcRectangleProfileDef.h"
#include "ifc2x3/IfcRectangularPyramid.h"
#include "ifc2x3/IfcRectangularTrimmedSurface.h"
#include "ifc2x3/IfcReferencesValueDocument.h"
#include "ifc2x3/IfcRegularTimeSeries.h"
#include "ifc2x3/IfcReinforcementBarProperties.h"
#include "ifc2x3/IfcReinforcementDefinitionProperties.h"
#include "ifc2x3/IfcReinforcingBar.h"
#include "ifc2x3/IfcReinforcingElement.h"
#include "ifc2x3/IfcReinforcingMesh.h"
#include "ifc2x3/IfcRelAggregates.h"
#include "ifc2x3/IfcRelAssigns.h"
#include "ifc2x3/IfcRelAssignsTasks.h"
#include "ifc2x3/IfcRelAssignsToActor.h"
#include "ifc2x3/IfcRelAssignsToControl.h"
#include "ifc2x3/IfcRelAssignsToGroup.h"
#include "ifc2x3/IfcRelAssignsToProcess.h"
#include "ifc2x3/IfcRelAssignsToProduct.h"
#include "ifc2x3/IfcRelAssignsToProjectOrder.h"
#include "ifc2x3/IfcRelAssignsToResource.h"
#include "ifc2x3/IfcRelAssociates.h"
#include "ifc2x3/IfcRelAssociatesAppliedValue.h"
#include "ifc2x3/IfcRelAssociatesApproval.h"
#include "ifc2x3/IfcRelAssociatesClassification.h"
#include "ifc2x3/IfcRelAssociatesConstraint.h"
#include "ifc2x3/IfcRelAssociatesDocument.h"
#include "ifc2x3/IfcRelAssociatesLibrary.h"
#include "ifc2x3/IfcRelAssociatesMaterial.h"
#include "ifc2x3/IfcRelAssociatesProfileProperties.h"
#include "ifc2x3/IfcRelConnects.h"
#include "ifc2x3/IfcRelConnectsElements.h"
#include "ifc2x3/IfcRelConnectsPathElements.h"
#include "ifc2x3/IfcRelConnectsPortToElement.h"
#include "ifc2x3/IfcRelConnectsPorts.h"
#include "ifc2x3/IfcRelConnectsStructuralActivity.h"
#include "ifc2x3/IfcRelConnectsStructuralElement.h"
#include "ifc2x3/IfcRelConnectsStructuralMember.h"
#include "ifc2x3/IfcRelConnectsWithEccentricity.h"
#include "ifc2x3/IfcRelConnectsWithRealizingElements.h"
#include "ifc2x3/IfcRelContainedInSpatialStructure.h"
#include "ifc2x3/IfcRelCoversBldgElements.h"
#include "ifc2x3/IfcRelCoversSpaces.h"
#include "ifc2x3/IfcRelDecomposes.h"
#include "ifc2x3/IfcRelDefines.h"
#include "ifc2x3/IfcRelDefinesByProperties.h"
#include "ifc2x3/IfcRelDefinesByType.h"
#include "ifc2x3/IfcRelFillsElement.h"
#include "ifc2x3/IfcRelFlowControlElements.h"
#include "ifc2x3/IfcRelInteractionRequirements.h"
#include "ifc2x3/IfcRelNests.h"
#include "ifc2x3/IfcRelOccupiesSpaces.h"
#include "ifc2x3/IfcRelOverridesProperties.h"
#include "ifc2x3/IfcRelProjectsElement.h"
#include "ifc2x3/IfcRelReferencedInSpatialStructure.h"
#include "ifc2x3/IfcRelSchedulesCostItems.h"
#include "ifc2x3/IfcRelSequence.h"
#include "ifc2x3/IfcRelServicesBuildings.h"
#include "ifc2x3/IfcRelSpaceBoundary.h"
#include "ifc2x3/IfcRelVoidsElement.h"
#include "ifc2x3/IfcRelationship.h"
#include "ifc2x3/IfcRelaxation.h"
#include "ifc2x3/IfcRepresentation.h"
#include "ifc2x3/IfcRepresentationContext.h"
#include "ifc2x3/IfcRepresentationItem.h"
#include "ifc2x3/IfcRepresentationMap.h"
#include "ifc2x3/IfcResource.h"
#include "ifc2x3/IfcRevolvedAreaSolid.h"
#include "ifc2x3/IfcRibPlateProfileProperties.h"
#include "ifc2x3/IfcRightCircularCone.h"
#include "ifc2x3/IfcRightCircularCylinder.h"
#include "ifc2x3/IfcRoof.h"
#include "ifc2x3/IfcRoot.h"
#include "ifc2x3/IfcRoundedEdgeFeature.h"
#include "ifc2x3/IfcRoundedRectangleProfileDef.h"
#include "ifc2x3/IfcSIUnit.h"
#include "ifc2x3/IfcSanitaryTerminalType.h"
#include "ifc2x3/IfcScheduleTimeControl.h"
#include "ifc2x3/IfcSectionProperties.h"
#include "ifc2x3/IfcSectionReinforcementProperties.h"
#include "ifc2x3/IfcSectionedSpine.h"
#include "ifc2x3/IfcSensorType.h"
#include "ifc2x3/IfcServiceLife.h"
#include "ifc2x3/IfcServiceLifeFactor.h"
#include "ifc2x3/IfcShapeAspect.h"
#include "ifc2x3/IfcShapeModel.h"
#include "ifc2x3/IfcShapeRepresentation.h"
#include "ifc2x3/IfcShellBasedSurfaceModel.h"
#include "ifc2x3/IfcSimpleProperty.h"
#include "ifc2x3/IfcSite.h"
#include "ifc2x3/IfcSlab.h"
#include "ifc2x3/IfcSlabType.h"
#include "ifc2x3/IfcSlippageConnectionCondition.h"
#include "ifc2x3/IfcSolidModel.h"
#include "ifc2x3/IfcSoundProperties.h"
#include "ifc2x3/IfcSoundValue.h"
#include "ifc2x3/IfcSpace.h"
#include "ifc2x3/IfcSpaceHeaterType.h"
#include "ifc2x3/IfcSpaceProgram.h"
#include "ifc2x3/IfcSpaceThermalLoadProperties.h"
#include "ifc2x3/IfcSpaceType.h"
#include "ifc2x3/IfcSpatialStructureElement.h"
#include "ifc2x3/IfcSpatialStructureElementType.h"
#include "ifc2x3/IfcSphere.h"
#include "ifc2x3/IfcStackTerminalType.h"
#include "ifc2x3/IfcStair.h"
#include "ifc2x3/IfcStairFlight.h"
#include "ifc2x3/IfcStairFlightType.h"
#include "ifc2x3/IfcStructuralAction.h"
#include "ifc2x3/IfcStructuralActivity.h"
#include "ifc2x3/IfcStructuralAnalysisModel.h"
#include "ifc2x3/IfcStructuralConnection.h"
#include "ifc2x3/IfcStructuralConnectionCondition.h"
#include "ifc2x3/IfcStructuralCurveConnection.h"
#include "ifc2x3/IfcStructuralCurveMember.h"
#include "ifc2x3/IfcStructuralCurveMemberVarying.h"
#include "ifc2x3/IfcStructuralItem.h"
#include "ifc2x3/IfcStructuralLinearAction.h"
#include "ifc2x3/IfcStructuralLinearActionVarying.h"
#include "ifc2x3/IfcStructuralLoad.h"
#include "ifc2x3/IfcStructuralLoadGroup.h"
#include "ifc2x3/IfcStructuralLoadLinearForce.h"
#include "ifc2x3/IfcStructuralLoadPlanarForce.h"
#include "ifc2x3/IfcStructuralLoadSingleDisplacement.h"
#include "ifc2x3/IfcStructuralLoadSingleDisplacementDistortion.h"
#include "ifc2x3/IfcStructuralLoadSingleForce.h"
#include "ifc2x3/IfcStructuralLoadSingleForceWarping.h"
#include "ifc2x3/IfcStructuralLoadStatic.h"
#include "ifc2x3/IfcStructuralLoadTemperature.h"
#include "ifc2x3/IfcStructuralMember.h"
#include "ifc2x3/IfcStructuralPlanarAction.h"
#include "ifc2x3/IfcStructuralPlanarActionVarying.h"
#include "ifc2x3/IfcStructuralPointAction.h"
#include "ifc2x3/IfcStructuralPointConnection.h"
#include "ifc2x3/IfcStructuralPointReaction.h"
#include "ifc2x3/IfcStructuralProfileProperties.h"
#include "ifc2x3/IfcStructuralReaction.h"
#include "ifc2x3/IfcStructuralResultGroup.h"
#include "ifc2x3/IfcStructuralSteelProfileProperties.h"
#include "ifc2x3/IfcStructuralSurfaceConnection.h"
#include "ifc2x3/IfcStructuralSurfaceMember.h"
#include "ifc2x3/IfcStructuralSurfaceMemberVarying.h"
#include "ifc2x3/IfcStructuredDimensionCallout.h"
#include "ifc2x3/IfcStyleModel.h"
#include "ifc2x3/IfcStyledItem.h"
#include "ifc2x3/IfcStyledRepresentation.h"
#include "ifc2x3/IfcSubContractResource.h"
#include "ifc2x3/IfcSubedge.h"
#include "ifc2x3/IfcSurface.h"
#include "ifc2x3/IfcSurfaceCurveSweptAreaSolid.h"
#include "ifc2x3/IfcSurfaceOfLinearExtrusion.h"
#include "ifc2x3/IfcSurfaceOfRevolution.h"
#include "ifc2x3/IfcSurfaceStyle.h"
#include "ifc2x3/IfcSurfaceStyleLighting.h"
#include "ifc2x3/IfcSurfaceStyleRefraction.h"
#include "ifc2x3/IfcSurfaceStyleRendering.h"
#include "ifc2x3/IfcSurfaceStyleShading.h"
#include "ifc2x3/IfcSurfaceStyleWithTextures.h"
#include "ifc2x3/IfcSurfaceTexture.h"
#include "ifc2x3/IfcSweptAreaSolid.h"
#include "ifc2x3/IfcSweptDiskSolid.h"
#include "ifc2x3/IfcSweptSurface.h"
#include "ifc2x3/IfcSwitchingDeviceType.h"
#include "ifc2x3/IfcSymbolStyle.h"
#include "ifc2x3/IfcSystem.h"
#include "ifc2x3/IfcSystemFurnitureElementType.h"
#include "ifc2x3/IfcTShapeProfileDef.h"
#include "ifc2x3/IfcTable.h"
#include "ifc2x3/IfcTableRow.h"
#include "ifc2x3/IfcTankType.h"
#include "ifc2x3/IfcTask.h"
#include "ifc2x3/IfcTelecomAddress.h"
#include "ifc2x3/IfcTendon.h"
#include "ifc2x3/IfcTendonAnchor.h"
#include "ifc2x3/IfcTerminatorSymbol.h"
#include "ifc2x3/IfcTextLiteral.h"
#include "ifc2x3/IfcTextLiteralWithExtent.h"
#include "ifc2x3/IfcTextStyle.h"
#include "ifc2x3/IfcTextStyleFontModel.h"
#include "ifc2x3/IfcTextStyleForDefinedFont.h"
#include "ifc2x3/IfcTextStyleTextModel.h"
#include "ifc2x3/IfcTextStyleWithBoxCharacteristics.h"
#include "ifc2x3/IfcTextureCoordinate.h"
#include "ifc2x3/IfcTextureCoordinateGenerator.h"
#include "ifc2x3/IfcTextureMap.h"
#include "ifc2x3/IfcTextureVertex.h"
#include "ifc2x3/IfcThermalMaterialProperties.h"
#include "ifc2x3/IfcTimeSeries.h"
#include "ifc2x3/IfcTimeSeriesReferenceRelationship.h"
#include "ifc2x3/IfcTimeSeriesSchedule.h"
#include "ifc2x3/IfcTimeSeriesValue.h"
#include "ifc2x3/IfcTopologicalRepresentationItem.h"
#include "ifc2x3/IfcTopologyRepresentation.h"
#include "ifc2x3/IfcTransformerType.h"
#include "ifc2x3/IfcTransportElement.h"
#include "ifc2x3/IfcTransportElementType.h"
#include "ifc2x3/IfcTrapeziumProfileDef.h"
#include "ifc2x3/IfcTrimmedCurve.h"
#include "ifc2x3/IfcTubeBundleType.h"
#include "ifc2x3/IfcTwoDirectionRepeatFactor.h"
#include "ifc2x3/IfcTypeObject.h"
#include "ifc2x3/IfcTypeProduct.h"
#include "ifc2x3/IfcUShapeProfileDef.h"
#include "ifc2x3/IfcUnitAssignment.h"
#include "ifc2x3/IfcUnitaryEquipmentType.h"
#include "ifc2x3/IfcValveType.h"
#include "ifc2x3/IfcVector.h"
#include "ifc2x3/IfcVertex.h"
#include "ifc2x3/IfcVertexBasedTextureMap.h"
#include "ifc2x3/IfcVertexLoop.h"
#include "ifc2x3/IfcVertexPoint.h"
#include "ifc2x3/IfcVibrationIsolatorType.h"
#include "ifc2x3/IfcVirtualElement.h"
#include "ifc2x3/IfcVirtualGridIntersection.h"
#include "ifc2x3/IfcWall.h"
#include "ifc2x3/IfcWallStandardCase.h"
#include "ifc2x3/IfcWallType.h"
#include "ifc2x3/IfcWasteTerminalType.h"
#include "ifc2x3/IfcWaterProperties.h"
#include "ifc2x3/IfcWindow.h"
#include "ifc2x3/IfcWindowLiningProperties.h"
#include "ifc2x3/IfcWindowPanelProperties.h"
#include "ifc2x3/IfcWindowStyle.h"
#include "ifc2x3/IfcWorkControl.h"
#include "ifc2x3/IfcWorkPlan.h"
#include "ifc2x3/IfcWorkSchedule.h"
#include "ifc2x3/IfcZShapeProfileDef.h"
#include "ifc2x3/IfcZone.h"
#include <Step/BaseEntity.h>
#include <Step/BaseExpressDataSet.h>
#include <Step/RefLinkedList.h>
#include <Step/Referenced.h>

namespace ifc2x3 {

    class CopyOp;

    /**
     * The ExpressDataSet generated for this schema.
     * 
     * It contains all the methods necessary to get,remove,create or clone entities.
     * It also contains methods to get a list of all entities of a certain type (including sub-types).
     * 
     */
    class IFC2X3_DLL_DEF ExpressDataSet : public Step::BaseExpressDataSet {
    public:
        /**
         */
        ExpressDataSet();
        virtual ~ExpressDataSet();
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        Ifc2DCompositeCurve *getIfc2DCompositeCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfc2DCompositeCurve(Ifc2DCompositeCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< Ifc2DCompositeCurve > createIfc2DCompositeCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        Ifc2DCompositeCurve *cloneIfc2DCompositeCurve(const Ifc2DCompositeCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcActionRequest *getIfcActionRequest(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcActionRequest(IfcActionRequest *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcActionRequest > createIfcActionRequest(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcActionRequest *cloneIfcActionRequest(const IfcActionRequest &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcActor *getIfcActor(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcActor(IfcActor *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcActor > createIfcActor(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcActor *cloneIfcActor(const IfcActor &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcActorRole *getIfcActorRole(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcActorRole(IfcActorRole *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcActorRole > createIfcActorRole(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcActorRole *cloneIfcActorRole(const IfcActorRole &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcActuatorType *getIfcActuatorType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcActuatorType(IfcActuatorType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcActuatorType > createIfcActuatorType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcActuatorType *cloneIfcActuatorType(const IfcActuatorType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAirTerminalBoxType *getIfcAirTerminalBoxType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAirTerminalBoxType(IfcAirTerminalBoxType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAirTerminalBoxType > createIfcAirTerminalBoxType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAirTerminalBoxType *cloneIfcAirTerminalBoxType(const IfcAirTerminalBoxType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAirTerminalType *getIfcAirTerminalType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAirTerminalType(IfcAirTerminalType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAirTerminalType > createIfcAirTerminalType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAirTerminalType *cloneIfcAirTerminalType(const IfcAirTerminalType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAirToAirHeatRecoveryType *getIfcAirToAirHeatRecoveryType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAirToAirHeatRecoveryType(IfcAirToAirHeatRecoveryType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAirToAirHeatRecoveryType > createIfcAirToAirHeatRecoveryType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAirToAirHeatRecoveryType *cloneIfcAirToAirHeatRecoveryType(const IfcAirToAirHeatRecoveryType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAlarmType *getIfcAlarmType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAlarmType(IfcAlarmType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAlarmType > createIfcAlarmType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAlarmType *cloneIfcAlarmType(const IfcAlarmType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAngularDimension *getIfcAngularDimension(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAngularDimension(IfcAngularDimension *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAngularDimension > createIfcAngularDimension(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAngularDimension *cloneIfcAngularDimension(const IfcAngularDimension &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotation *getIfcAnnotation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotation(IfcAnnotation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotation > createIfcAnnotation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotation *cloneIfcAnnotation(const IfcAnnotation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotationCurveOccurrence *getIfcAnnotationCurveOccurrence(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotationCurveOccurrence(IfcAnnotationCurveOccurrence *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotationCurveOccurrence > createIfcAnnotationCurveOccurrence(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotationCurveOccurrence *cloneIfcAnnotationCurveOccurrence(const IfcAnnotationCurveOccurrence &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotationFillArea *getIfcAnnotationFillArea(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotationFillArea(IfcAnnotationFillArea *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotationFillArea > createIfcAnnotationFillArea(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotationFillArea *cloneIfcAnnotationFillArea(const IfcAnnotationFillArea &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotationFillAreaOccurrence *getIfcAnnotationFillAreaOccurrence(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotationFillAreaOccurrence(IfcAnnotationFillAreaOccurrence *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotationFillAreaOccurrence > createIfcAnnotationFillAreaOccurrence(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotationFillAreaOccurrence *cloneIfcAnnotationFillAreaOccurrence(const IfcAnnotationFillAreaOccurrence &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotationSurface *getIfcAnnotationSurface(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotationSurface(IfcAnnotationSurface *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotationSurface > createIfcAnnotationSurface(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotationSurface *cloneIfcAnnotationSurface(const IfcAnnotationSurface &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotationSurfaceOccurrence *getIfcAnnotationSurfaceOccurrence(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotationSurfaceOccurrence(IfcAnnotationSurfaceOccurrence *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotationSurfaceOccurrence > createIfcAnnotationSurfaceOccurrence(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotationSurfaceOccurrence *cloneIfcAnnotationSurfaceOccurrence(const IfcAnnotationSurfaceOccurrence &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotationSymbolOccurrence *getIfcAnnotationSymbolOccurrence(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotationSymbolOccurrence(IfcAnnotationSymbolOccurrence *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotationSymbolOccurrence > createIfcAnnotationSymbolOccurrence(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotationSymbolOccurrence *cloneIfcAnnotationSymbolOccurrence(const IfcAnnotationSymbolOccurrence &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAnnotationTextOccurrence *getIfcAnnotationTextOccurrence(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAnnotationTextOccurrence(IfcAnnotationTextOccurrence *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAnnotationTextOccurrence > createIfcAnnotationTextOccurrence(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAnnotationTextOccurrence *cloneIfcAnnotationTextOccurrence(const IfcAnnotationTextOccurrence &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcApplication *getIfcApplication(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcApplication(IfcApplication *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcApplication > createIfcApplication(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcApplication *cloneIfcApplication(const IfcApplication &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAppliedValueRelationship *getIfcAppliedValueRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAppliedValueRelationship(IfcAppliedValueRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAppliedValueRelationship > createIfcAppliedValueRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAppliedValueRelationship *cloneIfcAppliedValueRelationship(const IfcAppliedValueRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcApproval *getIfcApproval(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcApproval(IfcApproval *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcApproval > createIfcApproval(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcApproval *cloneIfcApproval(const IfcApproval &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcApprovalActorRelationship *getIfcApprovalActorRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcApprovalActorRelationship(IfcApprovalActorRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcApprovalActorRelationship > createIfcApprovalActorRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcApprovalActorRelationship *cloneIfcApprovalActorRelationship(const IfcApprovalActorRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcApprovalPropertyRelationship *getIfcApprovalPropertyRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcApprovalPropertyRelationship(IfcApprovalPropertyRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcApprovalPropertyRelationship > createIfcApprovalPropertyRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcApprovalPropertyRelationship *cloneIfcApprovalPropertyRelationship(const IfcApprovalPropertyRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcApprovalRelationship *getIfcApprovalRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcApprovalRelationship(IfcApprovalRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcApprovalRelationship > createIfcApprovalRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcApprovalRelationship *cloneIfcApprovalRelationship(const IfcApprovalRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcArbitraryClosedProfileDef *getIfcArbitraryClosedProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcArbitraryClosedProfileDef(IfcArbitraryClosedProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcArbitraryClosedProfileDef > createIfcArbitraryClosedProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcArbitraryClosedProfileDef *cloneIfcArbitraryClosedProfileDef(const IfcArbitraryClosedProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcArbitraryOpenProfileDef *getIfcArbitraryOpenProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcArbitraryOpenProfileDef(IfcArbitraryOpenProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcArbitraryOpenProfileDef > createIfcArbitraryOpenProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcArbitraryOpenProfileDef *cloneIfcArbitraryOpenProfileDef(const IfcArbitraryOpenProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcArbitraryProfileDefWithVoids *getIfcArbitraryProfileDefWithVoids(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcArbitraryProfileDefWithVoids(IfcArbitraryProfileDefWithVoids *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcArbitraryProfileDefWithVoids > createIfcArbitraryProfileDefWithVoids(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcArbitraryProfileDefWithVoids *cloneIfcArbitraryProfileDefWithVoids(const IfcArbitraryProfileDefWithVoids &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAsset *getIfcAsset(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAsset(IfcAsset *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAsset > createIfcAsset(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAsset *cloneIfcAsset(const IfcAsset &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAsymmetricIShapeProfileDef *getIfcAsymmetricIShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAsymmetricIShapeProfileDef(IfcAsymmetricIShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAsymmetricIShapeProfileDef > createIfcAsymmetricIShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAsymmetricIShapeProfileDef *cloneIfcAsymmetricIShapeProfileDef(const IfcAsymmetricIShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAxis1Placement *getIfcAxis1Placement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAxis1Placement(IfcAxis1Placement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAxis1Placement > createIfcAxis1Placement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAxis1Placement *cloneIfcAxis1Placement(const IfcAxis1Placement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAxis2Placement2D *getIfcAxis2Placement2D(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAxis2Placement2D(IfcAxis2Placement2D *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAxis2Placement2D > createIfcAxis2Placement2D(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAxis2Placement2D *cloneIfcAxis2Placement2D(const IfcAxis2Placement2D &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcAxis2Placement3D *getIfcAxis2Placement3D(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcAxis2Placement3D(IfcAxis2Placement3D *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcAxis2Placement3D > createIfcAxis2Placement3D(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcAxis2Placement3D *cloneIfcAxis2Placement3D(const IfcAxis2Placement3D &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBeam *getIfcBeam(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBeam(IfcBeam *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBeam > createIfcBeam(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBeam *cloneIfcBeam(const IfcBeam &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBeamType *getIfcBeamType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBeamType(IfcBeamType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBeamType > createIfcBeamType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBeamType *cloneIfcBeamType(const IfcBeamType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBezierCurve *getIfcBezierCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBezierCurve(IfcBezierCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBezierCurve > createIfcBezierCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBezierCurve *cloneIfcBezierCurve(const IfcBezierCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBlobTexture *getIfcBlobTexture(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBlobTexture(IfcBlobTexture *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBlobTexture > createIfcBlobTexture(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBlobTexture *cloneIfcBlobTexture(const IfcBlobTexture &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBlock *getIfcBlock(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBlock(IfcBlock *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBlock > createIfcBlock(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBlock *cloneIfcBlock(const IfcBlock &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoilerType *getIfcBoilerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoilerType(IfcBoilerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoilerType > createIfcBoilerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoilerType *cloneIfcBoilerType(const IfcBoilerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBooleanClippingResult *getIfcBooleanClippingResult(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBooleanClippingResult(IfcBooleanClippingResult *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBooleanClippingResult > createIfcBooleanClippingResult(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBooleanClippingResult *cloneIfcBooleanClippingResult(const IfcBooleanClippingResult &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBooleanResult *getIfcBooleanResult(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBooleanResult(IfcBooleanResult *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBooleanResult > createIfcBooleanResult(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBooleanResult *cloneIfcBooleanResult(const IfcBooleanResult &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoundaryEdgeCondition *getIfcBoundaryEdgeCondition(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoundaryEdgeCondition(IfcBoundaryEdgeCondition *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoundaryEdgeCondition > createIfcBoundaryEdgeCondition(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoundaryEdgeCondition *cloneIfcBoundaryEdgeCondition(const IfcBoundaryEdgeCondition &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoundaryFaceCondition *getIfcBoundaryFaceCondition(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoundaryFaceCondition(IfcBoundaryFaceCondition *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoundaryFaceCondition > createIfcBoundaryFaceCondition(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoundaryFaceCondition *cloneIfcBoundaryFaceCondition(const IfcBoundaryFaceCondition &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoundaryNodeCondition *getIfcBoundaryNodeCondition(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoundaryNodeCondition(IfcBoundaryNodeCondition *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoundaryNodeCondition > createIfcBoundaryNodeCondition(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoundaryNodeCondition *cloneIfcBoundaryNodeCondition(const IfcBoundaryNodeCondition &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoundaryNodeConditionWarping *getIfcBoundaryNodeConditionWarping(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoundaryNodeConditionWarping(IfcBoundaryNodeConditionWarping *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoundaryNodeConditionWarping > createIfcBoundaryNodeConditionWarping(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoundaryNodeConditionWarping *cloneIfcBoundaryNodeConditionWarping(const IfcBoundaryNodeConditionWarping &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoundedSurface *getIfcBoundedSurface(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoundedSurface(IfcBoundedSurface *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoundedSurface > createIfcBoundedSurface(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoundedSurface *cloneIfcBoundedSurface(const IfcBoundedSurface &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoundingBox *getIfcBoundingBox(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoundingBox(IfcBoundingBox *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoundingBox > createIfcBoundingBox(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoundingBox *cloneIfcBoundingBox(const IfcBoundingBox &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBoxedHalfSpace *getIfcBoxedHalfSpace(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBoxedHalfSpace(IfcBoxedHalfSpace *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBoxedHalfSpace > createIfcBoxedHalfSpace(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBoxedHalfSpace *cloneIfcBoxedHalfSpace(const IfcBoxedHalfSpace &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBuilding *getIfcBuilding(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBuilding(IfcBuilding *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBuilding > createIfcBuilding(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBuilding *cloneIfcBuilding(const IfcBuilding &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBuildingElementPart *getIfcBuildingElementPart(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBuildingElementPart(IfcBuildingElementPart *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBuildingElementPart > createIfcBuildingElementPart(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBuildingElementPart *cloneIfcBuildingElementPart(const IfcBuildingElementPart &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBuildingElementProxy *getIfcBuildingElementProxy(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBuildingElementProxy(IfcBuildingElementProxy *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBuildingElementProxy > createIfcBuildingElementProxy(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBuildingElementProxy *cloneIfcBuildingElementProxy(const IfcBuildingElementProxy &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBuildingElementProxyType *getIfcBuildingElementProxyType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBuildingElementProxyType(IfcBuildingElementProxyType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBuildingElementProxyType > createIfcBuildingElementProxyType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBuildingElementProxyType *cloneIfcBuildingElementProxyType(const IfcBuildingElementProxyType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcBuildingStorey *getIfcBuildingStorey(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcBuildingStorey(IfcBuildingStorey *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcBuildingStorey > createIfcBuildingStorey(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcBuildingStorey *cloneIfcBuildingStorey(const IfcBuildingStorey &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCShapeProfileDef *getIfcCShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCShapeProfileDef(IfcCShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCShapeProfileDef > createIfcCShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCShapeProfileDef *cloneIfcCShapeProfileDef(const IfcCShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCableCarrierFittingType *getIfcCableCarrierFittingType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCableCarrierFittingType(IfcCableCarrierFittingType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCableCarrierFittingType > createIfcCableCarrierFittingType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCableCarrierFittingType *cloneIfcCableCarrierFittingType(const IfcCableCarrierFittingType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCableCarrierSegmentType *getIfcCableCarrierSegmentType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCableCarrierSegmentType(IfcCableCarrierSegmentType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCableCarrierSegmentType > createIfcCableCarrierSegmentType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCableCarrierSegmentType *cloneIfcCableCarrierSegmentType(const IfcCableCarrierSegmentType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCableSegmentType *getIfcCableSegmentType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCableSegmentType(IfcCableSegmentType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCableSegmentType > createIfcCableSegmentType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCableSegmentType *cloneIfcCableSegmentType(const IfcCableSegmentType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCalendarDate *getIfcCalendarDate(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCalendarDate(IfcCalendarDate *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCalendarDate > createIfcCalendarDate(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCalendarDate *cloneIfcCalendarDate(const IfcCalendarDate &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCartesianPoint *getIfcCartesianPoint(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCartesianPoint(IfcCartesianPoint *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCartesianPoint > createIfcCartesianPoint(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCartesianPoint *cloneIfcCartesianPoint(const IfcCartesianPoint &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCartesianTransformationOperator2D *getIfcCartesianTransformationOperator2D(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCartesianTransformationOperator2D(IfcCartesianTransformationOperator2D *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCartesianTransformationOperator2D > createIfcCartesianTransformationOperator2D(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCartesianTransformationOperator2D *cloneIfcCartesianTransformationOperator2D(const IfcCartesianTransformationOperator2D &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCartesianTransformationOperator2DnonUniform *getIfcCartesianTransformationOperator2DnonUniform(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCartesianTransformationOperator2DnonUniform(IfcCartesianTransformationOperator2DnonUniform *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCartesianTransformationOperator2DnonUniform > createIfcCartesianTransformationOperator2DnonUniform(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCartesianTransformationOperator2DnonUniform *cloneIfcCartesianTransformationOperator2DnonUniform(const IfcCartesianTransformationOperator2DnonUniform &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCartesianTransformationOperator3D *getIfcCartesianTransformationOperator3D(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCartesianTransformationOperator3D(IfcCartesianTransformationOperator3D *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCartesianTransformationOperator3D > createIfcCartesianTransformationOperator3D(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCartesianTransformationOperator3D *cloneIfcCartesianTransformationOperator3D(const IfcCartesianTransformationOperator3D &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCartesianTransformationOperator3DnonUniform *getIfcCartesianTransformationOperator3DnonUniform(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCartesianTransformationOperator3DnonUniform(IfcCartesianTransformationOperator3DnonUniform *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCartesianTransformationOperator3DnonUniform > createIfcCartesianTransformationOperator3DnonUniform(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCartesianTransformationOperator3DnonUniform *cloneIfcCartesianTransformationOperator3DnonUniform(const IfcCartesianTransformationOperator3DnonUniform &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCenterLineProfileDef *getIfcCenterLineProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCenterLineProfileDef(IfcCenterLineProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCenterLineProfileDef > createIfcCenterLineProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCenterLineProfileDef *cloneIfcCenterLineProfileDef(const IfcCenterLineProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcChamferEdgeFeature *getIfcChamferEdgeFeature(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcChamferEdgeFeature(IfcChamferEdgeFeature *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcChamferEdgeFeature > createIfcChamferEdgeFeature(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcChamferEdgeFeature *cloneIfcChamferEdgeFeature(const IfcChamferEdgeFeature &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcChillerType *getIfcChillerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcChillerType(IfcChillerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcChillerType > createIfcChillerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcChillerType *cloneIfcChillerType(const IfcChillerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCircle *getIfcCircle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCircle(IfcCircle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCircle > createIfcCircle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCircle *cloneIfcCircle(const IfcCircle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCircleHollowProfileDef *getIfcCircleHollowProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCircleHollowProfileDef(IfcCircleHollowProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCircleHollowProfileDef > createIfcCircleHollowProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCircleHollowProfileDef *cloneIfcCircleHollowProfileDef(const IfcCircleHollowProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCircleProfileDef *getIfcCircleProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCircleProfileDef(IfcCircleProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCircleProfileDef > createIfcCircleProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCircleProfileDef *cloneIfcCircleProfileDef(const IfcCircleProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcClassification *getIfcClassification(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcClassification(IfcClassification *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcClassification > createIfcClassification(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcClassification *cloneIfcClassification(const IfcClassification &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcClassificationItem *getIfcClassificationItem(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcClassificationItem(IfcClassificationItem *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcClassificationItem > createIfcClassificationItem(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcClassificationItem *cloneIfcClassificationItem(const IfcClassificationItem &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcClassificationItemRelationship *getIfcClassificationItemRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcClassificationItemRelationship(IfcClassificationItemRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcClassificationItemRelationship > createIfcClassificationItemRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcClassificationItemRelationship *cloneIfcClassificationItemRelationship(const IfcClassificationItemRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcClassificationNotation *getIfcClassificationNotation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcClassificationNotation(IfcClassificationNotation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcClassificationNotation > createIfcClassificationNotation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcClassificationNotation *cloneIfcClassificationNotation(const IfcClassificationNotation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcClassificationNotationFacet *getIfcClassificationNotationFacet(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcClassificationNotationFacet(IfcClassificationNotationFacet *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcClassificationNotationFacet > createIfcClassificationNotationFacet(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcClassificationNotationFacet *cloneIfcClassificationNotationFacet(const IfcClassificationNotationFacet &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcClassificationReference *getIfcClassificationReference(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcClassificationReference(IfcClassificationReference *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcClassificationReference > createIfcClassificationReference(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcClassificationReference *cloneIfcClassificationReference(const IfcClassificationReference &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcClosedShell *getIfcClosedShell(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcClosedShell(IfcClosedShell *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcClosedShell > createIfcClosedShell(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcClosedShell *cloneIfcClosedShell(const IfcClosedShell &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCoilType *getIfcCoilType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCoilType(IfcCoilType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCoilType > createIfcCoilType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCoilType *cloneIfcCoilType(const IfcCoilType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcColourRgb *getIfcColourRgb(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcColourRgb(IfcColourRgb *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcColourRgb > createIfcColourRgb(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcColourRgb *cloneIfcColourRgb(const IfcColourRgb &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcColumn *getIfcColumn(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcColumn(IfcColumn *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcColumn > createIfcColumn(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcColumn *cloneIfcColumn(const IfcColumn &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcColumnType *getIfcColumnType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcColumnType(IfcColumnType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcColumnType > createIfcColumnType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcColumnType *cloneIfcColumnType(const IfcColumnType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcComplexProperty *getIfcComplexProperty(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcComplexProperty(IfcComplexProperty *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcComplexProperty > createIfcComplexProperty(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcComplexProperty *cloneIfcComplexProperty(const IfcComplexProperty &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCompositeCurve *getIfcCompositeCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCompositeCurve(IfcCompositeCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCompositeCurve > createIfcCompositeCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCompositeCurve *cloneIfcCompositeCurve(const IfcCompositeCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCompositeCurveSegment *getIfcCompositeCurveSegment(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCompositeCurveSegment(IfcCompositeCurveSegment *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCompositeCurveSegment > createIfcCompositeCurveSegment(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCompositeCurveSegment *cloneIfcCompositeCurveSegment(const IfcCompositeCurveSegment &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCompositeProfileDef *getIfcCompositeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCompositeProfileDef(IfcCompositeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCompositeProfileDef > createIfcCompositeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCompositeProfileDef *cloneIfcCompositeProfileDef(const IfcCompositeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCompressorType *getIfcCompressorType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCompressorType(IfcCompressorType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCompressorType > createIfcCompressorType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCompressorType *cloneIfcCompressorType(const IfcCompressorType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCondenserType *getIfcCondenserType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCondenserType(IfcCondenserType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCondenserType > createIfcCondenserType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCondenserType *cloneIfcCondenserType(const IfcCondenserType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCondition *getIfcCondition(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCondition(IfcCondition *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCondition > createIfcCondition(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCondition *cloneIfcCondition(const IfcCondition &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConditionCriterion *getIfcConditionCriterion(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConditionCriterion(IfcConditionCriterion *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConditionCriterion > createIfcConditionCriterion(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConditionCriterion *cloneIfcConditionCriterion(const IfcConditionCriterion &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConnectedFaceSet *getIfcConnectedFaceSet(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConnectedFaceSet(IfcConnectedFaceSet *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConnectedFaceSet > createIfcConnectedFaceSet(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConnectedFaceSet *cloneIfcConnectedFaceSet(const IfcConnectedFaceSet &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConnectionCurveGeometry *getIfcConnectionCurveGeometry(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConnectionCurveGeometry(IfcConnectionCurveGeometry *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConnectionCurveGeometry > createIfcConnectionCurveGeometry(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConnectionCurveGeometry *cloneIfcConnectionCurveGeometry(const IfcConnectionCurveGeometry &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConnectionPointEccentricity *getIfcConnectionPointEccentricity(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConnectionPointEccentricity(IfcConnectionPointEccentricity *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConnectionPointEccentricity > createIfcConnectionPointEccentricity(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConnectionPointEccentricity *cloneIfcConnectionPointEccentricity(const IfcConnectionPointEccentricity &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConnectionPointGeometry *getIfcConnectionPointGeometry(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConnectionPointGeometry(IfcConnectionPointGeometry *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConnectionPointGeometry > createIfcConnectionPointGeometry(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConnectionPointGeometry *cloneIfcConnectionPointGeometry(const IfcConnectionPointGeometry &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConnectionPortGeometry *getIfcConnectionPortGeometry(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConnectionPortGeometry(IfcConnectionPortGeometry *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConnectionPortGeometry > createIfcConnectionPortGeometry(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConnectionPortGeometry *cloneIfcConnectionPortGeometry(const IfcConnectionPortGeometry &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConnectionSurfaceGeometry *getIfcConnectionSurfaceGeometry(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConnectionSurfaceGeometry(IfcConnectionSurfaceGeometry *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConnectionSurfaceGeometry > createIfcConnectionSurfaceGeometry(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConnectionSurfaceGeometry *cloneIfcConnectionSurfaceGeometry(const IfcConnectionSurfaceGeometry &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConstraintAggregationRelationship *getIfcConstraintAggregationRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConstraintAggregationRelationship(IfcConstraintAggregationRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConstraintAggregationRelationship > createIfcConstraintAggregationRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConstraintAggregationRelationship *cloneIfcConstraintAggregationRelationship(const IfcConstraintAggregationRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConstraintClassificationRelationship *getIfcConstraintClassificationRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConstraintClassificationRelationship(IfcConstraintClassificationRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConstraintClassificationRelationship > createIfcConstraintClassificationRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConstraintClassificationRelationship *cloneIfcConstraintClassificationRelationship(const IfcConstraintClassificationRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConstraintRelationship *getIfcConstraintRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConstraintRelationship(IfcConstraintRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConstraintRelationship > createIfcConstraintRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConstraintRelationship *cloneIfcConstraintRelationship(const IfcConstraintRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConstructionEquipmentResource *getIfcConstructionEquipmentResource(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConstructionEquipmentResource(IfcConstructionEquipmentResource *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConstructionEquipmentResource > createIfcConstructionEquipmentResource(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConstructionEquipmentResource *cloneIfcConstructionEquipmentResource(const IfcConstructionEquipmentResource &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConstructionMaterialResource *getIfcConstructionMaterialResource(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConstructionMaterialResource(IfcConstructionMaterialResource *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConstructionMaterialResource > createIfcConstructionMaterialResource(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConstructionMaterialResource *cloneIfcConstructionMaterialResource(const IfcConstructionMaterialResource &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConstructionProductResource *getIfcConstructionProductResource(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConstructionProductResource(IfcConstructionProductResource *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConstructionProductResource > createIfcConstructionProductResource(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConstructionProductResource *cloneIfcConstructionProductResource(const IfcConstructionProductResource &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcContextDependentUnit *getIfcContextDependentUnit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcContextDependentUnit(IfcContextDependentUnit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcContextDependentUnit > createIfcContextDependentUnit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcContextDependentUnit *cloneIfcContextDependentUnit(const IfcContextDependentUnit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcControllerType *getIfcControllerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcControllerType(IfcControllerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcControllerType > createIfcControllerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcControllerType *cloneIfcControllerType(const IfcControllerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcConversionBasedUnit *getIfcConversionBasedUnit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcConversionBasedUnit(IfcConversionBasedUnit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcConversionBasedUnit > createIfcConversionBasedUnit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcConversionBasedUnit *cloneIfcConversionBasedUnit(const IfcConversionBasedUnit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCooledBeamType *getIfcCooledBeamType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCooledBeamType(IfcCooledBeamType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCooledBeamType > createIfcCooledBeamType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCooledBeamType *cloneIfcCooledBeamType(const IfcCooledBeamType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCoolingTowerType *getIfcCoolingTowerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCoolingTowerType(IfcCoolingTowerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCoolingTowerType > createIfcCoolingTowerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCoolingTowerType *cloneIfcCoolingTowerType(const IfcCoolingTowerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCoordinatedUniversalTimeOffset *getIfcCoordinatedUniversalTimeOffset(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCoordinatedUniversalTimeOffset(IfcCoordinatedUniversalTimeOffset *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCoordinatedUniversalTimeOffset > createIfcCoordinatedUniversalTimeOffset(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCoordinatedUniversalTimeOffset *cloneIfcCoordinatedUniversalTimeOffset(const IfcCoordinatedUniversalTimeOffset &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCostItem *getIfcCostItem(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCostItem(IfcCostItem *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCostItem > createIfcCostItem(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCostItem *cloneIfcCostItem(const IfcCostItem &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCostSchedule *getIfcCostSchedule(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCostSchedule(IfcCostSchedule *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCostSchedule > createIfcCostSchedule(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCostSchedule *cloneIfcCostSchedule(const IfcCostSchedule &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCostValue *getIfcCostValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCostValue(IfcCostValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCostValue > createIfcCostValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCostValue *cloneIfcCostValue(const IfcCostValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCovering *getIfcCovering(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCovering(IfcCovering *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCovering > createIfcCovering(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCovering *cloneIfcCovering(const IfcCovering &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCoveringType *getIfcCoveringType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCoveringType(IfcCoveringType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCoveringType > createIfcCoveringType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCoveringType *cloneIfcCoveringType(const IfcCoveringType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCraneRailAShapeProfileDef *getIfcCraneRailAShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCraneRailAShapeProfileDef(IfcCraneRailAShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCraneRailAShapeProfileDef > createIfcCraneRailAShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCraneRailAShapeProfileDef *cloneIfcCraneRailAShapeProfileDef(const IfcCraneRailAShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCraneRailFShapeProfileDef *getIfcCraneRailFShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCraneRailFShapeProfileDef(IfcCraneRailFShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCraneRailFShapeProfileDef > createIfcCraneRailFShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCraneRailFShapeProfileDef *cloneIfcCraneRailFShapeProfileDef(const IfcCraneRailFShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCrewResource *getIfcCrewResource(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCrewResource(IfcCrewResource *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCrewResource > createIfcCrewResource(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCrewResource *cloneIfcCrewResource(const IfcCrewResource &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCsgSolid *getIfcCsgSolid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCsgSolid(IfcCsgSolid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCsgSolid > createIfcCsgSolid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCsgSolid *cloneIfcCsgSolid(const IfcCsgSolid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurrencyRelationship *getIfcCurrencyRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurrencyRelationship(IfcCurrencyRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurrencyRelationship > createIfcCurrencyRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurrencyRelationship *cloneIfcCurrencyRelationship(const IfcCurrencyRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurtainWall *getIfcCurtainWall(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurtainWall(IfcCurtainWall *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurtainWall > createIfcCurtainWall(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurtainWall *cloneIfcCurtainWall(const IfcCurtainWall &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurtainWallType *getIfcCurtainWallType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurtainWallType(IfcCurtainWallType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurtainWallType > createIfcCurtainWallType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurtainWallType *cloneIfcCurtainWallType(const IfcCurtainWallType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurveBoundedPlane *getIfcCurveBoundedPlane(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurveBoundedPlane(IfcCurveBoundedPlane *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurveBoundedPlane > createIfcCurveBoundedPlane(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurveBoundedPlane *cloneIfcCurveBoundedPlane(const IfcCurveBoundedPlane &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurveStyle *getIfcCurveStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurveStyle(IfcCurveStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurveStyle > createIfcCurveStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurveStyle *cloneIfcCurveStyle(const IfcCurveStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurveStyleFont *getIfcCurveStyleFont(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurveStyleFont(IfcCurveStyleFont *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurveStyleFont > createIfcCurveStyleFont(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurveStyleFont *cloneIfcCurveStyleFont(const IfcCurveStyleFont &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurveStyleFontAndScaling *getIfcCurveStyleFontAndScaling(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurveStyleFontAndScaling(IfcCurveStyleFontAndScaling *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurveStyleFontAndScaling > createIfcCurveStyleFontAndScaling(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurveStyleFontAndScaling *cloneIfcCurveStyleFontAndScaling(const IfcCurveStyleFontAndScaling &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcCurveStyleFontPattern *getIfcCurveStyleFontPattern(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcCurveStyleFontPattern(IfcCurveStyleFontPattern *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcCurveStyleFontPattern > createIfcCurveStyleFontPattern(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcCurveStyleFontPattern *cloneIfcCurveStyleFontPattern(const IfcCurveStyleFontPattern &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDamperType *getIfcDamperType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDamperType(IfcDamperType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDamperType > createIfcDamperType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDamperType *cloneIfcDamperType(const IfcDamperType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDateAndTime *getIfcDateAndTime(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDateAndTime(IfcDateAndTime *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDateAndTime > createIfcDateAndTime(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDateAndTime *cloneIfcDateAndTime(const IfcDateAndTime &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDefinedSymbol *getIfcDefinedSymbol(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDefinedSymbol(IfcDefinedSymbol *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDefinedSymbol > createIfcDefinedSymbol(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDefinedSymbol *cloneIfcDefinedSymbol(const IfcDefinedSymbol &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDerivedProfileDef *getIfcDerivedProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDerivedProfileDef(IfcDerivedProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDerivedProfileDef > createIfcDerivedProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDerivedProfileDef *cloneIfcDerivedProfileDef(const IfcDerivedProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDerivedUnit *getIfcDerivedUnit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDerivedUnit(IfcDerivedUnit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDerivedUnit > createIfcDerivedUnit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDerivedUnit *cloneIfcDerivedUnit(const IfcDerivedUnit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDerivedUnitElement *getIfcDerivedUnitElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDerivedUnitElement(IfcDerivedUnitElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDerivedUnitElement > createIfcDerivedUnitElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDerivedUnitElement *cloneIfcDerivedUnitElement(const IfcDerivedUnitElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDiameterDimension *getIfcDiameterDimension(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDiameterDimension(IfcDiameterDimension *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDiameterDimension > createIfcDiameterDimension(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDiameterDimension *cloneIfcDiameterDimension(const IfcDiameterDimension &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDimensionCalloutRelationship *getIfcDimensionCalloutRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDimensionCalloutRelationship(IfcDimensionCalloutRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDimensionCalloutRelationship > createIfcDimensionCalloutRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDimensionCalloutRelationship *cloneIfcDimensionCalloutRelationship(const IfcDimensionCalloutRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDimensionCurve *getIfcDimensionCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDimensionCurve(IfcDimensionCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDimensionCurve > createIfcDimensionCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDimensionCurve *cloneIfcDimensionCurve(const IfcDimensionCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDimensionCurveDirectedCallout *getIfcDimensionCurveDirectedCallout(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDimensionCurveDirectedCallout(IfcDimensionCurveDirectedCallout *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDimensionCurveDirectedCallout > createIfcDimensionCurveDirectedCallout(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDimensionCurveDirectedCallout *cloneIfcDimensionCurveDirectedCallout(const IfcDimensionCurveDirectedCallout &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDimensionCurveTerminator *getIfcDimensionCurveTerminator(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDimensionCurveTerminator(IfcDimensionCurveTerminator *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDimensionCurveTerminator > createIfcDimensionCurveTerminator(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDimensionCurveTerminator *cloneIfcDimensionCurveTerminator(const IfcDimensionCurveTerminator &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDimensionPair *getIfcDimensionPair(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDimensionPair(IfcDimensionPair *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDimensionPair > createIfcDimensionPair(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDimensionPair *cloneIfcDimensionPair(const IfcDimensionPair &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDimensionalExponents *getIfcDimensionalExponents(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDimensionalExponents(IfcDimensionalExponents *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDimensionalExponents > createIfcDimensionalExponents(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDimensionalExponents *cloneIfcDimensionalExponents(const IfcDimensionalExponents &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDirection *getIfcDirection(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDirection(IfcDirection *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDirection > createIfcDirection(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDirection *cloneIfcDirection(const IfcDirection &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDiscreteAccessory *getIfcDiscreteAccessory(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDiscreteAccessory(IfcDiscreteAccessory *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDiscreteAccessory > createIfcDiscreteAccessory(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDiscreteAccessory *cloneIfcDiscreteAccessory(const IfcDiscreteAccessory &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDiscreteAccessoryType *getIfcDiscreteAccessoryType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDiscreteAccessoryType(IfcDiscreteAccessoryType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDiscreteAccessoryType > createIfcDiscreteAccessoryType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDiscreteAccessoryType *cloneIfcDiscreteAccessoryType(const IfcDiscreteAccessoryType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDistributionChamberElement *getIfcDistributionChamberElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDistributionChamberElement(IfcDistributionChamberElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDistributionChamberElement > createIfcDistributionChamberElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDistributionChamberElement *cloneIfcDistributionChamberElement(const IfcDistributionChamberElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDistributionChamberElementType *getIfcDistributionChamberElementType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDistributionChamberElementType(IfcDistributionChamberElementType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDistributionChamberElementType > createIfcDistributionChamberElementType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDistributionChamberElementType *cloneIfcDistributionChamberElementType(const IfcDistributionChamberElementType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDistributionControlElement *getIfcDistributionControlElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDistributionControlElement(IfcDistributionControlElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDistributionControlElement > createIfcDistributionControlElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDistributionControlElement *cloneIfcDistributionControlElement(const IfcDistributionControlElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDistributionElement *getIfcDistributionElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDistributionElement(IfcDistributionElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDistributionElement > createIfcDistributionElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDistributionElement *cloneIfcDistributionElement(const IfcDistributionElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDistributionElementType *getIfcDistributionElementType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDistributionElementType(IfcDistributionElementType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDistributionElementType > createIfcDistributionElementType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDistributionElementType *cloneIfcDistributionElementType(const IfcDistributionElementType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDistributionFlowElement *getIfcDistributionFlowElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDistributionFlowElement(IfcDistributionFlowElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDistributionFlowElement > createIfcDistributionFlowElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDistributionFlowElement *cloneIfcDistributionFlowElement(const IfcDistributionFlowElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDistributionPort *getIfcDistributionPort(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDistributionPort(IfcDistributionPort *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDistributionPort > createIfcDistributionPort(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDistributionPort *cloneIfcDistributionPort(const IfcDistributionPort &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDocumentElectronicFormat *getIfcDocumentElectronicFormat(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDocumentElectronicFormat(IfcDocumentElectronicFormat *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDocumentElectronicFormat > createIfcDocumentElectronicFormat(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDocumentElectronicFormat *cloneIfcDocumentElectronicFormat(const IfcDocumentElectronicFormat &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDocumentInformation *getIfcDocumentInformation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDocumentInformation(IfcDocumentInformation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDocumentInformation > createIfcDocumentInformation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDocumentInformation *cloneIfcDocumentInformation(const IfcDocumentInformation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDocumentInformationRelationship *getIfcDocumentInformationRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDocumentInformationRelationship(IfcDocumentInformationRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDocumentInformationRelationship > createIfcDocumentInformationRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDocumentInformationRelationship *cloneIfcDocumentInformationRelationship(const IfcDocumentInformationRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDocumentReference *getIfcDocumentReference(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDocumentReference(IfcDocumentReference *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDocumentReference > createIfcDocumentReference(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDocumentReference *cloneIfcDocumentReference(const IfcDocumentReference &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDoor *getIfcDoor(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDoor(IfcDoor *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDoor > createIfcDoor(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDoor *cloneIfcDoor(const IfcDoor &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDoorLiningProperties *getIfcDoorLiningProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDoorLiningProperties(IfcDoorLiningProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDoorLiningProperties > createIfcDoorLiningProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDoorLiningProperties *cloneIfcDoorLiningProperties(const IfcDoorLiningProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDoorPanelProperties *getIfcDoorPanelProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDoorPanelProperties(IfcDoorPanelProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDoorPanelProperties > createIfcDoorPanelProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDoorPanelProperties *cloneIfcDoorPanelProperties(const IfcDoorPanelProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDoorStyle *getIfcDoorStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDoorStyle(IfcDoorStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDoorStyle > createIfcDoorStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDoorStyle *cloneIfcDoorStyle(const IfcDoorStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDraughtingCallout *getIfcDraughtingCallout(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDraughtingCallout(IfcDraughtingCallout *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDraughtingCallout > createIfcDraughtingCallout(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDraughtingCallout *cloneIfcDraughtingCallout(const IfcDraughtingCallout &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDraughtingCalloutRelationship *getIfcDraughtingCalloutRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDraughtingCalloutRelationship(IfcDraughtingCalloutRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDraughtingCalloutRelationship > createIfcDraughtingCalloutRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDraughtingCalloutRelationship *cloneIfcDraughtingCalloutRelationship(const IfcDraughtingCalloutRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDraughtingPreDefinedColour *getIfcDraughtingPreDefinedColour(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDraughtingPreDefinedColour(IfcDraughtingPreDefinedColour *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDraughtingPreDefinedColour > createIfcDraughtingPreDefinedColour(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDraughtingPreDefinedColour *cloneIfcDraughtingPreDefinedColour(const IfcDraughtingPreDefinedColour &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDraughtingPreDefinedCurveFont *getIfcDraughtingPreDefinedCurveFont(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDraughtingPreDefinedCurveFont(IfcDraughtingPreDefinedCurveFont *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDraughtingPreDefinedCurveFont > createIfcDraughtingPreDefinedCurveFont(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDraughtingPreDefinedCurveFont *cloneIfcDraughtingPreDefinedCurveFont(const IfcDraughtingPreDefinedCurveFont &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDraughtingPreDefinedTextFont *getIfcDraughtingPreDefinedTextFont(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDraughtingPreDefinedTextFont(IfcDraughtingPreDefinedTextFont *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDraughtingPreDefinedTextFont > createIfcDraughtingPreDefinedTextFont(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDraughtingPreDefinedTextFont *cloneIfcDraughtingPreDefinedTextFont(const IfcDraughtingPreDefinedTextFont &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDuctFittingType *getIfcDuctFittingType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDuctFittingType(IfcDuctFittingType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDuctFittingType > createIfcDuctFittingType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDuctFittingType *cloneIfcDuctFittingType(const IfcDuctFittingType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDuctSegmentType *getIfcDuctSegmentType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDuctSegmentType(IfcDuctSegmentType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDuctSegmentType > createIfcDuctSegmentType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDuctSegmentType *cloneIfcDuctSegmentType(const IfcDuctSegmentType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcDuctSilencerType *getIfcDuctSilencerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcDuctSilencerType(IfcDuctSilencerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcDuctSilencerType > createIfcDuctSilencerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcDuctSilencerType *cloneIfcDuctSilencerType(const IfcDuctSilencerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEdge *getIfcEdge(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEdge(IfcEdge *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEdge > createIfcEdge(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEdge *cloneIfcEdge(const IfcEdge &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEdgeCurve *getIfcEdgeCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEdgeCurve(IfcEdgeCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEdgeCurve > createIfcEdgeCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEdgeCurve *cloneIfcEdgeCurve(const IfcEdgeCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEdgeLoop *getIfcEdgeLoop(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEdgeLoop(IfcEdgeLoop *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEdgeLoop > createIfcEdgeLoop(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEdgeLoop *cloneIfcEdgeLoop(const IfcEdgeLoop &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricApplianceType *getIfcElectricApplianceType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricApplianceType(IfcElectricApplianceType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricApplianceType > createIfcElectricApplianceType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricApplianceType *cloneIfcElectricApplianceType(const IfcElectricApplianceType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricDistributionPoint *getIfcElectricDistributionPoint(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricDistributionPoint(IfcElectricDistributionPoint *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricDistributionPoint > createIfcElectricDistributionPoint(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricDistributionPoint *cloneIfcElectricDistributionPoint(const IfcElectricDistributionPoint &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricFlowStorageDeviceType *getIfcElectricFlowStorageDeviceType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricFlowStorageDeviceType(IfcElectricFlowStorageDeviceType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricFlowStorageDeviceType > createIfcElectricFlowStorageDeviceType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricFlowStorageDeviceType *cloneIfcElectricFlowStorageDeviceType(const IfcElectricFlowStorageDeviceType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricGeneratorType *getIfcElectricGeneratorType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricGeneratorType(IfcElectricGeneratorType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricGeneratorType > createIfcElectricGeneratorType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricGeneratorType *cloneIfcElectricGeneratorType(const IfcElectricGeneratorType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricHeaterType *getIfcElectricHeaterType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricHeaterType(IfcElectricHeaterType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricHeaterType > createIfcElectricHeaterType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricHeaterType *cloneIfcElectricHeaterType(const IfcElectricHeaterType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricMotorType *getIfcElectricMotorType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricMotorType(IfcElectricMotorType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricMotorType > createIfcElectricMotorType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricMotorType *cloneIfcElectricMotorType(const IfcElectricMotorType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricTimeControlType *getIfcElectricTimeControlType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricTimeControlType(IfcElectricTimeControlType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricTimeControlType > createIfcElectricTimeControlType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricTimeControlType *cloneIfcElectricTimeControlType(const IfcElectricTimeControlType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricalBaseProperties *getIfcElectricalBaseProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricalBaseProperties(IfcElectricalBaseProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricalBaseProperties > createIfcElectricalBaseProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricalBaseProperties *cloneIfcElectricalBaseProperties(const IfcElectricalBaseProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricalCircuit *getIfcElectricalCircuit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricalCircuit(IfcElectricalCircuit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricalCircuit > createIfcElectricalCircuit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricalCircuit *cloneIfcElectricalCircuit(const IfcElectricalCircuit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElectricalElement *getIfcElectricalElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElectricalElement(IfcElectricalElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElectricalElement > createIfcElectricalElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElectricalElement *cloneIfcElectricalElement(const IfcElectricalElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElementAssembly *getIfcElementAssembly(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElementAssembly(IfcElementAssembly *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElementAssembly > createIfcElementAssembly(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElementAssembly *cloneIfcElementAssembly(const IfcElementAssembly &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcElementQuantity *getIfcElementQuantity(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcElementQuantity(IfcElementQuantity *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcElementQuantity > createIfcElementQuantity(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcElementQuantity *cloneIfcElementQuantity(const IfcElementQuantity &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEllipse *getIfcEllipse(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEllipse(IfcEllipse *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEllipse > createIfcEllipse(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEllipse *cloneIfcEllipse(const IfcEllipse &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEllipseProfileDef *getIfcEllipseProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEllipseProfileDef(IfcEllipseProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEllipseProfileDef > createIfcEllipseProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEllipseProfileDef *cloneIfcEllipseProfileDef(const IfcEllipseProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEnergyConversionDevice *getIfcEnergyConversionDevice(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEnergyConversionDevice(IfcEnergyConversionDevice *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEnergyConversionDevice > createIfcEnergyConversionDevice(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEnergyConversionDevice *cloneIfcEnergyConversionDevice(const IfcEnergyConversionDevice &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEnergyProperties *getIfcEnergyProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEnergyProperties(IfcEnergyProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEnergyProperties > createIfcEnergyProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEnergyProperties *cloneIfcEnergyProperties(const IfcEnergyProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEnvironmentalImpactValue *getIfcEnvironmentalImpactValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEnvironmentalImpactValue(IfcEnvironmentalImpactValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEnvironmentalImpactValue > createIfcEnvironmentalImpactValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEnvironmentalImpactValue *cloneIfcEnvironmentalImpactValue(const IfcEnvironmentalImpactValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEquipmentElement *getIfcEquipmentElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEquipmentElement(IfcEquipmentElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEquipmentElement > createIfcEquipmentElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEquipmentElement *cloneIfcEquipmentElement(const IfcEquipmentElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEquipmentStandard *getIfcEquipmentStandard(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEquipmentStandard(IfcEquipmentStandard *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEquipmentStandard > createIfcEquipmentStandard(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEquipmentStandard *cloneIfcEquipmentStandard(const IfcEquipmentStandard &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEvaporativeCoolerType *getIfcEvaporativeCoolerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEvaporativeCoolerType(IfcEvaporativeCoolerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEvaporativeCoolerType > createIfcEvaporativeCoolerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEvaporativeCoolerType *cloneIfcEvaporativeCoolerType(const IfcEvaporativeCoolerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcEvaporatorType *getIfcEvaporatorType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcEvaporatorType(IfcEvaporatorType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcEvaporatorType > createIfcEvaporatorType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcEvaporatorType *cloneIfcEvaporatorType(const IfcEvaporatorType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcExtendedMaterialProperties *getIfcExtendedMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcExtendedMaterialProperties(IfcExtendedMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcExtendedMaterialProperties > createIfcExtendedMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcExtendedMaterialProperties *cloneIfcExtendedMaterialProperties(const IfcExtendedMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcExternallyDefinedHatchStyle *getIfcExternallyDefinedHatchStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcExternallyDefinedHatchStyle(IfcExternallyDefinedHatchStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcExternallyDefinedHatchStyle > createIfcExternallyDefinedHatchStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcExternallyDefinedHatchStyle *cloneIfcExternallyDefinedHatchStyle(const IfcExternallyDefinedHatchStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcExternallyDefinedSurfaceStyle *getIfcExternallyDefinedSurfaceStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcExternallyDefinedSurfaceStyle(IfcExternallyDefinedSurfaceStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcExternallyDefinedSurfaceStyle > createIfcExternallyDefinedSurfaceStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcExternallyDefinedSurfaceStyle *cloneIfcExternallyDefinedSurfaceStyle(const IfcExternallyDefinedSurfaceStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcExternallyDefinedSymbol *getIfcExternallyDefinedSymbol(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcExternallyDefinedSymbol(IfcExternallyDefinedSymbol *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcExternallyDefinedSymbol > createIfcExternallyDefinedSymbol(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcExternallyDefinedSymbol *cloneIfcExternallyDefinedSymbol(const IfcExternallyDefinedSymbol &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcExternallyDefinedTextFont *getIfcExternallyDefinedTextFont(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcExternallyDefinedTextFont(IfcExternallyDefinedTextFont *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcExternallyDefinedTextFont > createIfcExternallyDefinedTextFont(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcExternallyDefinedTextFont *cloneIfcExternallyDefinedTextFont(const IfcExternallyDefinedTextFont &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcExtrudedAreaSolid *getIfcExtrudedAreaSolid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcExtrudedAreaSolid(IfcExtrudedAreaSolid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcExtrudedAreaSolid > createIfcExtrudedAreaSolid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcExtrudedAreaSolid *cloneIfcExtrudedAreaSolid(const IfcExtrudedAreaSolid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFace *getIfcFace(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFace(IfcFace *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFace > createIfcFace(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFace *cloneIfcFace(const IfcFace &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFaceBasedSurfaceModel *getIfcFaceBasedSurfaceModel(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFaceBasedSurfaceModel(IfcFaceBasedSurfaceModel *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFaceBasedSurfaceModel > createIfcFaceBasedSurfaceModel(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFaceBasedSurfaceModel *cloneIfcFaceBasedSurfaceModel(const IfcFaceBasedSurfaceModel &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFaceBound *getIfcFaceBound(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFaceBound(IfcFaceBound *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFaceBound > createIfcFaceBound(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFaceBound *cloneIfcFaceBound(const IfcFaceBound &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFaceOuterBound *getIfcFaceOuterBound(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFaceOuterBound(IfcFaceOuterBound *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFaceOuterBound > createIfcFaceOuterBound(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFaceOuterBound *cloneIfcFaceOuterBound(const IfcFaceOuterBound &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFaceSurface *getIfcFaceSurface(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFaceSurface(IfcFaceSurface *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFaceSurface > createIfcFaceSurface(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFaceSurface *cloneIfcFaceSurface(const IfcFaceSurface &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFacetedBrep *getIfcFacetedBrep(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFacetedBrep(IfcFacetedBrep *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFacetedBrep > createIfcFacetedBrep(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFacetedBrep *cloneIfcFacetedBrep(const IfcFacetedBrep &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFacetedBrepWithVoids *getIfcFacetedBrepWithVoids(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFacetedBrepWithVoids(IfcFacetedBrepWithVoids *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFacetedBrepWithVoids > createIfcFacetedBrepWithVoids(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFacetedBrepWithVoids *cloneIfcFacetedBrepWithVoids(const IfcFacetedBrepWithVoids &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFailureConnectionCondition *getIfcFailureConnectionCondition(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFailureConnectionCondition(IfcFailureConnectionCondition *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFailureConnectionCondition > createIfcFailureConnectionCondition(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFailureConnectionCondition *cloneIfcFailureConnectionCondition(const IfcFailureConnectionCondition &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFanType *getIfcFanType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFanType(IfcFanType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFanType > createIfcFanType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFanType *cloneIfcFanType(const IfcFanType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFastener *getIfcFastener(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFastener(IfcFastener *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFastener > createIfcFastener(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFastener *cloneIfcFastener(const IfcFastener &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFastenerType *getIfcFastenerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFastenerType(IfcFastenerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFastenerType > createIfcFastenerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFastenerType *cloneIfcFastenerType(const IfcFastenerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFillAreaStyle *getIfcFillAreaStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFillAreaStyle(IfcFillAreaStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFillAreaStyle > createIfcFillAreaStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFillAreaStyle *cloneIfcFillAreaStyle(const IfcFillAreaStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFillAreaStyleHatching *getIfcFillAreaStyleHatching(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFillAreaStyleHatching(IfcFillAreaStyleHatching *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFillAreaStyleHatching > createIfcFillAreaStyleHatching(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFillAreaStyleHatching *cloneIfcFillAreaStyleHatching(const IfcFillAreaStyleHatching &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFillAreaStyleTileSymbolWithStyle *getIfcFillAreaStyleTileSymbolWithStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFillAreaStyleTileSymbolWithStyle(IfcFillAreaStyleTileSymbolWithStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFillAreaStyleTileSymbolWithStyle > createIfcFillAreaStyleTileSymbolWithStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFillAreaStyleTileSymbolWithStyle *cloneIfcFillAreaStyleTileSymbolWithStyle(const IfcFillAreaStyleTileSymbolWithStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFillAreaStyleTiles *getIfcFillAreaStyleTiles(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFillAreaStyleTiles(IfcFillAreaStyleTiles *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFillAreaStyleTiles > createIfcFillAreaStyleTiles(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFillAreaStyleTiles *cloneIfcFillAreaStyleTiles(const IfcFillAreaStyleTiles &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFilterType *getIfcFilterType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFilterType(IfcFilterType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFilterType > createIfcFilterType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFilterType *cloneIfcFilterType(const IfcFilterType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFireSuppressionTerminalType *getIfcFireSuppressionTerminalType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFireSuppressionTerminalType(IfcFireSuppressionTerminalType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFireSuppressionTerminalType > createIfcFireSuppressionTerminalType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFireSuppressionTerminalType *cloneIfcFireSuppressionTerminalType(const IfcFireSuppressionTerminalType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowController *getIfcFlowController(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowController(IfcFlowController *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowController > createIfcFlowController(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowController *cloneIfcFlowController(const IfcFlowController &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowFitting *getIfcFlowFitting(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowFitting(IfcFlowFitting *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowFitting > createIfcFlowFitting(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowFitting *cloneIfcFlowFitting(const IfcFlowFitting &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowInstrumentType *getIfcFlowInstrumentType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowInstrumentType(IfcFlowInstrumentType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowInstrumentType > createIfcFlowInstrumentType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowInstrumentType *cloneIfcFlowInstrumentType(const IfcFlowInstrumentType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowMeterType *getIfcFlowMeterType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowMeterType(IfcFlowMeterType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowMeterType > createIfcFlowMeterType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowMeterType *cloneIfcFlowMeterType(const IfcFlowMeterType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowMovingDevice *getIfcFlowMovingDevice(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowMovingDevice(IfcFlowMovingDevice *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowMovingDevice > createIfcFlowMovingDevice(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowMovingDevice *cloneIfcFlowMovingDevice(const IfcFlowMovingDevice &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowSegment *getIfcFlowSegment(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowSegment(IfcFlowSegment *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowSegment > createIfcFlowSegment(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowSegment *cloneIfcFlowSegment(const IfcFlowSegment &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowStorageDevice *getIfcFlowStorageDevice(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowStorageDevice(IfcFlowStorageDevice *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowStorageDevice > createIfcFlowStorageDevice(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowStorageDevice *cloneIfcFlowStorageDevice(const IfcFlowStorageDevice &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowTerminal *getIfcFlowTerminal(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowTerminal(IfcFlowTerminal *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowTerminal > createIfcFlowTerminal(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowTerminal *cloneIfcFlowTerminal(const IfcFlowTerminal &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFlowTreatmentDevice *getIfcFlowTreatmentDevice(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFlowTreatmentDevice(IfcFlowTreatmentDevice *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFlowTreatmentDevice > createIfcFlowTreatmentDevice(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFlowTreatmentDevice *cloneIfcFlowTreatmentDevice(const IfcFlowTreatmentDevice &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFluidFlowProperties *getIfcFluidFlowProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFluidFlowProperties(IfcFluidFlowProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFluidFlowProperties > createIfcFluidFlowProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFluidFlowProperties *cloneIfcFluidFlowProperties(const IfcFluidFlowProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFooting *getIfcFooting(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFooting(IfcFooting *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFooting > createIfcFooting(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFooting *cloneIfcFooting(const IfcFooting &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFuelProperties *getIfcFuelProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFuelProperties(IfcFuelProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFuelProperties > createIfcFuelProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFuelProperties *cloneIfcFuelProperties(const IfcFuelProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFurnishingElement *getIfcFurnishingElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFurnishingElement(IfcFurnishingElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFurnishingElement > createIfcFurnishingElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFurnishingElement *cloneIfcFurnishingElement(const IfcFurnishingElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFurnishingElementType *getIfcFurnishingElementType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFurnishingElementType(IfcFurnishingElementType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFurnishingElementType > createIfcFurnishingElementType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFurnishingElementType *cloneIfcFurnishingElementType(const IfcFurnishingElementType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFurnitureStandard *getIfcFurnitureStandard(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFurnitureStandard(IfcFurnitureStandard *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFurnitureStandard > createIfcFurnitureStandard(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFurnitureStandard *cloneIfcFurnitureStandard(const IfcFurnitureStandard &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcFurnitureType *getIfcFurnitureType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcFurnitureType(IfcFurnitureType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcFurnitureType > createIfcFurnitureType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcFurnitureType *cloneIfcFurnitureType(const IfcFurnitureType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGasTerminalType *getIfcGasTerminalType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGasTerminalType(IfcGasTerminalType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGasTerminalType > createIfcGasTerminalType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGasTerminalType *cloneIfcGasTerminalType(const IfcGasTerminalType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGeneralMaterialProperties *getIfcGeneralMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGeneralMaterialProperties(IfcGeneralMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGeneralMaterialProperties > createIfcGeneralMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGeneralMaterialProperties *cloneIfcGeneralMaterialProperties(const IfcGeneralMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGeneralProfileProperties *getIfcGeneralProfileProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGeneralProfileProperties(IfcGeneralProfileProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGeneralProfileProperties > createIfcGeneralProfileProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGeneralProfileProperties *cloneIfcGeneralProfileProperties(const IfcGeneralProfileProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGeometricCurveSet *getIfcGeometricCurveSet(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGeometricCurveSet(IfcGeometricCurveSet *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGeometricCurveSet > createIfcGeometricCurveSet(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGeometricCurveSet *cloneIfcGeometricCurveSet(const IfcGeometricCurveSet &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGeometricRepresentationContext *getIfcGeometricRepresentationContext(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGeometricRepresentationContext(IfcGeometricRepresentationContext *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGeometricRepresentationContext > createIfcGeometricRepresentationContext(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGeometricRepresentationContext *cloneIfcGeometricRepresentationContext(const IfcGeometricRepresentationContext &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGeometricRepresentationSubContext *getIfcGeometricRepresentationSubContext(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGeometricRepresentationSubContext(IfcGeometricRepresentationSubContext *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGeometricRepresentationSubContext > createIfcGeometricRepresentationSubContext(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGeometricRepresentationSubContext *cloneIfcGeometricRepresentationSubContext(const IfcGeometricRepresentationSubContext &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGeometricSet *getIfcGeometricSet(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGeometricSet(IfcGeometricSet *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGeometricSet > createIfcGeometricSet(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGeometricSet *cloneIfcGeometricSet(const IfcGeometricSet &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGrid *getIfcGrid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGrid(IfcGrid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGrid > createIfcGrid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGrid *cloneIfcGrid(const IfcGrid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGridAxis *getIfcGridAxis(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGridAxis(IfcGridAxis *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGridAxis > createIfcGridAxis(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGridAxis *cloneIfcGridAxis(const IfcGridAxis &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGridPlacement *getIfcGridPlacement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGridPlacement(IfcGridPlacement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGridPlacement > createIfcGridPlacement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGridPlacement *cloneIfcGridPlacement(const IfcGridPlacement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcGroup *getIfcGroup(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcGroup(IfcGroup *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcGroup > createIfcGroup(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcGroup *cloneIfcGroup(const IfcGroup &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcHalfSpaceSolid *getIfcHalfSpaceSolid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcHalfSpaceSolid(IfcHalfSpaceSolid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcHalfSpaceSolid > createIfcHalfSpaceSolid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcHalfSpaceSolid *cloneIfcHalfSpaceSolid(const IfcHalfSpaceSolid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcHeatExchangerType *getIfcHeatExchangerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcHeatExchangerType(IfcHeatExchangerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcHeatExchangerType > createIfcHeatExchangerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcHeatExchangerType *cloneIfcHeatExchangerType(const IfcHeatExchangerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcHumidifierType *getIfcHumidifierType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcHumidifierType(IfcHumidifierType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcHumidifierType > createIfcHumidifierType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcHumidifierType *cloneIfcHumidifierType(const IfcHumidifierType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcHygroscopicMaterialProperties *getIfcHygroscopicMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcHygroscopicMaterialProperties(IfcHygroscopicMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcHygroscopicMaterialProperties > createIfcHygroscopicMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcHygroscopicMaterialProperties *cloneIfcHygroscopicMaterialProperties(const IfcHygroscopicMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcIShapeProfileDef *getIfcIShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcIShapeProfileDef(IfcIShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcIShapeProfileDef > createIfcIShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcIShapeProfileDef *cloneIfcIShapeProfileDef(const IfcIShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcImageTexture *getIfcImageTexture(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcImageTexture(IfcImageTexture *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcImageTexture > createIfcImageTexture(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcImageTexture *cloneIfcImageTexture(const IfcImageTexture &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcInventory *getIfcInventory(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcInventory(IfcInventory *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcInventory > createIfcInventory(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcInventory *cloneIfcInventory(const IfcInventory &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcIrregularTimeSeries *getIfcIrregularTimeSeries(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcIrregularTimeSeries(IfcIrregularTimeSeries *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcIrregularTimeSeries > createIfcIrregularTimeSeries(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcIrregularTimeSeries *cloneIfcIrregularTimeSeries(const IfcIrregularTimeSeries &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcIrregularTimeSeriesValue *getIfcIrregularTimeSeriesValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcIrregularTimeSeriesValue(IfcIrregularTimeSeriesValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcIrregularTimeSeriesValue > createIfcIrregularTimeSeriesValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcIrregularTimeSeriesValue *cloneIfcIrregularTimeSeriesValue(const IfcIrregularTimeSeriesValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcJunctionBoxType *getIfcJunctionBoxType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcJunctionBoxType(IfcJunctionBoxType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcJunctionBoxType > createIfcJunctionBoxType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcJunctionBoxType *cloneIfcJunctionBoxType(const IfcJunctionBoxType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLShapeProfileDef *getIfcLShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLShapeProfileDef(IfcLShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLShapeProfileDef > createIfcLShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLShapeProfileDef *cloneIfcLShapeProfileDef(const IfcLShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLaborResource *getIfcLaborResource(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLaborResource(IfcLaborResource *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLaborResource > createIfcLaborResource(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLaborResource *cloneIfcLaborResource(const IfcLaborResource &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLampType *getIfcLampType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLampType(IfcLampType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLampType > createIfcLampType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLampType *cloneIfcLampType(const IfcLampType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLibraryInformation *getIfcLibraryInformation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLibraryInformation(IfcLibraryInformation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLibraryInformation > createIfcLibraryInformation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLibraryInformation *cloneIfcLibraryInformation(const IfcLibraryInformation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLibraryReference *getIfcLibraryReference(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLibraryReference(IfcLibraryReference *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLibraryReference > createIfcLibraryReference(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLibraryReference *cloneIfcLibraryReference(const IfcLibraryReference &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightDistributionData *getIfcLightDistributionData(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightDistributionData(IfcLightDistributionData *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightDistributionData > createIfcLightDistributionData(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightDistributionData *cloneIfcLightDistributionData(const IfcLightDistributionData &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightFixtureType *getIfcLightFixtureType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightFixtureType(IfcLightFixtureType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightFixtureType > createIfcLightFixtureType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightFixtureType *cloneIfcLightFixtureType(const IfcLightFixtureType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightIntensityDistribution *getIfcLightIntensityDistribution(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightIntensityDistribution(IfcLightIntensityDistribution *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightIntensityDistribution > createIfcLightIntensityDistribution(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightIntensityDistribution *cloneIfcLightIntensityDistribution(const IfcLightIntensityDistribution &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightSourceAmbient *getIfcLightSourceAmbient(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightSourceAmbient(IfcLightSourceAmbient *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightSourceAmbient > createIfcLightSourceAmbient(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightSourceAmbient *cloneIfcLightSourceAmbient(const IfcLightSourceAmbient &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightSourceDirectional *getIfcLightSourceDirectional(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightSourceDirectional(IfcLightSourceDirectional *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightSourceDirectional > createIfcLightSourceDirectional(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightSourceDirectional *cloneIfcLightSourceDirectional(const IfcLightSourceDirectional &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightSourceGoniometric *getIfcLightSourceGoniometric(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightSourceGoniometric(IfcLightSourceGoniometric *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightSourceGoniometric > createIfcLightSourceGoniometric(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightSourceGoniometric *cloneIfcLightSourceGoniometric(const IfcLightSourceGoniometric &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightSourcePositional *getIfcLightSourcePositional(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightSourcePositional(IfcLightSourcePositional *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightSourcePositional > createIfcLightSourcePositional(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightSourcePositional *cloneIfcLightSourcePositional(const IfcLightSourcePositional &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLightSourceSpot *getIfcLightSourceSpot(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLightSourceSpot(IfcLightSourceSpot *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLightSourceSpot > createIfcLightSourceSpot(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLightSourceSpot *cloneIfcLightSourceSpot(const IfcLightSourceSpot &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLine *getIfcLine(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLine(IfcLine *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLine > createIfcLine(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLine *cloneIfcLine(const IfcLine &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLinearDimension *getIfcLinearDimension(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLinearDimension(IfcLinearDimension *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLinearDimension > createIfcLinearDimension(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLinearDimension *cloneIfcLinearDimension(const IfcLinearDimension &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLocalPlacement *getIfcLocalPlacement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLocalPlacement(IfcLocalPlacement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLocalPlacement > createIfcLocalPlacement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLocalPlacement *cloneIfcLocalPlacement(const IfcLocalPlacement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLocalTime *getIfcLocalTime(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLocalTime(IfcLocalTime *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLocalTime > createIfcLocalTime(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLocalTime *cloneIfcLocalTime(const IfcLocalTime &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcLoop *getIfcLoop(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcLoop(IfcLoop *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcLoop > createIfcLoop(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcLoop *cloneIfcLoop(const IfcLoop &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMappedItem *getIfcMappedItem(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMappedItem(IfcMappedItem *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMappedItem > createIfcMappedItem(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMappedItem *cloneIfcMappedItem(const IfcMappedItem &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMaterial *getIfcMaterial(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMaterial(IfcMaterial *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMaterial > createIfcMaterial(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMaterial *cloneIfcMaterial(const IfcMaterial &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMaterialClassificationRelationship *getIfcMaterialClassificationRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMaterialClassificationRelationship(IfcMaterialClassificationRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMaterialClassificationRelationship > createIfcMaterialClassificationRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMaterialClassificationRelationship *cloneIfcMaterialClassificationRelationship(const IfcMaterialClassificationRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMaterialDefinitionRepresentation *getIfcMaterialDefinitionRepresentation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMaterialDefinitionRepresentation(IfcMaterialDefinitionRepresentation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMaterialDefinitionRepresentation > createIfcMaterialDefinitionRepresentation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMaterialDefinitionRepresentation *cloneIfcMaterialDefinitionRepresentation(const IfcMaterialDefinitionRepresentation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMaterialLayer *getIfcMaterialLayer(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMaterialLayer(IfcMaterialLayer *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMaterialLayer > createIfcMaterialLayer(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMaterialLayer *cloneIfcMaterialLayer(const IfcMaterialLayer &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMaterialLayerSet *getIfcMaterialLayerSet(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMaterialLayerSet(IfcMaterialLayerSet *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMaterialLayerSet > createIfcMaterialLayerSet(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMaterialLayerSet *cloneIfcMaterialLayerSet(const IfcMaterialLayerSet &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMaterialLayerSetUsage *getIfcMaterialLayerSetUsage(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMaterialLayerSetUsage(IfcMaterialLayerSetUsage *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMaterialLayerSetUsage > createIfcMaterialLayerSetUsage(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMaterialLayerSetUsage *cloneIfcMaterialLayerSetUsage(const IfcMaterialLayerSetUsage &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMaterialList *getIfcMaterialList(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMaterialList(IfcMaterialList *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMaterialList > createIfcMaterialList(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMaterialList *cloneIfcMaterialList(const IfcMaterialList &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMeasureWithUnit *getIfcMeasureWithUnit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMeasureWithUnit(IfcMeasureWithUnit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMeasureWithUnit > createIfcMeasureWithUnit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMeasureWithUnit *cloneIfcMeasureWithUnit(const IfcMeasureWithUnit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMechanicalConcreteMaterialProperties *getIfcMechanicalConcreteMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMechanicalConcreteMaterialProperties(IfcMechanicalConcreteMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMechanicalConcreteMaterialProperties > createIfcMechanicalConcreteMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMechanicalConcreteMaterialProperties *cloneIfcMechanicalConcreteMaterialProperties(const IfcMechanicalConcreteMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMechanicalFastener *getIfcMechanicalFastener(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMechanicalFastener(IfcMechanicalFastener *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMechanicalFastener > createIfcMechanicalFastener(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMechanicalFastener *cloneIfcMechanicalFastener(const IfcMechanicalFastener &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMechanicalFastenerType *getIfcMechanicalFastenerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMechanicalFastenerType(IfcMechanicalFastenerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMechanicalFastenerType > createIfcMechanicalFastenerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMechanicalFastenerType *cloneIfcMechanicalFastenerType(const IfcMechanicalFastenerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMechanicalMaterialProperties *getIfcMechanicalMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMechanicalMaterialProperties(IfcMechanicalMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMechanicalMaterialProperties > createIfcMechanicalMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMechanicalMaterialProperties *cloneIfcMechanicalMaterialProperties(const IfcMechanicalMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMechanicalSteelMaterialProperties *getIfcMechanicalSteelMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMechanicalSteelMaterialProperties(IfcMechanicalSteelMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMechanicalSteelMaterialProperties > createIfcMechanicalSteelMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMechanicalSteelMaterialProperties *cloneIfcMechanicalSteelMaterialProperties(const IfcMechanicalSteelMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMember *getIfcMember(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMember(IfcMember *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMember > createIfcMember(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMember *cloneIfcMember(const IfcMember &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMemberType *getIfcMemberType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMemberType(IfcMemberType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMemberType > createIfcMemberType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMemberType *cloneIfcMemberType(const IfcMemberType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMetric *getIfcMetric(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMetric(IfcMetric *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMetric > createIfcMetric(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMetric *cloneIfcMetric(const IfcMetric &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMonetaryUnit *getIfcMonetaryUnit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMonetaryUnit(IfcMonetaryUnit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMonetaryUnit > createIfcMonetaryUnit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMonetaryUnit *cloneIfcMonetaryUnit(const IfcMonetaryUnit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMotorConnectionType *getIfcMotorConnectionType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMotorConnectionType(IfcMotorConnectionType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMotorConnectionType > createIfcMotorConnectionType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMotorConnectionType *cloneIfcMotorConnectionType(const IfcMotorConnectionType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcMove *getIfcMove(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcMove(IfcMove *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcMove > createIfcMove(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcMove *cloneIfcMove(const IfcMove &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcObjective *getIfcObjective(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcObjective(IfcObjective *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcObjective > createIfcObjective(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcObjective *cloneIfcObjective(const IfcObjective &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOccupant *getIfcOccupant(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOccupant(IfcOccupant *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOccupant > createIfcOccupant(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOccupant *cloneIfcOccupant(const IfcOccupant &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOffsetCurve2D *getIfcOffsetCurve2D(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOffsetCurve2D(IfcOffsetCurve2D *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOffsetCurve2D > createIfcOffsetCurve2D(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOffsetCurve2D *cloneIfcOffsetCurve2D(const IfcOffsetCurve2D &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOffsetCurve3D *getIfcOffsetCurve3D(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOffsetCurve3D(IfcOffsetCurve3D *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOffsetCurve3D > createIfcOffsetCurve3D(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOffsetCurve3D *cloneIfcOffsetCurve3D(const IfcOffsetCurve3D &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOneDirectionRepeatFactor *getIfcOneDirectionRepeatFactor(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOneDirectionRepeatFactor(IfcOneDirectionRepeatFactor *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOneDirectionRepeatFactor > createIfcOneDirectionRepeatFactor(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOneDirectionRepeatFactor *cloneIfcOneDirectionRepeatFactor(const IfcOneDirectionRepeatFactor &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOpenShell *getIfcOpenShell(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOpenShell(IfcOpenShell *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOpenShell > createIfcOpenShell(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOpenShell *cloneIfcOpenShell(const IfcOpenShell &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOpeningElement *getIfcOpeningElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOpeningElement(IfcOpeningElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOpeningElement > createIfcOpeningElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOpeningElement *cloneIfcOpeningElement(const IfcOpeningElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOpticalMaterialProperties *getIfcOpticalMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOpticalMaterialProperties(IfcOpticalMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOpticalMaterialProperties > createIfcOpticalMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOpticalMaterialProperties *cloneIfcOpticalMaterialProperties(const IfcOpticalMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOrderAction *getIfcOrderAction(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOrderAction(IfcOrderAction *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOrderAction > createIfcOrderAction(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOrderAction *cloneIfcOrderAction(const IfcOrderAction &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOrganization *getIfcOrganization(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOrganization(IfcOrganization *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOrganization > createIfcOrganization(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOrganization *cloneIfcOrganization(const IfcOrganization &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOrganizationRelationship *getIfcOrganizationRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOrganizationRelationship(IfcOrganizationRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOrganizationRelationship > createIfcOrganizationRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOrganizationRelationship *cloneIfcOrganizationRelationship(const IfcOrganizationRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOrientedEdge *getIfcOrientedEdge(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOrientedEdge(IfcOrientedEdge *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOrientedEdge > createIfcOrientedEdge(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOrientedEdge *cloneIfcOrientedEdge(const IfcOrientedEdge &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOutletType *getIfcOutletType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOutletType(IfcOutletType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOutletType > createIfcOutletType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOutletType *cloneIfcOutletType(const IfcOutletType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcOwnerHistory *getIfcOwnerHistory(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcOwnerHistory(IfcOwnerHistory *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcOwnerHistory > createIfcOwnerHistory(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcOwnerHistory *cloneIfcOwnerHistory(const IfcOwnerHistory &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPath *getIfcPath(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPath(IfcPath *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPath > createIfcPath(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPath *cloneIfcPath(const IfcPath &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPerformanceHistory *getIfcPerformanceHistory(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPerformanceHistory(IfcPerformanceHistory *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPerformanceHistory > createIfcPerformanceHistory(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPerformanceHistory *cloneIfcPerformanceHistory(const IfcPerformanceHistory &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPermeableCoveringProperties *getIfcPermeableCoveringProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPermeableCoveringProperties(IfcPermeableCoveringProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPermeableCoveringProperties > createIfcPermeableCoveringProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPermeableCoveringProperties *cloneIfcPermeableCoveringProperties(const IfcPermeableCoveringProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPermit *getIfcPermit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPermit(IfcPermit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPermit > createIfcPermit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPermit *cloneIfcPermit(const IfcPermit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPerson *getIfcPerson(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPerson(IfcPerson *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPerson > createIfcPerson(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPerson *cloneIfcPerson(const IfcPerson &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPersonAndOrganization *getIfcPersonAndOrganization(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPersonAndOrganization(IfcPersonAndOrganization *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPersonAndOrganization > createIfcPersonAndOrganization(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPersonAndOrganization *cloneIfcPersonAndOrganization(const IfcPersonAndOrganization &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPhysicalComplexQuantity *getIfcPhysicalComplexQuantity(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPhysicalComplexQuantity(IfcPhysicalComplexQuantity *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPhysicalComplexQuantity > createIfcPhysicalComplexQuantity(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPhysicalComplexQuantity *cloneIfcPhysicalComplexQuantity(const IfcPhysicalComplexQuantity &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPile *getIfcPile(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPile(IfcPile *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPile > createIfcPile(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPile *cloneIfcPile(const IfcPile &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPipeFittingType *getIfcPipeFittingType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPipeFittingType(IfcPipeFittingType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPipeFittingType > createIfcPipeFittingType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPipeFittingType *cloneIfcPipeFittingType(const IfcPipeFittingType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPipeSegmentType *getIfcPipeSegmentType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPipeSegmentType(IfcPipeSegmentType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPipeSegmentType > createIfcPipeSegmentType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPipeSegmentType *cloneIfcPipeSegmentType(const IfcPipeSegmentType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPixelTexture *getIfcPixelTexture(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPixelTexture(IfcPixelTexture *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPixelTexture > createIfcPixelTexture(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPixelTexture *cloneIfcPixelTexture(const IfcPixelTexture &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPlanarBox *getIfcPlanarBox(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPlanarBox(IfcPlanarBox *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPlanarBox > createIfcPlanarBox(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPlanarBox *cloneIfcPlanarBox(const IfcPlanarBox &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPlanarExtent *getIfcPlanarExtent(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPlanarExtent(IfcPlanarExtent *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPlanarExtent > createIfcPlanarExtent(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPlanarExtent *cloneIfcPlanarExtent(const IfcPlanarExtent &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPlane *getIfcPlane(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPlane(IfcPlane *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPlane > createIfcPlane(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPlane *cloneIfcPlane(const IfcPlane &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPlate *getIfcPlate(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPlate(IfcPlate *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPlate > createIfcPlate(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPlate *cloneIfcPlate(const IfcPlate &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPlateType *getIfcPlateType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPlateType(IfcPlateType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPlateType > createIfcPlateType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPlateType *cloneIfcPlateType(const IfcPlateType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPointOnCurve *getIfcPointOnCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPointOnCurve(IfcPointOnCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPointOnCurve > createIfcPointOnCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPointOnCurve *cloneIfcPointOnCurve(const IfcPointOnCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPointOnSurface *getIfcPointOnSurface(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPointOnSurface(IfcPointOnSurface *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPointOnSurface > createIfcPointOnSurface(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPointOnSurface *cloneIfcPointOnSurface(const IfcPointOnSurface &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPolyLoop *getIfcPolyLoop(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPolyLoop(IfcPolyLoop *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPolyLoop > createIfcPolyLoop(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPolyLoop *cloneIfcPolyLoop(const IfcPolyLoop &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPolygonalBoundedHalfSpace *getIfcPolygonalBoundedHalfSpace(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPolygonalBoundedHalfSpace(IfcPolygonalBoundedHalfSpace *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPolygonalBoundedHalfSpace > createIfcPolygonalBoundedHalfSpace(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPolygonalBoundedHalfSpace *cloneIfcPolygonalBoundedHalfSpace(const IfcPolygonalBoundedHalfSpace &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPolyline *getIfcPolyline(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPolyline(IfcPolyline *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPolyline > createIfcPolyline(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPolyline *cloneIfcPolyline(const IfcPolyline &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPostalAddress *getIfcPostalAddress(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPostalAddress(IfcPostalAddress *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPostalAddress > createIfcPostalAddress(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPostalAddress *cloneIfcPostalAddress(const IfcPostalAddress &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPreDefinedDimensionSymbol *getIfcPreDefinedDimensionSymbol(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPreDefinedDimensionSymbol(IfcPreDefinedDimensionSymbol *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPreDefinedDimensionSymbol > createIfcPreDefinedDimensionSymbol(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPreDefinedDimensionSymbol *cloneIfcPreDefinedDimensionSymbol(const IfcPreDefinedDimensionSymbol &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPreDefinedPointMarkerSymbol *getIfcPreDefinedPointMarkerSymbol(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPreDefinedPointMarkerSymbol(IfcPreDefinedPointMarkerSymbol *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPreDefinedPointMarkerSymbol > createIfcPreDefinedPointMarkerSymbol(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPreDefinedPointMarkerSymbol *cloneIfcPreDefinedPointMarkerSymbol(const IfcPreDefinedPointMarkerSymbol &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPreDefinedTerminatorSymbol *getIfcPreDefinedTerminatorSymbol(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPreDefinedTerminatorSymbol(IfcPreDefinedTerminatorSymbol *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPreDefinedTerminatorSymbol > createIfcPreDefinedTerminatorSymbol(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPreDefinedTerminatorSymbol *cloneIfcPreDefinedTerminatorSymbol(const IfcPreDefinedTerminatorSymbol &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPresentationLayerAssignment *getIfcPresentationLayerAssignment(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPresentationLayerAssignment(IfcPresentationLayerAssignment *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPresentationLayerAssignment > createIfcPresentationLayerAssignment(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPresentationLayerAssignment *cloneIfcPresentationLayerAssignment(const IfcPresentationLayerAssignment &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPresentationLayerWithStyle *getIfcPresentationLayerWithStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPresentationLayerWithStyle(IfcPresentationLayerWithStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPresentationLayerWithStyle > createIfcPresentationLayerWithStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPresentationLayerWithStyle *cloneIfcPresentationLayerWithStyle(const IfcPresentationLayerWithStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPresentationStyleAssignment *getIfcPresentationStyleAssignment(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPresentationStyleAssignment(IfcPresentationStyleAssignment *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPresentationStyleAssignment > createIfcPresentationStyleAssignment(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPresentationStyleAssignment *cloneIfcPresentationStyleAssignment(const IfcPresentationStyleAssignment &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProcedure *getIfcProcedure(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProcedure(IfcProcedure *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProcedure > createIfcProcedure(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProcedure *cloneIfcProcedure(const IfcProcedure &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProductDefinitionShape *getIfcProductDefinitionShape(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProductDefinitionShape(IfcProductDefinitionShape *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProductDefinitionShape > createIfcProductDefinitionShape(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProductDefinitionShape *cloneIfcProductDefinitionShape(const IfcProductDefinitionShape &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProductRepresentation *getIfcProductRepresentation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProductRepresentation(IfcProductRepresentation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProductRepresentation > createIfcProductRepresentation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProductRepresentation *cloneIfcProductRepresentation(const IfcProductRepresentation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProductsOfCombustionProperties *getIfcProductsOfCombustionProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProductsOfCombustionProperties(IfcProductsOfCombustionProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProductsOfCombustionProperties > createIfcProductsOfCombustionProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProductsOfCombustionProperties *cloneIfcProductsOfCombustionProperties(const IfcProductsOfCombustionProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProject *getIfcProject(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProject(IfcProject *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProject > createIfcProject(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProject *cloneIfcProject(const IfcProject &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProjectOrder *getIfcProjectOrder(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProjectOrder(IfcProjectOrder *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProjectOrder > createIfcProjectOrder(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProjectOrder *cloneIfcProjectOrder(const IfcProjectOrder &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProjectOrderRecord *getIfcProjectOrderRecord(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProjectOrderRecord(IfcProjectOrderRecord *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProjectOrderRecord > createIfcProjectOrderRecord(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProjectOrderRecord *cloneIfcProjectOrderRecord(const IfcProjectOrderRecord &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProjectionCurve *getIfcProjectionCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProjectionCurve(IfcProjectionCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProjectionCurve > createIfcProjectionCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProjectionCurve *cloneIfcProjectionCurve(const IfcProjectionCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProjectionElement *getIfcProjectionElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProjectionElement(IfcProjectionElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProjectionElement > createIfcProjectionElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProjectionElement *cloneIfcProjectionElement(const IfcProjectionElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyBoundedValue *getIfcPropertyBoundedValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyBoundedValue(IfcPropertyBoundedValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyBoundedValue > createIfcPropertyBoundedValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyBoundedValue *cloneIfcPropertyBoundedValue(const IfcPropertyBoundedValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyConstraintRelationship *getIfcPropertyConstraintRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyConstraintRelationship(IfcPropertyConstraintRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyConstraintRelationship > createIfcPropertyConstraintRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyConstraintRelationship *cloneIfcPropertyConstraintRelationship(const IfcPropertyConstraintRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyDependencyRelationship *getIfcPropertyDependencyRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyDependencyRelationship(IfcPropertyDependencyRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyDependencyRelationship > createIfcPropertyDependencyRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyDependencyRelationship *cloneIfcPropertyDependencyRelationship(const IfcPropertyDependencyRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyEnumeratedValue *getIfcPropertyEnumeratedValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyEnumeratedValue(IfcPropertyEnumeratedValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyEnumeratedValue > createIfcPropertyEnumeratedValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyEnumeratedValue *cloneIfcPropertyEnumeratedValue(const IfcPropertyEnumeratedValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyEnumeration *getIfcPropertyEnumeration(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyEnumeration(IfcPropertyEnumeration *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyEnumeration > createIfcPropertyEnumeration(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyEnumeration *cloneIfcPropertyEnumeration(const IfcPropertyEnumeration &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyListValue *getIfcPropertyListValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyListValue(IfcPropertyListValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyListValue > createIfcPropertyListValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyListValue *cloneIfcPropertyListValue(const IfcPropertyListValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyReferenceValue *getIfcPropertyReferenceValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyReferenceValue(IfcPropertyReferenceValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyReferenceValue > createIfcPropertyReferenceValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyReferenceValue *cloneIfcPropertyReferenceValue(const IfcPropertyReferenceValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertySet *getIfcPropertySet(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertySet(IfcPropertySet *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertySet > createIfcPropertySet(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertySet *cloneIfcPropertySet(const IfcPropertySet &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertySingleValue *getIfcPropertySingleValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertySingleValue(IfcPropertySingleValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertySingleValue > createIfcPropertySingleValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertySingleValue *cloneIfcPropertySingleValue(const IfcPropertySingleValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPropertyTableValue *getIfcPropertyTableValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPropertyTableValue(IfcPropertyTableValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPropertyTableValue > createIfcPropertyTableValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPropertyTableValue *cloneIfcPropertyTableValue(const IfcPropertyTableValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProtectiveDeviceType *getIfcProtectiveDeviceType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProtectiveDeviceType(IfcProtectiveDeviceType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProtectiveDeviceType > createIfcProtectiveDeviceType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProtectiveDeviceType *cloneIfcProtectiveDeviceType(const IfcProtectiveDeviceType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcProxy *getIfcProxy(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcProxy(IfcProxy *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcProxy > createIfcProxy(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcProxy *cloneIfcProxy(const IfcProxy &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcPumpType *getIfcPumpType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcPumpType(IfcPumpType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcPumpType > createIfcPumpType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcPumpType *cloneIfcPumpType(const IfcPumpType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcQuantityArea *getIfcQuantityArea(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcQuantityArea(IfcQuantityArea *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcQuantityArea > createIfcQuantityArea(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcQuantityArea *cloneIfcQuantityArea(const IfcQuantityArea &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcQuantityCount *getIfcQuantityCount(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcQuantityCount(IfcQuantityCount *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcQuantityCount > createIfcQuantityCount(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcQuantityCount *cloneIfcQuantityCount(const IfcQuantityCount &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcQuantityLength *getIfcQuantityLength(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcQuantityLength(IfcQuantityLength *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcQuantityLength > createIfcQuantityLength(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcQuantityLength *cloneIfcQuantityLength(const IfcQuantityLength &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcQuantityTime *getIfcQuantityTime(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcQuantityTime(IfcQuantityTime *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcQuantityTime > createIfcQuantityTime(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcQuantityTime *cloneIfcQuantityTime(const IfcQuantityTime &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcQuantityVolume *getIfcQuantityVolume(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcQuantityVolume(IfcQuantityVolume *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcQuantityVolume > createIfcQuantityVolume(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcQuantityVolume *cloneIfcQuantityVolume(const IfcQuantityVolume &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcQuantityWeight *getIfcQuantityWeight(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcQuantityWeight(IfcQuantityWeight *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcQuantityWeight > createIfcQuantityWeight(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcQuantityWeight *cloneIfcQuantityWeight(const IfcQuantityWeight &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRadiusDimension *getIfcRadiusDimension(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRadiusDimension(IfcRadiusDimension *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRadiusDimension > createIfcRadiusDimension(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRadiusDimension *cloneIfcRadiusDimension(const IfcRadiusDimension &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRailing *getIfcRailing(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRailing(IfcRailing *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRailing > createIfcRailing(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRailing *cloneIfcRailing(const IfcRailing &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRailingType *getIfcRailingType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRailingType(IfcRailingType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRailingType > createIfcRailingType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRailingType *cloneIfcRailingType(const IfcRailingType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRamp *getIfcRamp(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRamp(IfcRamp *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRamp > createIfcRamp(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRamp *cloneIfcRamp(const IfcRamp &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRampFlight *getIfcRampFlight(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRampFlight(IfcRampFlight *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRampFlight > createIfcRampFlight(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRampFlight *cloneIfcRampFlight(const IfcRampFlight &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRampFlightType *getIfcRampFlightType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRampFlightType(IfcRampFlightType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRampFlightType > createIfcRampFlightType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRampFlightType *cloneIfcRampFlightType(const IfcRampFlightType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRationalBezierCurve *getIfcRationalBezierCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRationalBezierCurve(IfcRationalBezierCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRationalBezierCurve > createIfcRationalBezierCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRationalBezierCurve *cloneIfcRationalBezierCurve(const IfcRationalBezierCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRectangleHollowProfileDef *getIfcRectangleHollowProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRectangleHollowProfileDef(IfcRectangleHollowProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRectangleHollowProfileDef > createIfcRectangleHollowProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRectangleHollowProfileDef *cloneIfcRectangleHollowProfileDef(const IfcRectangleHollowProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRectangleProfileDef *getIfcRectangleProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRectangleProfileDef(IfcRectangleProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRectangleProfileDef > createIfcRectangleProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRectangleProfileDef *cloneIfcRectangleProfileDef(const IfcRectangleProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRectangularPyramid *getIfcRectangularPyramid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRectangularPyramid(IfcRectangularPyramid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRectangularPyramid > createIfcRectangularPyramid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRectangularPyramid *cloneIfcRectangularPyramid(const IfcRectangularPyramid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRectangularTrimmedSurface *getIfcRectangularTrimmedSurface(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRectangularTrimmedSurface(IfcRectangularTrimmedSurface *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRectangularTrimmedSurface > createIfcRectangularTrimmedSurface(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRectangularTrimmedSurface *cloneIfcRectangularTrimmedSurface(const IfcRectangularTrimmedSurface &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcReferencesValueDocument *getIfcReferencesValueDocument(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcReferencesValueDocument(IfcReferencesValueDocument *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcReferencesValueDocument > createIfcReferencesValueDocument(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcReferencesValueDocument *cloneIfcReferencesValueDocument(const IfcReferencesValueDocument &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRegularTimeSeries *getIfcRegularTimeSeries(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRegularTimeSeries(IfcRegularTimeSeries *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRegularTimeSeries > createIfcRegularTimeSeries(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRegularTimeSeries *cloneIfcRegularTimeSeries(const IfcRegularTimeSeries &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcReinforcementBarProperties *getIfcReinforcementBarProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcReinforcementBarProperties(IfcReinforcementBarProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcReinforcementBarProperties > createIfcReinforcementBarProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcReinforcementBarProperties *cloneIfcReinforcementBarProperties(const IfcReinforcementBarProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcReinforcementDefinitionProperties *getIfcReinforcementDefinitionProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcReinforcementDefinitionProperties(IfcReinforcementDefinitionProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcReinforcementDefinitionProperties > createIfcReinforcementDefinitionProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcReinforcementDefinitionProperties *cloneIfcReinforcementDefinitionProperties(const IfcReinforcementDefinitionProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcReinforcingBar *getIfcReinforcingBar(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcReinforcingBar(IfcReinforcingBar *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcReinforcingBar > createIfcReinforcingBar(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcReinforcingBar *cloneIfcReinforcingBar(const IfcReinforcingBar &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcReinforcingMesh *getIfcReinforcingMesh(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcReinforcingMesh(IfcReinforcingMesh *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcReinforcingMesh > createIfcReinforcingMesh(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcReinforcingMesh *cloneIfcReinforcingMesh(const IfcReinforcingMesh &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAggregates *getIfcRelAggregates(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAggregates(IfcRelAggregates *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAggregates > createIfcRelAggregates(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAggregates *cloneIfcRelAggregates(const IfcRelAggregates &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsTasks *getIfcRelAssignsTasks(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsTasks(IfcRelAssignsTasks *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsTasks > createIfcRelAssignsTasks(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsTasks *cloneIfcRelAssignsTasks(const IfcRelAssignsTasks &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsToActor *getIfcRelAssignsToActor(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsToActor(IfcRelAssignsToActor *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsToActor > createIfcRelAssignsToActor(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsToActor *cloneIfcRelAssignsToActor(const IfcRelAssignsToActor &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsToControl *getIfcRelAssignsToControl(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsToControl(IfcRelAssignsToControl *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsToControl > createIfcRelAssignsToControl(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsToControl *cloneIfcRelAssignsToControl(const IfcRelAssignsToControl &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsToGroup *getIfcRelAssignsToGroup(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsToGroup(IfcRelAssignsToGroup *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsToGroup > createIfcRelAssignsToGroup(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsToGroup *cloneIfcRelAssignsToGroup(const IfcRelAssignsToGroup &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsToProcess *getIfcRelAssignsToProcess(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsToProcess(IfcRelAssignsToProcess *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsToProcess > createIfcRelAssignsToProcess(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsToProcess *cloneIfcRelAssignsToProcess(const IfcRelAssignsToProcess &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsToProduct *getIfcRelAssignsToProduct(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsToProduct(IfcRelAssignsToProduct *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsToProduct > createIfcRelAssignsToProduct(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsToProduct *cloneIfcRelAssignsToProduct(const IfcRelAssignsToProduct &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsToProjectOrder *getIfcRelAssignsToProjectOrder(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsToProjectOrder(IfcRelAssignsToProjectOrder *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsToProjectOrder > createIfcRelAssignsToProjectOrder(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsToProjectOrder *cloneIfcRelAssignsToProjectOrder(const IfcRelAssignsToProjectOrder &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssignsToResource *getIfcRelAssignsToResource(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssignsToResource(IfcRelAssignsToResource *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssignsToResource > createIfcRelAssignsToResource(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssignsToResource *cloneIfcRelAssignsToResource(const IfcRelAssignsToResource &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociates *getIfcRelAssociates(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociates(IfcRelAssociates *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociates > createIfcRelAssociates(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociates *cloneIfcRelAssociates(const IfcRelAssociates &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesAppliedValue *getIfcRelAssociatesAppliedValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesAppliedValue(IfcRelAssociatesAppliedValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesAppliedValue > createIfcRelAssociatesAppliedValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesAppliedValue *cloneIfcRelAssociatesAppliedValue(const IfcRelAssociatesAppliedValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesApproval *getIfcRelAssociatesApproval(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesApproval(IfcRelAssociatesApproval *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesApproval > createIfcRelAssociatesApproval(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesApproval *cloneIfcRelAssociatesApproval(const IfcRelAssociatesApproval &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesClassification *getIfcRelAssociatesClassification(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesClassification(IfcRelAssociatesClassification *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesClassification > createIfcRelAssociatesClassification(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesClassification *cloneIfcRelAssociatesClassification(const IfcRelAssociatesClassification &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesConstraint *getIfcRelAssociatesConstraint(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesConstraint(IfcRelAssociatesConstraint *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesConstraint > createIfcRelAssociatesConstraint(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesConstraint *cloneIfcRelAssociatesConstraint(const IfcRelAssociatesConstraint &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesDocument *getIfcRelAssociatesDocument(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesDocument(IfcRelAssociatesDocument *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesDocument > createIfcRelAssociatesDocument(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesDocument *cloneIfcRelAssociatesDocument(const IfcRelAssociatesDocument &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesLibrary *getIfcRelAssociatesLibrary(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesLibrary(IfcRelAssociatesLibrary *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesLibrary > createIfcRelAssociatesLibrary(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesLibrary *cloneIfcRelAssociatesLibrary(const IfcRelAssociatesLibrary &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesMaterial *getIfcRelAssociatesMaterial(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesMaterial(IfcRelAssociatesMaterial *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesMaterial > createIfcRelAssociatesMaterial(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesMaterial *cloneIfcRelAssociatesMaterial(const IfcRelAssociatesMaterial &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelAssociatesProfileProperties *getIfcRelAssociatesProfileProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelAssociatesProfileProperties(IfcRelAssociatesProfileProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelAssociatesProfileProperties > createIfcRelAssociatesProfileProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelAssociatesProfileProperties *cloneIfcRelAssociatesProfileProperties(const IfcRelAssociatesProfileProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsElements *getIfcRelConnectsElements(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsElements(IfcRelConnectsElements *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsElements > createIfcRelConnectsElements(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsElements *cloneIfcRelConnectsElements(const IfcRelConnectsElements &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsPathElements *getIfcRelConnectsPathElements(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsPathElements(IfcRelConnectsPathElements *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsPathElements > createIfcRelConnectsPathElements(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsPathElements *cloneIfcRelConnectsPathElements(const IfcRelConnectsPathElements &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsPortToElement *getIfcRelConnectsPortToElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsPortToElement(IfcRelConnectsPortToElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsPortToElement > createIfcRelConnectsPortToElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsPortToElement *cloneIfcRelConnectsPortToElement(const IfcRelConnectsPortToElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsPorts *getIfcRelConnectsPorts(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsPorts(IfcRelConnectsPorts *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsPorts > createIfcRelConnectsPorts(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsPorts *cloneIfcRelConnectsPorts(const IfcRelConnectsPorts &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsStructuralActivity *getIfcRelConnectsStructuralActivity(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsStructuralActivity(IfcRelConnectsStructuralActivity *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsStructuralActivity > createIfcRelConnectsStructuralActivity(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsStructuralActivity *cloneIfcRelConnectsStructuralActivity(const IfcRelConnectsStructuralActivity &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsStructuralElement *getIfcRelConnectsStructuralElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsStructuralElement(IfcRelConnectsStructuralElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsStructuralElement > createIfcRelConnectsStructuralElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsStructuralElement *cloneIfcRelConnectsStructuralElement(const IfcRelConnectsStructuralElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsStructuralMember *getIfcRelConnectsStructuralMember(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsStructuralMember(IfcRelConnectsStructuralMember *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsStructuralMember > createIfcRelConnectsStructuralMember(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsStructuralMember *cloneIfcRelConnectsStructuralMember(const IfcRelConnectsStructuralMember &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsWithEccentricity *getIfcRelConnectsWithEccentricity(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsWithEccentricity(IfcRelConnectsWithEccentricity *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsWithEccentricity > createIfcRelConnectsWithEccentricity(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsWithEccentricity *cloneIfcRelConnectsWithEccentricity(const IfcRelConnectsWithEccentricity &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelConnectsWithRealizingElements *getIfcRelConnectsWithRealizingElements(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelConnectsWithRealizingElements(IfcRelConnectsWithRealizingElements *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelConnectsWithRealizingElements > createIfcRelConnectsWithRealizingElements(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelConnectsWithRealizingElements *cloneIfcRelConnectsWithRealizingElements(const IfcRelConnectsWithRealizingElements &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelContainedInSpatialStructure *getIfcRelContainedInSpatialStructure(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelContainedInSpatialStructure(IfcRelContainedInSpatialStructure *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelContainedInSpatialStructure > createIfcRelContainedInSpatialStructure(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelContainedInSpatialStructure *cloneIfcRelContainedInSpatialStructure(const IfcRelContainedInSpatialStructure &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelCoversBldgElements *getIfcRelCoversBldgElements(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelCoversBldgElements(IfcRelCoversBldgElements *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelCoversBldgElements > createIfcRelCoversBldgElements(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelCoversBldgElements *cloneIfcRelCoversBldgElements(const IfcRelCoversBldgElements &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelCoversSpaces *getIfcRelCoversSpaces(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelCoversSpaces(IfcRelCoversSpaces *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelCoversSpaces > createIfcRelCoversSpaces(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelCoversSpaces *cloneIfcRelCoversSpaces(const IfcRelCoversSpaces &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelDefinesByProperties *getIfcRelDefinesByProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelDefinesByProperties(IfcRelDefinesByProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelDefinesByProperties > createIfcRelDefinesByProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelDefinesByProperties *cloneIfcRelDefinesByProperties(const IfcRelDefinesByProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelDefinesByType *getIfcRelDefinesByType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelDefinesByType(IfcRelDefinesByType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelDefinesByType > createIfcRelDefinesByType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelDefinesByType *cloneIfcRelDefinesByType(const IfcRelDefinesByType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelFillsElement *getIfcRelFillsElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelFillsElement(IfcRelFillsElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelFillsElement > createIfcRelFillsElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelFillsElement *cloneIfcRelFillsElement(const IfcRelFillsElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelFlowControlElements *getIfcRelFlowControlElements(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelFlowControlElements(IfcRelFlowControlElements *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelFlowControlElements > createIfcRelFlowControlElements(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelFlowControlElements *cloneIfcRelFlowControlElements(const IfcRelFlowControlElements &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelInteractionRequirements *getIfcRelInteractionRequirements(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelInteractionRequirements(IfcRelInteractionRequirements *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelInteractionRequirements > createIfcRelInteractionRequirements(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelInteractionRequirements *cloneIfcRelInteractionRequirements(const IfcRelInteractionRequirements &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelNests *getIfcRelNests(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelNests(IfcRelNests *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelNests > createIfcRelNests(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelNests *cloneIfcRelNests(const IfcRelNests &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelOccupiesSpaces *getIfcRelOccupiesSpaces(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelOccupiesSpaces(IfcRelOccupiesSpaces *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelOccupiesSpaces > createIfcRelOccupiesSpaces(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelOccupiesSpaces *cloneIfcRelOccupiesSpaces(const IfcRelOccupiesSpaces &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelOverridesProperties *getIfcRelOverridesProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelOverridesProperties(IfcRelOverridesProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelOverridesProperties > createIfcRelOverridesProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelOverridesProperties *cloneIfcRelOverridesProperties(const IfcRelOverridesProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelProjectsElement *getIfcRelProjectsElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelProjectsElement(IfcRelProjectsElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelProjectsElement > createIfcRelProjectsElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelProjectsElement *cloneIfcRelProjectsElement(const IfcRelProjectsElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelReferencedInSpatialStructure *getIfcRelReferencedInSpatialStructure(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelReferencedInSpatialStructure(IfcRelReferencedInSpatialStructure *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelReferencedInSpatialStructure > createIfcRelReferencedInSpatialStructure(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelReferencedInSpatialStructure *cloneIfcRelReferencedInSpatialStructure(const IfcRelReferencedInSpatialStructure &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelSchedulesCostItems *getIfcRelSchedulesCostItems(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelSchedulesCostItems(IfcRelSchedulesCostItems *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelSchedulesCostItems > createIfcRelSchedulesCostItems(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelSchedulesCostItems *cloneIfcRelSchedulesCostItems(const IfcRelSchedulesCostItems &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelSequence *getIfcRelSequence(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelSequence(IfcRelSequence *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelSequence > createIfcRelSequence(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelSequence *cloneIfcRelSequence(const IfcRelSequence &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelServicesBuildings *getIfcRelServicesBuildings(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelServicesBuildings(IfcRelServicesBuildings *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelServicesBuildings > createIfcRelServicesBuildings(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelServicesBuildings *cloneIfcRelServicesBuildings(const IfcRelServicesBuildings &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelSpaceBoundary *getIfcRelSpaceBoundary(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelSpaceBoundary(IfcRelSpaceBoundary *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelSpaceBoundary > createIfcRelSpaceBoundary(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelSpaceBoundary *cloneIfcRelSpaceBoundary(const IfcRelSpaceBoundary &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelVoidsElement *getIfcRelVoidsElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelVoidsElement(IfcRelVoidsElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelVoidsElement > createIfcRelVoidsElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelVoidsElement *cloneIfcRelVoidsElement(const IfcRelVoidsElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRelaxation *getIfcRelaxation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRelaxation(IfcRelaxation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRelaxation > createIfcRelaxation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRelaxation *cloneIfcRelaxation(const IfcRelaxation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRepresentation *getIfcRepresentation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRepresentation(IfcRepresentation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRepresentation > createIfcRepresentation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRepresentation *cloneIfcRepresentation(const IfcRepresentation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRepresentationContext *getIfcRepresentationContext(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRepresentationContext(IfcRepresentationContext *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRepresentationContext > createIfcRepresentationContext(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRepresentationContext *cloneIfcRepresentationContext(const IfcRepresentationContext &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRepresentationMap *getIfcRepresentationMap(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRepresentationMap(IfcRepresentationMap *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRepresentationMap > createIfcRepresentationMap(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRepresentationMap *cloneIfcRepresentationMap(const IfcRepresentationMap &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRevolvedAreaSolid *getIfcRevolvedAreaSolid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRevolvedAreaSolid(IfcRevolvedAreaSolid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRevolvedAreaSolid > createIfcRevolvedAreaSolid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRevolvedAreaSolid *cloneIfcRevolvedAreaSolid(const IfcRevolvedAreaSolid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRibPlateProfileProperties *getIfcRibPlateProfileProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRibPlateProfileProperties(IfcRibPlateProfileProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRibPlateProfileProperties > createIfcRibPlateProfileProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRibPlateProfileProperties *cloneIfcRibPlateProfileProperties(const IfcRibPlateProfileProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRightCircularCone *getIfcRightCircularCone(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRightCircularCone(IfcRightCircularCone *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRightCircularCone > createIfcRightCircularCone(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRightCircularCone *cloneIfcRightCircularCone(const IfcRightCircularCone &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRightCircularCylinder *getIfcRightCircularCylinder(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRightCircularCylinder(IfcRightCircularCylinder *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRightCircularCylinder > createIfcRightCircularCylinder(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRightCircularCylinder *cloneIfcRightCircularCylinder(const IfcRightCircularCylinder &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRoof *getIfcRoof(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRoof(IfcRoof *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRoof > createIfcRoof(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRoof *cloneIfcRoof(const IfcRoof &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRoundedEdgeFeature *getIfcRoundedEdgeFeature(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRoundedEdgeFeature(IfcRoundedEdgeFeature *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRoundedEdgeFeature > createIfcRoundedEdgeFeature(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRoundedEdgeFeature *cloneIfcRoundedEdgeFeature(const IfcRoundedEdgeFeature &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcRoundedRectangleProfileDef *getIfcRoundedRectangleProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcRoundedRectangleProfileDef(IfcRoundedRectangleProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcRoundedRectangleProfileDef > createIfcRoundedRectangleProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcRoundedRectangleProfileDef *cloneIfcRoundedRectangleProfileDef(const IfcRoundedRectangleProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSIUnit *getIfcSIUnit(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSIUnit(IfcSIUnit *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSIUnit > createIfcSIUnit(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSIUnit *cloneIfcSIUnit(const IfcSIUnit &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSanitaryTerminalType *getIfcSanitaryTerminalType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSanitaryTerminalType(IfcSanitaryTerminalType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSanitaryTerminalType > createIfcSanitaryTerminalType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSanitaryTerminalType *cloneIfcSanitaryTerminalType(const IfcSanitaryTerminalType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcScheduleTimeControl *getIfcScheduleTimeControl(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcScheduleTimeControl(IfcScheduleTimeControl *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcScheduleTimeControl > createIfcScheduleTimeControl(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcScheduleTimeControl *cloneIfcScheduleTimeControl(const IfcScheduleTimeControl &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSectionProperties *getIfcSectionProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSectionProperties(IfcSectionProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSectionProperties > createIfcSectionProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSectionProperties *cloneIfcSectionProperties(const IfcSectionProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSectionReinforcementProperties *getIfcSectionReinforcementProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSectionReinforcementProperties(IfcSectionReinforcementProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSectionReinforcementProperties > createIfcSectionReinforcementProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSectionReinforcementProperties *cloneIfcSectionReinforcementProperties(const IfcSectionReinforcementProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSectionedSpine *getIfcSectionedSpine(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSectionedSpine(IfcSectionedSpine *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSectionedSpine > createIfcSectionedSpine(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSectionedSpine *cloneIfcSectionedSpine(const IfcSectionedSpine &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSensorType *getIfcSensorType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSensorType(IfcSensorType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSensorType > createIfcSensorType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSensorType *cloneIfcSensorType(const IfcSensorType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcServiceLife *getIfcServiceLife(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcServiceLife(IfcServiceLife *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcServiceLife > createIfcServiceLife(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcServiceLife *cloneIfcServiceLife(const IfcServiceLife &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcServiceLifeFactor *getIfcServiceLifeFactor(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcServiceLifeFactor(IfcServiceLifeFactor *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcServiceLifeFactor > createIfcServiceLifeFactor(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcServiceLifeFactor *cloneIfcServiceLifeFactor(const IfcServiceLifeFactor &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcShapeAspect *getIfcShapeAspect(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcShapeAspect(IfcShapeAspect *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcShapeAspect > createIfcShapeAspect(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcShapeAspect *cloneIfcShapeAspect(const IfcShapeAspect &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcShapeRepresentation *getIfcShapeRepresentation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcShapeRepresentation(IfcShapeRepresentation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcShapeRepresentation > createIfcShapeRepresentation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcShapeRepresentation *cloneIfcShapeRepresentation(const IfcShapeRepresentation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcShellBasedSurfaceModel *getIfcShellBasedSurfaceModel(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcShellBasedSurfaceModel(IfcShellBasedSurfaceModel *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcShellBasedSurfaceModel > createIfcShellBasedSurfaceModel(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcShellBasedSurfaceModel *cloneIfcShellBasedSurfaceModel(const IfcShellBasedSurfaceModel &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSite *getIfcSite(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSite(IfcSite *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSite > createIfcSite(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSite *cloneIfcSite(const IfcSite &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSlab *getIfcSlab(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSlab(IfcSlab *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSlab > createIfcSlab(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSlab *cloneIfcSlab(const IfcSlab &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSlabType *getIfcSlabType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSlabType(IfcSlabType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSlabType > createIfcSlabType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSlabType *cloneIfcSlabType(const IfcSlabType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSlippageConnectionCondition *getIfcSlippageConnectionCondition(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSlippageConnectionCondition(IfcSlippageConnectionCondition *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSlippageConnectionCondition > createIfcSlippageConnectionCondition(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSlippageConnectionCondition *cloneIfcSlippageConnectionCondition(const IfcSlippageConnectionCondition &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSoundProperties *getIfcSoundProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSoundProperties(IfcSoundProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSoundProperties > createIfcSoundProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSoundProperties *cloneIfcSoundProperties(const IfcSoundProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSoundValue *getIfcSoundValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSoundValue(IfcSoundValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSoundValue > createIfcSoundValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSoundValue *cloneIfcSoundValue(const IfcSoundValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSpace *getIfcSpace(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSpace(IfcSpace *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSpace > createIfcSpace(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSpace *cloneIfcSpace(const IfcSpace &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSpaceHeaterType *getIfcSpaceHeaterType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSpaceHeaterType(IfcSpaceHeaterType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSpaceHeaterType > createIfcSpaceHeaterType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSpaceHeaterType *cloneIfcSpaceHeaterType(const IfcSpaceHeaterType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSpaceProgram *getIfcSpaceProgram(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSpaceProgram(IfcSpaceProgram *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSpaceProgram > createIfcSpaceProgram(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSpaceProgram *cloneIfcSpaceProgram(const IfcSpaceProgram &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSpaceThermalLoadProperties *getIfcSpaceThermalLoadProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSpaceThermalLoadProperties(IfcSpaceThermalLoadProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSpaceThermalLoadProperties > createIfcSpaceThermalLoadProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSpaceThermalLoadProperties *cloneIfcSpaceThermalLoadProperties(const IfcSpaceThermalLoadProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSpaceType *getIfcSpaceType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSpaceType(IfcSpaceType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSpaceType > createIfcSpaceType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSpaceType *cloneIfcSpaceType(const IfcSpaceType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSphere *getIfcSphere(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSphere(IfcSphere *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSphere > createIfcSphere(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSphere *cloneIfcSphere(const IfcSphere &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStackTerminalType *getIfcStackTerminalType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStackTerminalType(IfcStackTerminalType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStackTerminalType > createIfcStackTerminalType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStackTerminalType *cloneIfcStackTerminalType(const IfcStackTerminalType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStair *getIfcStair(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStair(IfcStair *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStair > createIfcStair(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStair *cloneIfcStair(const IfcStair &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStairFlight *getIfcStairFlight(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStairFlight(IfcStairFlight *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStairFlight > createIfcStairFlight(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStairFlight *cloneIfcStairFlight(const IfcStairFlight &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStairFlightType *getIfcStairFlightType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStairFlightType(IfcStairFlightType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStairFlightType > createIfcStairFlightType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStairFlightType *cloneIfcStairFlightType(const IfcStairFlightType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralAnalysisModel *getIfcStructuralAnalysisModel(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralAnalysisModel(IfcStructuralAnalysisModel *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralAnalysisModel > createIfcStructuralAnalysisModel(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralAnalysisModel *cloneIfcStructuralAnalysisModel(const IfcStructuralAnalysisModel &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralCurveConnection *getIfcStructuralCurveConnection(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralCurveConnection(IfcStructuralCurveConnection *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralCurveConnection > createIfcStructuralCurveConnection(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralCurveConnection *cloneIfcStructuralCurveConnection(const IfcStructuralCurveConnection &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralCurveMember *getIfcStructuralCurveMember(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralCurveMember(IfcStructuralCurveMember *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralCurveMember > createIfcStructuralCurveMember(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralCurveMember *cloneIfcStructuralCurveMember(const IfcStructuralCurveMember &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralCurveMemberVarying *getIfcStructuralCurveMemberVarying(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralCurveMemberVarying(IfcStructuralCurveMemberVarying *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralCurveMemberVarying > createIfcStructuralCurveMemberVarying(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralCurveMemberVarying *cloneIfcStructuralCurveMemberVarying(const IfcStructuralCurveMemberVarying &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLinearAction *getIfcStructuralLinearAction(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLinearAction(IfcStructuralLinearAction *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLinearAction > createIfcStructuralLinearAction(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLinearAction *cloneIfcStructuralLinearAction(const IfcStructuralLinearAction &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLinearActionVarying *getIfcStructuralLinearActionVarying(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLinearActionVarying(IfcStructuralLinearActionVarying *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLinearActionVarying > createIfcStructuralLinearActionVarying(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLinearActionVarying *cloneIfcStructuralLinearActionVarying(const IfcStructuralLinearActionVarying &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadGroup *getIfcStructuralLoadGroup(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadGroup(IfcStructuralLoadGroup *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadGroup > createIfcStructuralLoadGroup(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadGroup *cloneIfcStructuralLoadGroup(const IfcStructuralLoadGroup &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadLinearForce *getIfcStructuralLoadLinearForce(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadLinearForce(IfcStructuralLoadLinearForce *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadLinearForce > createIfcStructuralLoadLinearForce(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadLinearForce *cloneIfcStructuralLoadLinearForce(const IfcStructuralLoadLinearForce &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadPlanarForce *getIfcStructuralLoadPlanarForce(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadPlanarForce(IfcStructuralLoadPlanarForce *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadPlanarForce > createIfcStructuralLoadPlanarForce(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadPlanarForce *cloneIfcStructuralLoadPlanarForce(const IfcStructuralLoadPlanarForce &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadSingleDisplacement *getIfcStructuralLoadSingleDisplacement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadSingleDisplacement(IfcStructuralLoadSingleDisplacement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadSingleDisplacement > createIfcStructuralLoadSingleDisplacement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadSingleDisplacement *cloneIfcStructuralLoadSingleDisplacement(const IfcStructuralLoadSingleDisplacement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadSingleDisplacementDistortion *getIfcStructuralLoadSingleDisplacementDistortion(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadSingleDisplacementDistortion(IfcStructuralLoadSingleDisplacementDistortion *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadSingleDisplacementDistortion > createIfcStructuralLoadSingleDisplacementDistortion(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadSingleDisplacementDistortion *cloneIfcStructuralLoadSingleDisplacementDistortion(const IfcStructuralLoadSingleDisplacementDistortion &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadSingleForce *getIfcStructuralLoadSingleForce(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadSingleForce(IfcStructuralLoadSingleForce *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadSingleForce > createIfcStructuralLoadSingleForce(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadSingleForce *cloneIfcStructuralLoadSingleForce(const IfcStructuralLoadSingleForce &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadSingleForceWarping *getIfcStructuralLoadSingleForceWarping(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadSingleForceWarping(IfcStructuralLoadSingleForceWarping *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadSingleForceWarping > createIfcStructuralLoadSingleForceWarping(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadSingleForceWarping *cloneIfcStructuralLoadSingleForceWarping(const IfcStructuralLoadSingleForceWarping &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralLoadTemperature *getIfcStructuralLoadTemperature(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralLoadTemperature(IfcStructuralLoadTemperature *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralLoadTemperature > createIfcStructuralLoadTemperature(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralLoadTemperature *cloneIfcStructuralLoadTemperature(const IfcStructuralLoadTemperature &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralPlanarAction *getIfcStructuralPlanarAction(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralPlanarAction(IfcStructuralPlanarAction *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralPlanarAction > createIfcStructuralPlanarAction(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralPlanarAction *cloneIfcStructuralPlanarAction(const IfcStructuralPlanarAction &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralPlanarActionVarying *getIfcStructuralPlanarActionVarying(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralPlanarActionVarying(IfcStructuralPlanarActionVarying *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralPlanarActionVarying > createIfcStructuralPlanarActionVarying(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralPlanarActionVarying *cloneIfcStructuralPlanarActionVarying(const IfcStructuralPlanarActionVarying &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralPointAction *getIfcStructuralPointAction(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralPointAction(IfcStructuralPointAction *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralPointAction > createIfcStructuralPointAction(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralPointAction *cloneIfcStructuralPointAction(const IfcStructuralPointAction &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralPointConnection *getIfcStructuralPointConnection(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralPointConnection(IfcStructuralPointConnection *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralPointConnection > createIfcStructuralPointConnection(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralPointConnection *cloneIfcStructuralPointConnection(const IfcStructuralPointConnection &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralPointReaction *getIfcStructuralPointReaction(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralPointReaction(IfcStructuralPointReaction *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralPointReaction > createIfcStructuralPointReaction(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralPointReaction *cloneIfcStructuralPointReaction(const IfcStructuralPointReaction &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralProfileProperties *getIfcStructuralProfileProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralProfileProperties(IfcStructuralProfileProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralProfileProperties > createIfcStructuralProfileProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralProfileProperties *cloneIfcStructuralProfileProperties(const IfcStructuralProfileProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralResultGroup *getIfcStructuralResultGroup(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralResultGroup(IfcStructuralResultGroup *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralResultGroup > createIfcStructuralResultGroup(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralResultGroup *cloneIfcStructuralResultGroup(const IfcStructuralResultGroup &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralSteelProfileProperties *getIfcStructuralSteelProfileProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralSteelProfileProperties(IfcStructuralSteelProfileProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralSteelProfileProperties > createIfcStructuralSteelProfileProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralSteelProfileProperties *cloneIfcStructuralSteelProfileProperties(const IfcStructuralSteelProfileProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralSurfaceConnection *getIfcStructuralSurfaceConnection(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralSurfaceConnection(IfcStructuralSurfaceConnection *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralSurfaceConnection > createIfcStructuralSurfaceConnection(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralSurfaceConnection *cloneIfcStructuralSurfaceConnection(const IfcStructuralSurfaceConnection &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralSurfaceMember *getIfcStructuralSurfaceMember(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralSurfaceMember(IfcStructuralSurfaceMember *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralSurfaceMember > createIfcStructuralSurfaceMember(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralSurfaceMember *cloneIfcStructuralSurfaceMember(const IfcStructuralSurfaceMember &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuralSurfaceMemberVarying *getIfcStructuralSurfaceMemberVarying(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuralSurfaceMemberVarying(IfcStructuralSurfaceMemberVarying *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuralSurfaceMemberVarying > createIfcStructuralSurfaceMemberVarying(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuralSurfaceMemberVarying *cloneIfcStructuralSurfaceMemberVarying(const IfcStructuralSurfaceMemberVarying &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStructuredDimensionCallout *getIfcStructuredDimensionCallout(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStructuredDimensionCallout(IfcStructuredDimensionCallout *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStructuredDimensionCallout > createIfcStructuredDimensionCallout(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStructuredDimensionCallout *cloneIfcStructuredDimensionCallout(const IfcStructuredDimensionCallout &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStyledItem *getIfcStyledItem(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStyledItem(IfcStyledItem *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStyledItem > createIfcStyledItem(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStyledItem *cloneIfcStyledItem(const IfcStyledItem &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcStyledRepresentation *getIfcStyledRepresentation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcStyledRepresentation(IfcStyledRepresentation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcStyledRepresentation > createIfcStyledRepresentation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcStyledRepresentation *cloneIfcStyledRepresentation(const IfcStyledRepresentation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSubContractResource *getIfcSubContractResource(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSubContractResource(IfcSubContractResource *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSubContractResource > createIfcSubContractResource(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSubContractResource *cloneIfcSubContractResource(const IfcSubContractResource &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSubedge *getIfcSubedge(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSubedge(IfcSubedge *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSubedge > createIfcSubedge(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSubedge *cloneIfcSubedge(const IfcSubedge &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceCurveSweptAreaSolid *getIfcSurfaceCurveSweptAreaSolid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceCurveSweptAreaSolid(IfcSurfaceCurveSweptAreaSolid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceCurveSweptAreaSolid > createIfcSurfaceCurveSweptAreaSolid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceCurveSweptAreaSolid *cloneIfcSurfaceCurveSweptAreaSolid(const IfcSurfaceCurveSweptAreaSolid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceOfLinearExtrusion *getIfcSurfaceOfLinearExtrusion(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceOfLinearExtrusion(IfcSurfaceOfLinearExtrusion *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceOfLinearExtrusion > createIfcSurfaceOfLinearExtrusion(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceOfLinearExtrusion *cloneIfcSurfaceOfLinearExtrusion(const IfcSurfaceOfLinearExtrusion &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceOfRevolution *getIfcSurfaceOfRevolution(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceOfRevolution(IfcSurfaceOfRevolution *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceOfRevolution > createIfcSurfaceOfRevolution(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceOfRevolution *cloneIfcSurfaceOfRevolution(const IfcSurfaceOfRevolution &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceStyle *getIfcSurfaceStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceStyle(IfcSurfaceStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceStyle > createIfcSurfaceStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceStyle *cloneIfcSurfaceStyle(const IfcSurfaceStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceStyleLighting *getIfcSurfaceStyleLighting(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceStyleLighting(IfcSurfaceStyleLighting *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceStyleLighting > createIfcSurfaceStyleLighting(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceStyleLighting *cloneIfcSurfaceStyleLighting(const IfcSurfaceStyleLighting &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceStyleRefraction *getIfcSurfaceStyleRefraction(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceStyleRefraction(IfcSurfaceStyleRefraction *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceStyleRefraction > createIfcSurfaceStyleRefraction(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceStyleRefraction *cloneIfcSurfaceStyleRefraction(const IfcSurfaceStyleRefraction &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceStyleRendering *getIfcSurfaceStyleRendering(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceStyleRendering(IfcSurfaceStyleRendering *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceStyleRendering > createIfcSurfaceStyleRendering(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceStyleRendering *cloneIfcSurfaceStyleRendering(const IfcSurfaceStyleRendering &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceStyleShading *getIfcSurfaceStyleShading(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceStyleShading(IfcSurfaceStyleShading *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceStyleShading > createIfcSurfaceStyleShading(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceStyleShading *cloneIfcSurfaceStyleShading(const IfcSurfaceStyleShading &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSurfaceStyleWithTextures *getIfcSurfaceStyleWithTextures(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSurfaceStyleWithTextures(IfcSurfaceStyleWithTextures *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSurfaceStyleWithTextures > createIfcSurfaceStyleWithTextures(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSurfaceStyleWithTextures *cloneIfcSurfaceStyleWithTextures(const IfcSurfaceStyleWithTextures &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSweptDiskSolid *getIfcSweptDiskSolid(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSweptDiskSolid(IfcSweptDiskSolid *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSweptDiskSolid > createIfcSweptDiskSolid(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSweptDiskSolid *cloneIfcSweptDiskSolid(const IfcSweptDiskSolid &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSwitchingDeviceType *getIfcSwitchingDeviceType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSwitchingDeviceType(IfcSwitchingDeviceType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSwitchingDeviceType > createIfcSwitchingDeviceType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSwitchingDeviceType *cloneIfcSwitchingDeviceType(const IfcSwitchingDeviceType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSymbolStyle *getIfcSymbolStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSymbolStyle(IfcSymbolStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSymbolStyle > createIfcSymbolStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSymbolStyle *cloneIfcSymbolStyle(const IfcSymbolStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSystem *getIfcSystem(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSystem(IfcSystem *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSystem > createIfcSystem(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSystem *cloneIfcSystem(const IfcSystem &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcSystemFurnitureElementType *getIfcSystemFurnitureElementType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcSystemFurnitureElementType(IfcSystemFurnitureElementType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcSystemFurnitureElementType > createIfcSystemFurnitureElementType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcSystemFurnitureElementType *cloneIfcSystemFurnitureElementType(const IfcSystemFurnitureElementType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTShapeProfileDef *getIfcTShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTShapeProfileDef(IfcTShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTShapeProfileDef > createIfcTShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTShapeProfileDef *cloneIfcTShapeProfileDef(const IfcTShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTable *getIfcTable(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTable(IfcTable *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTable > createIfcTable(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTable *cloneIfcTable(const IfcTable &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTableRow *getIfcTableRow(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTableRow(IfcTableRow *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTableRow > createIfcTableRow(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTableRow *cloneIfcTableRow(const IfcTableRow &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTankType *getIfcTankType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTankType(IfcTankType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTankType > createIfcTankType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTankType *cloneIfcTankType(const IfcTankType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTask *getIfcTask(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTask(IfcTask *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTask > createIfcTask(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTask *cloneIfcTask(const IfcTask &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTelecomAddress *getIfcTelecomAddress(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTelecomAddress(IfcTelecomAddress *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTelecomAddress > createIfcTelecomAddress(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTelecomAddress *cloneIfcTelecomAddress(const IfcTelecomAddress &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTendon *getIfcTendon(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTendon(IfcTendon *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTendon > createIfcTendon(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTendon *cloneIfcTendon(const IfcTendon &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTendonAnchor *getIfcTendonAnchor(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTendonAnchor(IfcTendonAnchor *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTendonAnchor > createIfcTendonAnchor(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTendonAnchor *cloneIfcTendonAnchor(const IfcTendonAnchor &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTerminatorSymbol *getIfcTerminatorSymbol(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTerminatorSymbol(IfcTerminatorSymbol *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTerminatorSymbol > createIfcTerminatorSymbol(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTerminatorSymbol *cloneIfcTerminatorSymbol(const IfcTerminatorSymbol &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextLiteral *getIfcTextLiteral(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextLiteral(IfcTextLiteral *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextLiteral > createIfcTextLiteral(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextLiteral *cloneIfcTextLiteral(const IfcTextLiteral &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextLiteralWithExtent *getIfcTextLiteralWithExtent(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextLiteralWithExtent(IfcTextLiteralWithExtent *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextLiteralWithExtent > createIfcTextLiteralWithExtent(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextLiteralWithExtent *cloneIfcTextLiteralWithExtent(const IfcTextLiteralWithExtent &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextStyle *getIfcTextStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextStyle(IfcTextStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextStyle > createIfcTextStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextStyle *cloneIfcTextStyle(const IfcTextStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextStyleFontModel *getIfcTextStyleFontModel(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextStyleFontModel(IfcTextStyleFontModel *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextStyleFontModel > createIfcTextStyleFontModel(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextStyleFontModel *cloneIfcTextStyleFontModel(const IfcTextStyleFontModel &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextStyleForDefinedFont *getIfcTextStyleForDefinedFont(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextStyleForDefinedFont(IfcTextStyleForDefinedFont *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextStyleForDefinedFont > createIfcTextStyleForDefinedFont(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextStyleForDefinedFont *cloneIfcTextStyleForDefinedFont(const IfcTextStyleForDefinedFont &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextStyleTextModel *getIfcTextStyleTextModel(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextStyleTextModel(IfcTextStyleTextModel *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextStyleTextModel > createIfcTextStyleTextModel(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextStyleTextModel *cloneIfcTextStyleTextModel(const IfcTextStyleTextModel &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextStyleWithBoxCharacteristics *getIfcTextStyleWithBoxCharacteristics(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextStyleWithBoxCharacteristics(IfcTextStyleWithBoxCharacteristics *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextStyleWithBoxCharacteristics > createIfcTextStyleWithBoxCharacteristics(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextStyleWithBoxCharacteristics *cloneIfcTextStyleWithBoxCharacteristics(const IfcTextStyleWithBoxCharacteristics &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextureCoordinateGenerator *getIfcTextureCoordinateGenerator(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextureCoordinateGenerator(IfcTextureCoordinateGenerator *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextureCoordinateGenerator > createIfcTextureCoordinateGenerator(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextureCoordinateGenerator *cloneIfcTextureCoordinateGenerator(const IfcTextureCoordinateGenerator &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextureMap *getIfcTextureMap(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextureMap(IfcTextureMap *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextureMap > createIfcTextureMap(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextureMap *cloneIfcTextureMap(const IfcTextureMap &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTextureVertex *getIfcTextureVertex(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTextureVertex(IfcTextureVertex *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTextureVertex > createIfcTextureVertex(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTextureVertex *cloneIfcTextureVertex(const IfcTextureVertex &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcThermalMaterialProperties *getIfcThermalMaterialProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcThermalMaterialProperties(IfcThermalMaterialProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcThermalMaterialProperties > createIfcThermalMaterialProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcThermalMaterialProperties *cloneIfcThermalMaterialProperties(const IfcThermalMaterialProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTimeSeriesReferenceRelationship *getIfcTimeSeriesReferenceRelationship(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTimeSeriesReferenceRelationship(IfcTimeSeriesReferenceRelationship *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTimeSeriesReferenceRelationship > createIfcTimeSeriesReferenceRelationship(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTimeSeriesReferenceRelationship *cloneIfcTimeSeriesReferenceRelationship(const IfcTimeSeriesReferenceRelationship &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTimeSeriesSchedule *getIfcTimeSeriesSchedule(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTimeSeriesSchedule(IfcTimeSeriesSchedule *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTimeSeriesSchedule > createIfcTimeSeriesSchedule(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTimeSeriesSchedule *cloneIfcTimeSeriesSchedule(const IfcTimeSeriesSchedule &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTimeSeriesValue *getIfcTimeSeriesValue(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTimeSeriesValue(IfcTimeSeriesValue *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTimeSeriesValue > createIfcTimeSeriesValue(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTimeSeriesValue *cloneIfcTimeSeriesValue(const IfcTimeSeriesValue &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTopologyRepresentation *getIfcTopologyRepresentation(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTopologyRepresentation(IfcTopologyRepresentation *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTopologyRepresentation > createIfcTopologyRepresentation(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTopologyRepresentation *cloneIfcTopologyRepresentation(const IfcTopologyRepresentation &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTransformerType *getIfcTransformerType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTransformerType(IfcTransformerType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTransformerType > createIfcTransformerType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTransformerType *cloneIfcTransformerType(const IfcTransformerType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTransportElement *getIfcTransportElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTransportElement(IfcTransportElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTransportElement > createIfcTransportElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTransportElement *cloneIfcTransportElement(const IfcTransportElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTransportElementType *getIfcTransportElementType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTransportElementType(IfcTransportElementType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTransportElementType > createIfcTransportElementType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTransportElementType *cloneIfcTransportElementType(const IfcTransportElementType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTrapeziumProfileDef *getIfcTrapeziumProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTrapeziumProfileDef(IfcTrapeziumProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTrapeziumProfileDef > createIfcTrapeziumProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTrapeziumProfileDef *cloneIfcTrapeziumProfileDef(const IfcTrapeziumProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTrimmedCurve *getIfcTrimmedCurve(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTrimmedCurve(IfcTrimmedCurve *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTrimmedCurve > createIfcTrimmedCurve(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTrimmedCurve *cloneIfcTrimmedCurve(const IfcTrimmedCurve &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTubeBundleType *getIfcTubeBundleType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTubeBundleType(IfcTubeBundleType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTubeBundleType > createIfcTubeBundleType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTubeBundleType *cloneIfcTubeBundleType(const IfcTubeBundleType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTwoDirectionRepeatFactor *getIfcTwoDirectionRepeatFactor(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTwoDirectionRepeatFactor(IfcTwoDirectionRepeatFactor *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTwoDirectionRepeatFactor > createIfcTwoDirectionRepeatFactor(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTwoDirectionRepeatFactor *cloneIfcTwoDirectionRepeatFactor(const IfcTwoDirectionRepeatFactor &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTypeObject *getIfcTypeObject(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTypeObject(IfcTypeObject *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTypeObject > createIfcTypeObject(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTypeObject *cloneIfcTypeObject(const IfcTypeObject &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcTypeProduct *getIfcTypeProduct(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcTypeProduct(IfcTypeProduct *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcTypeProduct > createIfcTypeProduct(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcTypeProduct *cloneIfcTypeProduct(const IfcTypeProduct &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcUShapeProfileDef *getIfcUShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcUShapeProfileDef(IfcUShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcUShapeProfileDef > createIfcUShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcUShapeProfileDef *cloneIfcUShapeProfileDef(const IfcUShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcUnitAssignment *getIfcUnitAssignment(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcUnitAssignment(IfcUnitAssignment *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcUnitAssignment > createIfcUnitAssignment(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcUnitAssignment *cloneIfcUnitAssignment(const IfcUnitAssignment &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcUnitaryEquipmentType *getIfcUnitaryEquipmentType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcUnitaryEquipmentType(IfcUnitaryEquipmentType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcUnitaryEquipmentType > createIfcUnitaryEquipmentType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcUnitaryEquipmentType *cloneIfcUnitaryEquipmentType(const IfcUnitaryEquipmentType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcValveType *getIfcValveType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcValveType(IfcValveType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcValveType > createIfcValveType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcValveType *cloneIfcValveType(const IfcValveType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVector *getIfcVector(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVector(IfcVector *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVector > createIfcVector(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVector *cloneIfcVector(const IfcVector &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVertex *getIfcVertex(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVertex(IfcVertex *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVertex > createIfcVertex(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVertex *cloneIfcVertex(const IfcVertex &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVertexBasedTextureMap *getIfcVertexBasedTextureMap(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVertexBasedTextureMap(IfcVertexBasedTextureMap *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVertexBasedTextureMap > createIfcVertexBasedTextureMap(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVertexBasedTextureMap *cloneIfcVertexBasedTextureMap(const IfcVertexBasedTextureMap &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVertexLoop *getIfcVertexLoop(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVertexLoop(IfcVertexLoop *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVertexLoop > createIfcVertexLoop(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVertexLoop *cloneIfcVertexLoop(const IfcVertexLoop &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVertexPoint *getIfcVertexPoint(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVertexPoint(IfcVertexPoint *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVertexPoint > createIfcVertexPoint(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVertexPoint *cloneIfcVertexPoint(const IfcVertexPoint &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVibrationIsolatorType *getIfcVibrationIsolatorType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVibrationIsolatorType(IfcVibrationIsolatorType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVibrationIsolatorType > createIfcVibrationIsolatorType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVibrationIsolatorType *cloneIfcVibrationIsolatorType(const IfcVibrationIsolatorType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVirtualElement *getIfcVirtualElement(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVirtualElement(IfcVirtualElement *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVirtualElement > createIfcVirtualElement(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVirtualElement *cloneIfcVirtualElement(const IfcVirtualElement &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcVirtualGridIntersection *getIfcVirtualGridIntersection(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcVirtualGridIntersection(IfcVirtualGridIntersection *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcVirtualGridIntersection > createIfcVirtualGridIntersection(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcVirtualGridIntersection *cloneIfcVirtualGridIntersection(const IfcVirtualGridIntersection &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWall *getIfcWall(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWall(IfcWall *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWall > createIfcWall(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWall *cloneIfcWall(const IfcWall &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWallStandardCase *getIfcWallStandardCase(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWallStandardCase(IfcWallStandardCase *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWallStandardCase > createIfcWallStandardCase(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWallStandardCase *cloneIfcWallStandardCase(const IfcWallStandardCase &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWallType *getIfcWallType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWallType(IfcWallType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWallType > createIfcWallType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWallType *cloneIfcWallType(const IfcWallType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWasteTerminalType *getIfcWasteTerminalType(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWasteTerminalType(IfcWasteTerminalType *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWasteTerminalType > createIfcWasteTerminalType(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWasteTerminalType *cloneIfcWasteTerminalType(const IfcWasteTerminalType &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWaterProperties *getIfcWaterProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWaterProperties(IfcWaterProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWaterProperties > createIfcWaterProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWaterProperties *cloneIfcWaterProperties(const IfcWaterProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWindow *getIfcWindow(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWindow(IfcWindow *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWindow > createIfcWindow(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWindow *cloneIfcWindow(const IfcWindow &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWindowLiningProperties *getIfcWindowLiningProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWindowLiningProperties(IfcWindowLiningProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWindowLiningProperties > createIfcWindowLiningProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWindowLiningProperties *cloneIfcWindowLiningProperties(const IfcWindowLiningProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWindowPanelProperties *getIfcWindowPanelProperties(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWindowPanelProperties(IfcWindowPanelProperties *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWindowPanelProperties > createIfcWindowPanelProperties(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWindowPanelProperties *cloneIfcWindowPanelProperties(const IfcWindowPanelProperties &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWindowStyle *getIfcWindowStyle(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWindowStyle(IfcWindowStyle *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWindowStyle > createIfcWindowStyle(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWindowStyle *cloneIfcWindowStyle(const IfcWindowStyle &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWorkPlan *getIfcWorkPlan(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWorkPlan(IfcWorkPlan *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWorkPlan > createIfcWorkPlan(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWorkPlan *cloneIfcWorkPlan(const IfcWorkPlan &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcWorkSchedule *getIfcWorkSchedule(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcWorkSchedule(IfcWorkSchedule *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcWorkSchedule > createIfcWorkSchedule(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcWorkSchedule *cloneIfcWorkSchedule(const IfcWorkSchedule &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcZShapeProfileDef *getIfcZShapeProfileDef(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcZShapeProfileDef(IfcZShapeProfileDef *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcZShapeProfileDef > createIfcZShapeProfileDef(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcZShapeProfileDef *cloneIfcZShapeProfileDef(const IfcZShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * Get the entity by it's Id.
         * 
         * @param id The Id of the Entity.
         * @return A pointer to the entity if found, NULL otherwise.
         */
        IfcZone *getIfcZone(Step::Id id);
        /**
         * Remove an Entity from the ExpressDataSet's maps.
         * 
         * @param arg The pointer to the entity to remove.
         * @return success.
         */
        bool removeIfcZone(IfcZone *arg);
        /**
         * Create an Entity from this ExpressDataSet.
         * 
         * @param isVolatile If set to true the Entity will not be stored in the ExpressDataSet maps. It is considered to be volatile.
         * @return The newly allocated entity.
         */
        Step::RefPtr< IfcZone > createIfcZone(bool isVolatile = false);
        /**
         * Clone an Entity into this ExpressDataSet with the given copy operator.
         * 
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         * @return The newly cloned entity.
         */
        IfcZone *cloneIfcZone(const IfcZone &obj, const CopyOp &copyop);
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< Ifc2DCompositeCurve > &getAllIfc2DCompositeCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcActionRequest > &getAllIfcActionRequest();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcActor > &getAllIfcActor();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcActorRole > &getAllIfcActorRole();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcActuatorType > &getAllIfcActuatorType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAddress > &getAllIfcAddress();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAirTerminalBoxType > &getAllIfcAirTerminalBoxType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAirTerminalType > &getAllIfcAirTerminalType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAirToAirHeatRecoveryType > &getAllIfcAirToAirHeatRecoveryType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAlarmType > &getAllIfcAlarmType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAngularDimension > &getAllIfcAngularDimension();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotation > &getAllIfcAnnotation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationCurveOccurrence > &getAllIfcAnnotationCurveOccurrence();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationFillArea > &getAllIfcAnnotationFillArea();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationFillAreaOccurrence > &getAllIfcAnnotationFillAreaOccurrence();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationOccurrence > &getAllIfcAnnotationOccurrence();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationSurface > &getAllIfcAnnotationSurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationSurfaceOccurrence > &getAllIfcAnnotationSurfaceOccurrence();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationSymbolOccurrence > &getAllIfcAnnotationSymbolOccurrence();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAnnotationTextOccurrence > &getAllIfcAnnotationTextOccurrence();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcApplication > &getAllIfcApplication();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAppliedValue > &getAllIfcAppliedValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAppliedValueRelationship > &getAllIfcAppliedValueRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcApproval > &getAllIfcApproval();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcApprovalActorRelationship > &getAllIfcApprovalActorRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcApprovalPropertyRelationship > &getAllIfcApprovalPropertyRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcApprovalRelationship > &getAllIfcApprovalRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcArbitraryClosedProfileDef > &getAllIfcArbitraryClosedProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcArbitraryOpenProfileDef > &getAllIfcArbitraryOpenProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcArbitraryProfileDefWithVoids > &getAllIfcArbitraryProfileDefWithVoids();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAsset > &getAllIfcAsset();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAsymmetricIShapeProfileDef > &getAllIfcAsymmetricIShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAxis1Placement > &getAllIfcAxis1Placement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAxis2Placement2D > &getAllIfcAxis2Placement2D();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcAxis2Placement3D > &getAllIfcAxis2Placement3D();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBSplineCurve > &getAllIfcBSplineCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBeam > &getAllIfcBeam();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBeamType > &getAllIfcBeamType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBezierCurve > &getAllIfcBezierCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBlobTexture > &getAllIfcBlobTexture();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBlock > &getAllIfcBlock();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoilerType > &getAllIfcBoilerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBooleanClippingResult > &getAllIfcBooleanClippingResult();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBooleanResult > &getAllIfcBooleanResult();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundaryCondition > &getAllIfcBoundaryCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundaryEdgeCondition > &getAllIfcBoundaryEdgeCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundaryFaceCondition > &getAllIfcBoundaryFaceCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundaryNodeCondition > &getAllIfcBoundaryNodeCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundaryNodeConditionWarping > &getAllIfcBoundaryNodeConditionWarping();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundedCurve > &getAllIfcBoundedCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundedSurface > &getAllIfcBoundedSurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoundingBox > &getAllIfcBoundingBox();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBoxedHalfSpace > &getAllIfcBoxedHalfSpace();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuilding > &getAllIfcBuilding();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuildingElement > &getAllIfcBuildingElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuildingElementComponent > &getAllIfcBuildingElementComponent();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuildingElementPart > &getAllIfcBuildingElementPart();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuildingElementProxy > &getAllIfcBuildingElementProxy();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuildingElementProxyType > &getAllIfcBuildingElementProxyType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuildingElementType > &getAllIfcBuildingElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcBuildingStorey > &getAllIfcBuildingStorey();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCShapeProfileDef > &getAllIfcCShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCableCarrierFittingType > &getAllIfcCableCarrierFittingType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCableCarrierSegmentType > &getAllIfcCableCarrierSegmentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCableSegmentType > &getAllIfcCableSegmentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCalendarDate > &getAllIfcCalendarDate();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCartesianPoint > &getAllIfcCartesianPoint();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator > &getAllIfcCartesianTransformationOperator();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator2D > &getAllIfcCartesianTransformationOperator2D();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator2DnonUniform > &getAllIfcCartesianTransformationOperator2DnonUniform();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator3D > &getAllIfcCartesianTransformationOperator3D();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator3DnonUniform > &getAllIfcCartesianTransformationOperator3DnonUniform();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCenterLineProfileDef > &getAllIfcCenterLineProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcChamferEdgeFeature > &getAllIfcChamferEdgeFeature();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcChillerType > &getAllIfcChillerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCircle > &getAllIfcCircle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCircleHollowProfileDef > &getAllIfcCircleHollowProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCircleProfileDef > &getAllIfcCircleProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcClassification > &getAllIfcClassification();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcClassificationItem > &getAllIfcClassificationItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcClassificationItemRelationship > &getAllIfcClassificationItemRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcClassificationNotation > &getAllIfcClassificationNotation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcClassificationNotationFacet > &getAllIfcClassificationNotationFacet();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcClassificationReference > &getAllIfcClassificationReference();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcClosedShell > &getAllIfcClosedShell();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCoilType > &getAllIfcCoilType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcColourRgb > &getAllIfcColourRgb();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcColourSpecification > &getAllIfcColourSpecification();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcColumn > &getAllIfcColumn();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcColumnType > &getAllIfcColumnType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcComplexProperty > &getAllIfcComplexProperty();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCompositeCurve > &getAllIfcCompositeCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCompositeCurveSegment > &getAllIfcCompositeCurveSegment();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCompositeProfileDef > &getAllIfcCompositeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCompressorType > &getAllIfcCompressorType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCondenserType > &getAllIfcCondenserType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCondition > &getAllIfcCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConditionCriterion > &getAllIfcConditionCriterion();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConic > &getAllIfcConic();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConnectedFaceSet > &getAllIfcConnectedFaceSet();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConnectionCurveGeometry > &getAllIfcConnectionCurveGeometry();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConnectionGeometry > &getAllIfcConnectionGeometry();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConnectionPointEccentricity > &getAllIfcConnectionPointEccentricity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConnectionPointGeometry > &getAllIfcConnectionPointGeometry();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConnectionPortGeometry > &getAllIfcConnectionPortGeometry();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConnectionSurfaceGeometry > &getAllIfcConnectionSurfaceGeometry();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstraint > &getAllIfcConstraint();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstraintAggregationRelationship > &getAllIfcConstraintAggregationRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstraintClassificationRelationship > &getAllIfcConstraintClassificationRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstraintRelationship > &getAllIfcConstraintRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstructionEquipmentResource > &getAllIfcConstructionEquipmentResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstructionMaterialResource > &getAllIfcConstructionMaterialResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstructionProductResource > &getAllIfcConstructionProductResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConstructionResource > &getAllIfcConstructionResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcContextDependentUnit > &getAllIfcContextDependentUnit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcControl > &getAllIfcControl();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcControllerType > &getAllIfcControllerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcConversionBasedUnit > &getAllIfcConversionBasedUnit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCooledBeamType > &getAllIfcCooledBeamType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCoolingTowerType > &getAllIfcCoolingTowerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCoordinatedUniversalTimeOffset > &getAllIfcCoordinatedUniversalTimeOffset();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCostItem > &getAllIfcCostItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCostSchedule > &getAllIfcCostSchedule();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCostValue > &getAllIfcCostValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCovering > &getAllIfcCovering();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCoveringType > &getAllIfcCoveringType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCraneRailAShapeProfileDef > &getAllIfcCraneRailAShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCraneRailFShapeProfileDef > &getAllIfcCraneRailFShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCrewResource > &getAllIfcCrewResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCsgPrimitive3D > &getAllIfcCsgPrimitive3D();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCsgSolid > &getAllIfcCsgSolid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurrencyRelationship > &getAllIfcCurrencyRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurtainWall > &getAllIfcCurtainWall();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurtainWallType > &getAllIfcCurtainWallType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurve > &getAllIfcCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurveBoundedPlane > &getAllIfcCurveBoundedPlane();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurveStyle > &getAllIfcCurveStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurveStyleFont > &getAllIfcCurveStyleFont();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurveStyleFontAndScaling > &getAllIfcCurveStyleFontAndScaling();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcCurveStyleFontPattern > &getAllIfcCurveStyleFontPattern();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDamperType > &getAllIfcDamperType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDateAndTime > &getAllIfcDateAndTime();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDefinedSymbol > &getAllIfcDefinedSymbol();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDerivedProfileDef > &getAllIfcDerivedProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDerivedUnit > &getAllIfcDerivedUnit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDerivedUnitElement > &getAllIfcDerivedUnitElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDiameterDimension > &getAllIfcDiameterDimension();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDimensionCalloutRelationship > &getAllIfcDimensionCalloutRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDimensionCurve > &getAllIfcDimensionCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDimensionCurveDirectedCallout > &getAllIfcDimensionCurveDirectedCallout();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDimensionCurveTerminator > &getAllIfcDimensionCurveTerminator();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDimensionPair > &getAllIfcDimensionPair();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDimensionalExponents > &getAllIfcDimensionalExponents();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDirection > &getAllIfcDirection();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDiscreteAccessory > &getAllIfcDiscreteAccessory();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDiscreteAccessoryType > &getAllIfcDiscreteAccessoryType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionChamberElement > &getAllIfcDistributionChamberElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionChamberElementType > &getAllIfcDistributionChamberElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionControlElement > &getAllIfcDistributionControlElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionControlElementType > &getAllIfcDistributionControlElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionElement > &getAllIfcDistributionElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionElementType > &getAllIfcDistributionElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionFlowElement > &getAllIfcDistributionFlowElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionFlowElementType > &getAllIfcDistributionFlowElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDistributionPort > &getAllIfcDistributionPort();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDocumentElectronicFormat > &getAllIfcDocumentElectronicFormat();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDocumentInformation > &getAllIfcDocumentInformation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDocumentInformationRelationship > &getAllIfcDocumentInformationRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDocumentReference > &getAllIfcDocumentReference();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDoor > &getAllIfcDoor();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDoorLiningProperties > &getAllIfcDoorLiningProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDoorPanelProperties > &getAllIfcDoorPanelProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDoorStyle > &getAllIfcDoorStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDraughtingCallout > &getAllIfcDraughtingCallout();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDraughtingCalloutRelationship > &getAllIfcDraughtingCalloutRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDraughtingPreDefinedColour > &getAllIfcDraughtingPreDefinedColour();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDraughtingPreDefinedCurveFont > &getAllIfcDraughtingPreDefinedCurveFont();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDraughtingPreDefinedTextFont > &getAllIfcDraughtingPreDefinedTextFont();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDuctFittingType > &getAllIfcDuctFittingType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDuctSegmentType > &getAllIfcDuctSegmentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcDuctSilencerType > &getAllIfcDuctSilencerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEdge > &getAllIfcEdge();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEdgeCurve > &getAllIfcEdgeCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEdgeFeature > &getAllIfcEdgeFeature();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEdgeLoop > &getAllIfcEdgeLoop();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricApplianceType > &getAllIfcElectricApplianceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricDistributionPoint > &getAllIfcElectricDistributionPoint();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricFlowStorageDeviceType > &getAllIfcElectricFlowStorageDeviceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricGeneratorType > &getAllIfcElectricGeneratorType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricHeaterType > &getAllIfcElectricHeaterType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricMotorType > &getAllIfcElectricMotorType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricTimeControlType > &getAllIfcElectricTimeControlType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricalBaseProperties > &getAllIfcElectricalBaseProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricalCircuit > &getAllIfcElectricalCircuit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElectricalElement > &getAllIfcElectricalElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElement > &getAllIfcElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElementAssembly > &getAllIfcElementAssembly();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElementComponent > &getAllIfcElementComponent();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElementComponentType > &getAllIfcElementComponentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElementQuantity > &getAllIfcElementQuantity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElementType > &getAllIfcElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcElementarySurface > &getAllIfcElementarySurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEllipse > &getAllIfcEllipse();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEllipseProfileDef > &getAllIfcEllipseProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEnergyConversionDevice > &getAllIfcEnergyConversionDevice();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEnergyConversionDeviceType > &getAllIfcEnergyConversionDeviceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEnergyProperties > &getAllIfcEnergyProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEnvironmentalImpactValue > &getAllIfcEnvironmentalImpactValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEquipmentElement > &getAllIfcEquipmentElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEquipmentStandard > &getAllIfcEquipmentStandard();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEvaporativeCoolerType > &getAllIfcEvaporativeCoolerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcEvaporatorType > &getAllIfcEvaporatorType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcExtendedMaterialProperties > &getAllIfcExtendedMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcExternalReference > &getAllIfcExternalReference();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcExternallyDefinedHatchStyle > &getAllIfcExternallyDefinedHatchStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcExternallyDefinedSurfaceStyle > &getAllIfcExternallyDefinedSurfaceStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcExternallyDefinedSymbol > &getAllIfcExternallyDefinedSymbol();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcExternallyDefinedTextFont > &getAllIfcExternallyDefinedTextFont();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcExtrudedAreaSolid > &getAllIfcExtrudedAreaSolid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFace > &getAllIfcFace();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFaceBasedSurfaceModel > &getAllIfcFaceBasedSurfaceModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFaceBound > &getAllIfcFaceBound();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFaceOuterBound > &getAllIfcFaceOuterBound();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFaceSurface > &getAllIfcFaceSurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFacetedBrep > &getAllIfcFacetedBrep();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFacetedBrepWithVoids > &getAllIfcFacetedBrepWithVoids();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFailureConnectionCondition > &getAllIfcFailureConnectionCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFanType > &getAllIfcFanType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFastener > &getAllIfcFastener();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFastenerType > &getAllIfcFastenerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFeatureElement > &getAllIfcFeatureElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFeatureElementAddition > &getAllIfcFeatureElementAddition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFeatureElementSubtraction > &getAllIfcFeatureElementSubtraction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFillAreaStyle > &getAllIfcFillAreaStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFillAreaStyleHatching > &getAllIfcFillAreaStyleHatching();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFillAreaStyleTileSymbolWithStyle > &getAllIfcFillAreaStyleTileSymbolWithStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFillAreaStyleTiles > &getAllIfcFillAreaStyleTiles();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFilterType > &getAllIfcFilterType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFireSuppressionTerminalType > &getAllIfcFireSuppressionTerminalType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowController > &getAllIfcFlowController();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowControllerType > &getAllIfcFlowControllerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowFitting > &getAllIfcFlowFitting();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowFittingType > &getAllIfcFlowFittingType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowInstrumentType > &getAllIfcFlowInstrumentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowMeterType > &getAllIfcFlowMeterType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowMovingDevice > &getAllIfcFlowMovingDevice();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowMovingDeviceType > &getAllIfcFlowMovingDeviceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowSegment > &getAllIfcFlowSegment();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowSegmentType > &getAllIfcFlowSegmentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowStorageDevice > &getAllIfcFlowStorageDevice();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowStorageDeviceType > &getAllIfcFlowStorageDeviceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowTerminal > &getAllIfcFlowTerminal();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowTerminalType > &getAllIfcFlowTerminalType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowTreatmentDevice > &getAllIfcFlowTreatmentDevice();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFlowTreatmentDeviceType > &getAllIfcFlowTreatmentDeviceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFluidFlowProperties > &getAllIfcFluidFlowProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFooting > &getAllIfcFooting();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFuelProperties > &getAllIfcFuelProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFurnishingElement > &getAllIfcFurnishingElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFurnishingElementType > &getAllIfcFurnishingElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFurnitureStandard > &getAllIfcFurnitureStandard();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcFurnitureType > &getAllIfcFurnitureType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGasTerminalType > &getAllIfcGasTerminalType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGeneralMaterialProperties > &getAllIfcGeneralMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGeneralProfileProperties > &getAllIfcGeneralProfileProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGeometricCurveSet > &getAllIfcGeometricCurveSet();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGeometricRepresentationContext > &getAllIfcGeometricRepresentationContext();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGeometricRepresentationItem > &getAllIfcGeometricRepresentationItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGeometricRepresentationSubContext > &getAllIfcGeometricRepresentationSubContext();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGeometricSet > &getAllIfcGeometricSet();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGrid > &getAllIfcGrid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGridAxis > &getAllIfcGridAxis();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGridPlacement > &getAllIfcGridPlacement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcGroup > &getAllIfcGroup();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcHalfSpaceSolid > &getAllIfcHalfSpaceSolid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcHeatExchangerType > &getAllIfcHeatExchangerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcHumidifierType > &getAllIfcHumidifierType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcHygroscopicMaterialProperties > &getAllIfcHygroscopicMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcIShapeProfileDef > &getAllIfcIShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcImageTexture > &getAllIfcImageTexture();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcInventory > &getAllIfcInventory();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcIrregularTimeSeries > &getAllIfcIrregularTimeSeries();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcIrregularTimeSeriesValue > &getAllIfcIrregularTimeSeriesValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcJunctionBoxType > &getAllIfcJunctionBoxType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLShapeProfileDef > &getAllIfcLShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLaborResource > &getAllIfcLaborResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLampType > &getAllIfcLampType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLibraryInformation > &getAllIfcLibraryInformation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLibraryReference > &getAllIfcLibraryReference();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightDistributionData > &getAllIfcLightDistributionData();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightFixtureType > &getAllIfcLightFixtureType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightIntensityDistribution > &getAllIfcLightIntensityDistribution();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightSource > &getAllIfcLightSource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightSourceAmbient > &getAllIfcLightSourceAmbient();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightSourceDirectional > &getAllIfcLightSourceDirectional();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightSourceGoniometric > &getAllIfcLightSourceGoniometric();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightSourcePositional > &getAllIfcLightSourcePositional();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLightSourceSpot > &getAllIfcLightSourceSpot();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLine > &getAllIfcLine();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLinearDimension > &getAllIfcLinearDimension();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLocalPlacement > &getAllIfcLocalPlacement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLocalTime > &getAllIfcLocalTime();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcLoop > &getAllIfcLoop();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcManifoldSolidBrep > &getAllIfcManifoldSolidBrep();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMappedItem > &getAllIfcMappedItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterial > &getAllIfcMaterial();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterialClassificationRelationship > &getAllIfcMaterialClassificationRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterialDefinitionRepresentation > &getAllIfcMaterialDefinitionRepresentation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterialLayer > &getAllIfcMaterialLayer();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterialLayerSet > &getAllIfcMaterialLayerSet();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterialLayerSetUsage > &getAllIfcMaterialLayerSetUsage();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterialList > &getAllIfcMaterialList();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMaterialProperties > &getAllIfcMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMeasureWithUnit > &getAllIfcMeasureWithUnit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMechanicalConcreteMaterialProperties > &getAllIfcMechanicalConcreteMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMechanicalFastener > &getAllIfcMechanicalFastener();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMechanicalFastenerType > &getAllIfcMechanicalFastenerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMechanicalMaterialProperties > &getAllIfcMechanicalMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMechanicalSteelMaterialProperties > &getAllIfcMechanicalSteelMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMember > &getAllIfcMember();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMemberType > &getAllIfcMemberType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMetric > &getAllIfcMetric();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMonetaryUnit > &getAllIfcMonetaryUnit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMotorConnectionType > &getAllIfcMotorConnectionType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcMove > &getAllIfcMove();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcNamedUnit > &getAllIfcNamedUnit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcObject > &getAllIfcObject();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcObjectDefinition > &getAllIfcObjectDefinition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcObjectPlacement > &getAllIfcObjectPlacement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcObjective > &getAllIfcObjective();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOccupant > &getAllIfcOccupant();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOffsetCurve2D > &getAllIfcOffsetCurve2D();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOffsetCurve3D > &getAllIfcOffsetCurve3D();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOneDirectionRepeatFactor > &getAllIfcOneDirectionRepeatFactor();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOpenShell > &getAllIfcOpenShell();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOpeningElement > &getAllIfcOpeningElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOpticalMaterialProperties > &getAllIfcOpticalMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOrderAction > &getAllIfcOrderAction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOrganization > &getAllIfcOrganization();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOrganizationRelationship > &getAllIfcOrganizationRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOrientedEdge > &getAllIfcOrientedEdge();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOutletType > &getAllIfcOutletType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcOwnerHistory > &getAllIfcOwnerHistory();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcParameterizedProfileDef > &getAllIfcParameterizedProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPath > &getAllIfcPath();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPerformanceHistory > &getAllIfcPerformanceHistory();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPermeableCoveringProperties > &getAllIfcPermeableCoveringProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPermit > &getAllIfcPermit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPerson > &getAllIfcPerson();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPersonAndOrganization > &getAllIfcPersonAndOrganization();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPhysicalComplexQuantity > &getAllIfcPhysicalComplexQuantity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPhysicalQuantity > &getAllIfcPhysicalQuantity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPhysicalSimpleQuantity > &getAllIfcPhysicalSimpleQuantity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPile > &getAllIfcPile();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPipeFittingType > &getAllIfcPipeFittingType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPipeSegmentType > &getAllIfcPipeSegmentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPixelTexture > &getAllIfcPixelTexture();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPlacement > &getAllIfcPlacement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPlanarBox > &getAllIfcPlanarBox();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPlanarExtent > &getAllIfcPlanarExtent();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPlane > &getAllIfcPlane();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPlate > &getAllIfcPlate();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPlateType > &getAllIfcPlateType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPoint > &getAllIfcPoint();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPointOnCurve > &getAllIfcPointOnCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPointOnSurface > &getAllIfcPointOnSurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPolyLoop > &getAllIfcPolyLoop();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPolygonalBoundedHalfSpace > &getAllIfcPolygonalBoundedHalfSpace();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPolyline > &getAllIfcPolyline();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPort > &getAllIfcPort();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPostalAddress > &getAllIfcPostalAddress();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedColour > &getAllIfcPreDefinedColour();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedCurveFont > &getAllIfcPreDefinedCurveFont();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedDimensionSymbol > &getAllIfcPreDefinedDimensionSymbol();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedItem > &getAllIfcPreDefinedItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedPointMarkerSymbol > &getAllIfcPreDefinedPointMarkerSymbol();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedSymbol > &getAllIfcPreDefinedSymbol();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedTerminatorSymbol > &getAllIfcPreDefinedTerminatorSymbol();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPreDefinedTextFont > &getAllIfcPreDefinedTextFont();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPresentationLayerAssignment > &getAllIfcPresentationLayerAssignment();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPresentationLayerWithStyle > &getAllIfcPresentationLayerWithStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPresentationStyle > &getAllIfcPresentationStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPresentationStyleAssignment > &getAllIfcPresentationStyleAssignment();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProcedure > &getAllIfcProcedure();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProcess > &getAllIfcProcess();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProduct > &getAllIfcProduct();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProductDefinitionShape > &getAllIfcProductDefinitionShape();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProductRepresentation > &getAllIfcProductRepresentation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProductsOfCombustionProperties > &getAllIfcProductsOfCombustionProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProfileDef > &getAllIfcProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProfileProperties > &getAllIfcProfileProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProject > &getAllIfcProject();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProjectOrder > &getAllIfcProjectOrder();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProjectOrderRecord > &getAllIfcProjectOrderRecord();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProjectionCurve > &getAllIfcProjectionCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProjectionElement > &getAllIfcProjectionElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProperty > &getAllIfcProperty();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyBoundedValue > &getAllIfcPropertyBoundedValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyConstraintRelationship > &getAllIfcPropertyConstraintRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyDefinition > &getAllIfcPropertyDefinition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyDependencyRelationship > &getAllIfcPropertyDependencyRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyEnumeratedValue > &getAllIfcPropertyEnumeratedValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyEnumeration > &getAllIfcPropertyEnumeration();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyListValue > &getAllIfcPropertyListValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyReferenceValue > &getAllIfcPropertyReferenceValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertySet > &getAllIfcPropertySet();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertySetDefinition > &getAllIfcPropertySetDefinition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertySingleValue > &getAllIfcPropertySingleValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPropertyTableValue > &getAllIfcPropertyTableValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProtectiveDeviceType > &getAllIfcProtectiveDeviceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcProxy > &getAllIfcProxy();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcPumpType > &getAllIfcPumpType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcQuantityArea > &getAllIfcQuantityArea();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcQuantityCount > &getAllIfcQuantityCount();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcQuantityLength > &getAllIfcQuantityLength();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcQuantityTime > &getAllIfcQuantityTime();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcQuantityVolume > &getAllIfcQuantityVolume();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcQuantityWeight > &getAllIfcQuantityWeight();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRadiusDimension > &getAllIfcRadiusDimension();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRailing > &getAllIfcRailing();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRailingType > &getAllIfcRailingType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRamp > &getAllIfcRamp();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRampFlight > &getAllIfcRampFlight();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRampFlightType > &getAllIfcRampFlightType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRationalBezierCurve > &getAllIfcRationalBezierCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRectangleHollowProfileDef > &getAllIfcRectangleHollowProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRectangleProfileDef > &getAllIfcRectangleProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRectangularPyramid > &getAllIfcRectangularPyramid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRectangularTrimmedSurface > &getAllIfcRectangularTrimmedSurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcReferencesValueDocument > &getAllIfcReferencesValueDocument();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRegularTimeSeries > &getAllIfcRegularTimeSeries();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcReinforcementBarProperties > &getAllIfcReinforcementBarProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcReinforcementDefinitionProperties > &getAllIfcReinforcementDefinitionProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcReinforcingBar > &getAllIfcReinforcingBar();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcReinforcingElement > &getAllIfcReinforcingElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcReinforcingMesh > &getAllIfcReinforcingMesh();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAggregates > &getAllIfcRelAggregates();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssigns > &getAllIfcRelAssigns();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsTasks > &getAllIfcRelAssignsTasks();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsToActor > &getAllIfcRelAssignsToActor();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsToControl > &getAllIfcRelAssignsToControl();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsToGroup > &getAllIfcRelAssignsToGroup();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsToProcess > &getAllIfcRelAssignsToProcess();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsToProduct > &getAllIfcRelAssignsToProduct();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsToProjectOrder > &getAllIfcRelAssignsToProjectOrder();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssignsToResource > &getAllIfcRelAssignsToResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociates > &getAllIfcRelAssociates();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesAppliedValue > &getAllIfcRelAssociatesAppliedValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesApproval > &getAllIfcRelAssociatesApproval();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesClassification > &getAllIfcRelAssociatesClassification();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesConstraint > &getAllIfcRelAssociatesConstraint();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesDocument > &getAllIfcRelAssociatesDocument();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesLibrary > &getAllIfcRelAssociatesLibrary();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesMaterial > &getAllIfcRelAssociatesMaterial();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelAssociatesProfileProperties > &getAllIfcRelAssociatesProfileProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnects > &getAllIfcRelConnects();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsElements > &getAllIfcRelConnectsElements();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsPathElements > &getAllIfcRelConnectsPathElements();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsPortToElement > &getAllIfcRelConnectsPortToElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsPorts > &getAllIfcRelConnectsPorts();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsStructuralActivity > &getAllIfcRelConnectsStructuralActivity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsStructuralElement > &getAllIfcRelConnectsStructuralElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsStructuralMember > &getAllIfcRelConnectsStructuralMember();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsWithEccentricity > &getAllIfcRelConnectsWithEccentricity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelConnectsWithRealizingElements > &getAllIfcRelConnectsWithRealizingElements();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelContainedInSpatialStructure > &getAllIfcRelContainedInSpatialStructure();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelCoversBldgElements > &getAllIfcRelCoversBldgElements();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelCoversSpaces > &getAllIfcRelCoversSpaces();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelDecomposes > &getAllIfcRelDecomposes();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelDefines > &getAllIfcRelDefines();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelDefinesByProperties > &getAllIfcRelDefinesByProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelDefinesByType > &getAllIfcRelDefinesByType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelFillsElement > &getAllIfcRelFillsElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelFlowControlElements > &getAllIfcRelFlowControlElements();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelInteractionRequirements > &getAllIfcRelInteractionRequirements();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelNests > &getAllIfcRelNests();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelOccupiesSpaces > &getAllIfcRelOccupiesSpaces();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelOverridesProperties > &getAllIfcRelOverridesProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelProjectsElement > &getAllIfcRelProjectsElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelReferencedInSpatialStructure > &getAllIfcRelReferencedInSpatialStructure();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelSchedulesCostItems > &getAllIfcRelSchedulesCostItems();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelSequence > &getAllIfcRelSequence();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelServicesBuildings > &getAllIfcRelServicesBuildings();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelSpaceBoundary > &getAllIfcRelSpaceBoundary();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelVoidsElement > &getAllIfcRelVoidsElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelationship > &getAllIfcRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRelaxation > &getAllIfcRelaxation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRepresentation > &getAllIfcRepresentation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRepresentationContext > &getAllIfcRepresentationContext();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRepresentationItem > &getAllIfcRepresentationItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRepresentationMap > &getAllIfcRepresentationMap();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcResource > &getAllIfcResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRevolvedAreaSolid > &getAllIfcRevolvedAreaSolid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRibPlateProfileProperties > &getAllIfcRibPlateProfileProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRightCircularCone > &getAllIfcRightCircularCone();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRightCircularCylinder > &getAllIfcRightCircularCylinder();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRoof > &getAllIfcRoof();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRoot > &getAllIfcRoot();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRoundedEdgeFeature > &getAllIfcRoundedEdgeFeature();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcRoundedRectangleProfileDef > &getAllIfcRoundedRectangleProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSIUnit > &getAllIfcSIUnit();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSanitaryTerminalType > &getAllIfcSanitaryTerminalType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcScheduleTimeControl > &getAllIfcScheduleTimeControl();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSectionProperties > &getAllIfcSectionProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSectionReinforcementProperties > &getAllIfcSectionReinforcementProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSectionedSpine > &getAllIfcSectionedSpine();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSensorType > &getAllIfcSensorType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcServiceLife > &getAllIfcServiceLife();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcServiceLifeFactor > &getAllIfcServiceLifeFactor();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcShapeAspect > &getAllIfcShapeAspect();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcShapeModel > &getAllIfcShapeModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcShapeRepresentation > &getAllIfcShapeRepresentation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcShellBasedSurfaceModel > &getAllIfcShellBasedSurfaceModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSimpleProperty > &getAllIfcSimpleProperty();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSite > &getAllIfcSite();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSlab > &getAllIfcSlab();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSlabType > &getAllIfcSlabType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSlippageConnectionCondition > &getAllIfcSlippageConnectionCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSolidModel > &getAllIfcSolidModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSoundProperties > &getAllIfcSoundProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSoundValue > &getAllIfcSoundValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSpace > &getAllIfcSpace();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSpaceHeaterType > &getAllIfcSpaceHeaterType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSpaceProgram > &getAllIfcSpaceProgram();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSpaceThermalLoadProperties > &getAllIfcSpaceThermalLoadProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSpaceType > &getAllIfcSpaceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSpatialStructureElement > &getAllIfcSpatialStructureElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSpatialStructureElementType > &getAllIfcSpatialStructureElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSphere > &getAllIfcSphere();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStackTerminalType > &getAllIfcStackTerminalType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStair > &getAllIfcStair();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStairFlight > &getAllIfcStairFlight();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStairFlightType > &getAllIfcStairFlightType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralAction > &getAllIfcStructuralAction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralActivity > &getAllIfcStructuralActivity();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralAnalysisModel > &getAllIfcStructuralAnalysisModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralConnection > &getAllIfcStructuralConnection();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralConnectionCondition > &getAllIfcStructuralConnectionCondition();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralCurveConnection > &getAllIfcStructuralCurveConnection();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralCurveMember > &getAllIfcStructuralCurveMember();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralCurveMemberVarying > &getAllIfcStructuralCurveMemberVarying();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralItem > &getAllIfcStructuralItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLinearAction > &getAllIfcStructuralLinearAction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLinearActionVarying > &getAllIfcStructuralLinearActionVarying();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoad > &getAllIfcStructuralLoad();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadGroup > &getAllIfcStructuralLoadGroup();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadLinearForce > &getAllIfcStructuralLoadLinearForce();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadPlanarForce > &getAllIfcStructuralLoadPlanarForce();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadSingleDisplacement > &getAllIfcStructuralLoadSingleDisplacement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadSingleDisplacementDistortion > &getAllIfcStructuralLoadSingleDisplacementDistortion();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadSingleForce > &getAllIfcStructuralLoadSingleForce();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadSingleForceWarping > &getAllIfcStructuralLoadSingleForceWarping();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadStatic > &getAllIfcStructuralLoadStatic();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralLoadTemperature > &getAllIfcStructuralLoadTemperature();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralMember > &getAllIfcStructuralMember();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralPlanarAction > &getAllIfcStructuralPlanarAction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralPlanarActionVarying > &getAllIfcStructuralPlanarActionVarying();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralPointAction > &getAllIfcStructuralPointAction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralPointConnection > &getAllIfcStructuralPointConnection();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralPointReaction > &getAllIfcStructuralPointReaction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralProfileProperties > &getAllIfcStructuralProfileProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralReaction > &getAllIfcStructuralReaction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralResultGroup > &getAllIfcStructuralResultGroup();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralSteelProfileProperties > &getAllIfcStructuralSteelProfileProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralSurfaceConnection > &getAllIfcStructuralSurfaceConnection();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralSurfaceMember > &getAllIfcStructuralSurfaceMember();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuralSurfaceMemberVarying > &getAllIfcStructuralSurfaceMemberVarying();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStructuredDimensionCallout > &getAllIfcStructuredDimensionCallout();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStyleModel > &getAllIfcStyleModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStyledItem > &getAllIfcStyledItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcStyledRepresentation > &getAllIfcStyledRepresentation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSubContractResource > &getAllIfcSubContractResource();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSubedge > &getAllIfcSubedge();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurface > &getAllIfcSurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceCurveSweptAreaSolid > &getAllIfcSurfaceCurveSweptAreaSolid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceOfLinearExtrusion > &getAllIfcSurfaceOfLinearExtrusion();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceOfRevolution > &getAllIfcSurfaceOfRevolution();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceStyle > &getAllIfcSurfaceStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceStyleLighting > &getAllIfcSurfaceStyleLighting();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceStyleRefraction > &getAllIfcSurfaceStyleRefraction();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceStyleRendering > &getAllIfcSurfaceStyleRendering();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceStyleShading > &getAllIfcSurfaceStyleShading();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceStyleWithTextures > &getAllIfcSurfaceStyleWithTextures();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSurfaceTexture > &getAllIfcSurfaceTexture();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSweptAreaSolid > &getAllIfcSweptAreaSolid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSweptDiskSolid > &getAllIfcSweptDiskSolid();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSweptSurface > &getAllIfcSweptSurface();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSwitchingDeviceType > &getAllIfcSwitchingDeviceType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSymbolStyle > &getAllIfcSymbolStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSystem > &getAllIfcSystem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcSystemFurnitureElementType > &getAllIfcSystemFurnitureElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTShapeProfileDef > &getAllIfcTShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTable > &getAllIfcTable();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTableRow > &getAllIfcTableRow();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTankType > &getAllIfcTankType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTask > &getAllIfcTask();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTelecomAddress > &getAllIfcTelecomAddress();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTendon > &getAllIfcTendon();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTendonAnchor > &getAllIfcTendonAnchor();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTerminatorSymbol > &getAllIfcTerminatorSymbol();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextLiteral > &getAllIfcTextLiteral();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextLiteralWithExtent > &getAllIfcTextLiteralWithExtent();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextStyle > &getAllIfcTextStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextStyleFontModel > &getAllIfcTextStyleFontModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextStyleForDefinedFont > &getAllIfcTextStyleForDefinedFont();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextStyleTextModel > &getAllIfcTextStyleTextModel();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextStyleWithBoxCharacteristics > &getAllIfcTextStyleWithBoxCharacteristics();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextureCoordinate > &getAllIfcTextureCoordinate();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextureCoordinateGenerator > &getAllIfcTextureCoordinateGenerator();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextureMap > &getAllIfcTextureMap();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTextureVertex > &getAllIfcTextureVertex();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcThermalMaterialProperties > &getAllIfcThermalMaterialProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTimeSeries > &getAllIfcTimeSeries();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTimeSeriesReferenceRelationship > &getAllIfcTimeSeriesReferenceRelationship();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTimeSeriesSchedule > &getAllIfcTimeSeriesSchedule();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTimeSeriesValue > &getAllIfcTimeSeriesValue();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTopologicalRepresentationItem > &getAllIfcTopologicalRepresentationItem();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTopologyRepresentation > &getAllIfcTopologyRepresentation();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTransformerType > &getAllIfcTransformerType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTransportElement > &getAllIfcTransportElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTransportElementType > &getAllIfcTransportElementType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTrapeziumProfileDef > &getAllIfcTrapeziumProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTrimmedCurve > &getAllIfcTrimmedCurve();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTubeBundleType > &getAllIfcTubeBundleType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTwoDirectionRepeatFactor > &getAllIfcTwoDirectionRepeatFactor();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTypeObject > &getAllIfcTypeObject();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcTypeProduct > &getAllIfcTypeProduct();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcUShapeProfileDef > &getAllIfcUShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcUnitAssignment > &getAllIfcUnitAssignment();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcUnitaryEquipmentType > &getAllIfcUnitaryEquipmentType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcValveType > &getAllIfcValveType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVector > &getAllIfcVector();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVertex > &getAllIfcVertex();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVertexBasedTextureMap > &getAllIfcVertexBasedTextureMap();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVertexLoop > &getAllIfcVertexLoop();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVertexPoint > &getAllIfcVertexPoint();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVibrationIsolatorType > &getAllIfcVibrationIsolatorType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVirtualElement > &getAllIfcVirtualElement();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcVirtualGridIntersection > &getAllIfcVirtualGridIntersection();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWall > &getAllIfcWall();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWallStandardCase > &getAllIfcWallStandardCase();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWallType > &getAllIfcWallType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWasteTerminalType > &getAllIfcWasteTerminalType();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWaterProperties > &getAllIfcWaterProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWindow > &getAllIfcWindow();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWindowLiningProperties > &getAllIfcWindowLiningProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWindowPanelProperties > &getAllIfcWindowPanelProperties();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWindowStyle > &getAllIfcWindowStyle();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWorkControl > &getAllIfcWorkControl();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWorkPlan > &getAllIfcWorkPlan();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcWorkSchedule > &getAllIfcWorkSchedule();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcZShapeProfileDef > &getAllIfcZShapeProfileDef();
        /**
         * Get all the entities of a given Entity type AND it's sub-types from this ExpressDataSet.
         * 
         * @return The list of references to the entities.
         */
        Step::RefLinkedList< IfcZone > &getAllIfcZone();
        friend class SPFReader;
        friend class SPFWriter;

    private:
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_Ifc2DCompositeCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcActionRequest_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcActor_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcActorRole_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcActuatorType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAirTerminalBoxType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAirTerminalType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAirToAirHeatRecoveryType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAlarmType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAngularDimension_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotationCurveOccurrence_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotationFillArea_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotationFillAreaOccurrence_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotationSurface_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotationSurfaceOccurrence_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotationSymbolOccurrence_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAnnotationTextOccurrence_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcApplication_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAppliedValueRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcApproval_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcApprovalActorRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcApprovalPropertyRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcApprovalRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcArbitraryClosedProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcArbitraryOpenProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcArbitraryProfileDefWithVoids_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAsset_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAsymmetricIShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAxis1Placement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAxis2Placement2D_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcAxis2Placement3D_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBeam_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBeamType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBezierCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBlobTexture_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBlock_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoilerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBooleanClippingResult_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBooleanResult_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoundaryEdgeCondition_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoundaryFaceCondition_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoundaryNodeCondition_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoundaryNodeConditionWarping_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoundedSurface_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoundingBox_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBoxedHalfSpace_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBuilding_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBuildingElementPart_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBuildingElementProxy_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBuildingElementProxyType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcBuildingStorey_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCableCarrierFittingType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCableCarrierSegmentType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCableSegmentType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCalendarDate_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCartesianPoint_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCartesianTransformationOperator2D_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCartesianTransformationOperator2DnonUniform_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCartesianTransformationOperator3D_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCartesianTransformationOperator3DnonUniform_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCenterLineProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcChamferEdgeFeature_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcChillerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCircle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCircleHollowProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCircleProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcClassification_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcClassificationItem_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcClassificationItemRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcClassificationNotation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcClassificationNotationFacet_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcClassificationReference_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcClosedShell_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCoilType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcColourRgb_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcColumn_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcColumnType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcComplexProperty_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCompositeCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCompositeCurveSegment_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCompositeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCompressorType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCondenserType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCondition_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConditionCriterion_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConnectedFaceSet_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConnectionCurveGeometry_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConnectionPointEccentricity_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConnectionPointGeometry_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConnectionPortGeometry_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConnectionSurfaceGeometry_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConstraintAggregationRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConstraintClassificationRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConstraintRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConstructionEquipmentResource_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConstructionMaterialResource_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConstructionProductResource_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcContextDependentUnit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcControllerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcConversionBasedUnit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCooledBeamType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCoolingTowerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCoordinatedUniversalTimeOffset_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCostItem_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCostSchedule_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCostValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCovering_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCoveringType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCraneRailAShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCraneRailFShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCrewResource_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCsgSolid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurrencyRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurtainWall_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurtainWallType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurveBoundedPlane_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurveStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurveStyleFont_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurveStyleFontAndScaling_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcCurveStyleFontPattern_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDamperType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDateAndTime_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDefinedSymbol_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDerivedProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDerivedUnit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDerivedUnitElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDiameterDimension_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDimensionCalloutRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDimensionCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDimensionCurveDirectedCallout_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDimensionCurveTerminator_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDimensionPair_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDimensionalExponents_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDirection_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDiscreteAccessory_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDiscreteAccessoryType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDistributionChamberElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDistributionChamberElementType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDistributionControlElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDistributionElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDistributionElementType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDistributionFlowElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDistributionPort_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDocumentElectronicFormat_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDocumentInformation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDocumentInformationRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDocumentReference_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDoor_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDoorLiningProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDoorPanelProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDoorStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDraughtingCallout_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDraughtingCalloutRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDraughtingPreDefinedColour_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDraughtingPreDefinedCurveFont_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDraughtingPreDefinedTextFont_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDuctFittingType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDuctSegmentType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcDuctSilencerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEdge_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEdgeCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEdgeLoop_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricApplianceType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricDistributionPoint_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricFlowStorageDeviceType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricGeneratorType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricHeaterType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricMotorType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricTimeControlType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricalBaseProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricalCircuit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElectricalElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElementAssembly_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcElementQuantity_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEllipse_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEllipseProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEnergyConversionDevice_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEnergyProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEnvironmentalImpactValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEquipmentElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEquipmentStandard_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEvaporativeCoolerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcEvaporatorType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcExtendedMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcExternallyDefinedHatchStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcExternallyDefinedSurfaceStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcExternallyDefinedSymbol_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcExternallyDefinedTextFont_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcExtrudedAreaSolid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFace_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFaceBasedSurfaceModel_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFaceBound_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFaceOuterBound_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFaceSurface_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFacetedBrep_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFacetedBrepWithVoids_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFailureConnectionCondition_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFanType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFastener_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFastenerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFillAreaStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFillAreaStyleHatching_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFillAreaStyleTileSymbolWithStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFillAreaStyleTiles_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFilterType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFireSuppressionTerminalType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowController_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowFitting_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowInstrumentType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowMeterType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowMovingDevice_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowSegment_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowStorageDevice_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowTerminal_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFlowTreatmentDevice_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFluidFlowProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFooting_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFuelProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFurnishingElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFurnishingElementType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFurnitureStandard_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcFurnitureType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGasTerminalType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGeneralMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGeneralProfileProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGeometricCurveSet_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGeometricRepresentationContext_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGeometricRepresentationSubContext_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGeometricSet_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGrid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGridAxis_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGridPlacement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcGroup_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcHalfSpaceSolid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcHeatExchangerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcHumidifierType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcHygroscopicMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcIShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcImageTexture_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcInventory_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcIrregularTimeSeries_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcIrregularTimeSeriesValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcJunctionBoxType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLaborResource_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLampType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLibraryInformation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLibraryReference_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightDistributionData_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightFixtureType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightIntensityDistribution_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightSourceAmbient_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightSourceDirectional_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightSourceGoniometric_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightSourcePositional_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLightSourceSpot_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLine_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLinearDimension_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLocalPlacement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLocalTime_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcLoop_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMappedItem_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMaterial_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMaterialClassificationRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMaterialDefinitionRepresentation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMaterialLayer_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMaterialLayerSet_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMaterialLayerSetUsage_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMaterialList_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMeasureWithUnit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMechanicalConcreteMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMechanicalFastener_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMechanicalFastenerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMechanicalMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMechanicalSteelMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMember_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMemberType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMetric_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMonetaryUnit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMotorConnectionType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcMove_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcObjective_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOccupant_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOffsetCurve2D_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOffsetCurve3D_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOneDirectionRepeatFactor_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOpenShell_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOpeningElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOpticalMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOrderAction_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOrganization_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOrganizationRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOrientedEdge_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOutletType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcOwnerHistory_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPath_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPerformanceHistory_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPermeableCoveringProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPermit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPerson_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPersonAndOrganization_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPhysicalComplexQuantity_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPile_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPipeFittingType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPipeSegmentType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPixelTexture_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPlanarBox_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPlanarExtent_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPlane_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPlate_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPlateType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPointOnCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPointOnSurface_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPolyLoop_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPolygonalBoundedHalfSpace_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPolyline_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPostalAddress_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPreDefinedDimensionSymbol_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPreDefinedPointMarkerSymbol_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPreDefinedTerminatorSymbol_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPresentationLayerAssignment_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPresentationLayerWithStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPresentationStyleAssignment_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProcedure_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProductDefinitionShape_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProductRepresentation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProductsOfCombustionProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProject_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProjectOrder_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProjectOrderRecord_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProjectionCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProjectionElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyBoundedValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyConstraintRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyDependencyRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyEnumeratedValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyEnumeration_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyListValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyReferenceValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertySet_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertySingleValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPropertyTableValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProtectiveDeviceType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcProxy_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcPumpType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcQuantityArea_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcQuantityCount_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcQuantityLength_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcQuantityTime_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcQuantityVolume_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcQuantityWeight_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRadiusDimension_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRailing_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRailingType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRamp_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRampFlight_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRampFlightType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRationalBezierCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRectangleHollowProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRectangleProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRectangularPyramid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRectangularTrimmedSurface_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcReferencesValueDocument_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRegularTimeSeries_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcReinforcementBarProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcReinforcementDefinitionProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcReinforcingBar_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcReinforcingMesh_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAggregates_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsTasks_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsToActor_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsToControl_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsToGroup_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsToProcess_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsToProduct_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsToProjectOrder_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssignsToResource_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociates_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesAppliedValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesApproval_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesClassification_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesConstraint_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesDocument_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesLibrary_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesMaterial_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelAssociatesProfileProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsElements_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsPathElements_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsPortToElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsPorts_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsStructuralActivity_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsStructuralElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsStructuralMember_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsWithEccentricity_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelConnectsWithRealizingElements_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelContainedInSpatialStructure_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelCoversBldgElements_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelCoversSpaces_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelDefinesByProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelDefinesByType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelFillsElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelFlowControlElements_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelInteractionRequirements_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelNests_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelOccupiesSpaces_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelOverridesProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelProjectsElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelReferencedInSpatialStructure_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelSchedulesCostItems_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelSequence_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelServicesBuildings_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelSpaceBoundary_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelVoidsElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRelaxation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRepresentation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRepresentationContext_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRepresentationMap_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRevolvedAreaSolid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRibPlateProfileProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRightCircularCone_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRightCircularCylinder_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRoof_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRoundedEdgeFeature_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcRoundedRectangleProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSIUnit_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSanitaryTerminalType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcScheduleTimeControl_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSectionProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSectionReinforcementProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSectionedSpine_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSensorType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcServiceLife_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcServiceLifeFactor_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcShapeAspect_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcShapeRepresentation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcShellBasedSurfaceModel_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSite_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSlab_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSlabType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSlippageConnectionCondition_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSoundProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSoundValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSpace_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSpaceHeaterType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSpaceProgram_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSpaceThermalLoadProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSpaceType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSphere_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStackTerminalType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStair_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStairFlight_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStairFlightType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralAnalysisModel_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralCurveConnection_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralCurveMember_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralCurveMemberVarying_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLinearAction_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLinearActionVarying_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadGroup_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadLinearForce_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadPlanarForce_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadSingleDisplacement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadSingleDisplacementDistortion_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadSingleForce_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadSingleForceWarping_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralLoadTemperature_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralPlanarAction_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralPlanarActionVarying_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralPointAction_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralPointConnection_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralPointReaction_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralProfileProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralResultGroup_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralSteelProfileProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralSurfaceConnection_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralSurfaceMember_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuralSurfaceMemberVarying_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStructuredDimensionCallout_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStyledItem_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcStyledRepresentation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSubContractResource_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSubedge_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceCurveSweptAreaSolid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceOfLinearExtrusion_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceOfRevolution_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceStyleLighting_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceStyleRefraction_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceStyleRendering_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceStyleShading_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSurfaceStyleWithTextures_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSweptDiskSolid_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSwitchingDeviceType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSymbolStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSystem_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcSystemFurnitureElementType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTable_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTableRow_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTankType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTask_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTelecomAddress_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTendon_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTendonAnchor_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTerminatorSymbol_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextLiteral_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextLiteralWithExtent_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextStyleFontModel_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextStyleForDefinedFont_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextStyleTextModel_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextStyleWithBoxCharacteristics_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextureCoordinateGenerator_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextureMap_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTextureVertex_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcThermalMaterialProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTimeSeriesReferenceRelationship_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTimeSeriesSchedule_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTimeSeriesValue_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTopologyRepresentation_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTransformerType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTransportElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTransportElementType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTrapeziumProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTrimmedCurve_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTubeBundleType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTwoDirectionRepeatFactor_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTypeObject_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcTypeProduct_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcUShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcUnitAssignment_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcUnitaryEquipmentType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcValveType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVector_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVertex_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVertexBasedTextureMap_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVertexLoop_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVertexPoint_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVibrationIsolatorType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVirtualElement_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcVirtualGridIntersection_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWall_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWallStandardCase_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWallType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWasteTerminalType_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWaterProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWindow_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWindowLiningProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWindowPanelProperties_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWindowStyle_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWorkPlan_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcWorkSchedule_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcZShapeProfileDef_Map;
        /**
         */
        std::map<Step::Id, Step::BaseObjectPtr > m_IfcZone_Map;
        /**
         */
        Step::RefLinkedList< Ifc2DCompositeCurve > m_refIfc2DCompositeCurveList;
        /**
         */
        Step::RefLinkedList< IfcActionRequest > m_refIfcActionRequestList;
        /**
         */
        Step::RefLinkedList< IfcActor > m_refIfcActorList;
        /**
         */
        Step::RefLinkedList< IfcActorRole > m_refIfcActorRoleList;
        /**
         */
        Step::RefLinkedList< IfcActuatorType > m_refIfcActuatorTypeList;
        /**
         */
        Step::RefLinkedList< IfcAddress > m_refIfcAddressList;
        /**
         */
        Step::RefLinkedList< IfcAirTerminalBoxType > m_refIfcAirTerminalBoxTypeList;
        /**
         */
        Step::RefLinkedList< IfcAirTerminalType > m_refIfcAirTerminalTypeList;
        /**
         */
        Step::RefLinkedList< IfcAirToAirHeatRecoveryType > m_refIfcAirToAirHeatRecoveryTypeList;
        /**
         */
        Step::RefLinkedList< IfcAlarmType > m_refIfcAlarmTypeList;
        /**
         */
        Step::RefLinkedList< IfcAngularDimension > m_refIfcAngularDimensionList;
        /**
         */
        Step::RefLinkedList< IfcAnnotation > m_refIfcAnnotationList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationCurveOccurrence > m_refIfcAnnotationCurveOccurrenceList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationFillArea > m_refIfcAnnotationFillAreaList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationFillAreaOccurrence > m_refIfcAnnotationFillAreaOccurrenceList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationOccurrence > m_refIfcAnnotationOccurrenceList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationSurface > m_refIfcAnnotationSurfaceList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationSurfaceOccurrence > m_refIfcAnnotationSurfaceOccurrenceList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationSymbolOccurrence > m_refIfcAnnotationSymbolOccurrenceList;
        /**
         */
        Step::RefLinkedList< IfcAnnotationTextOccurrence > m_refIfcAnnotationTextOccurrenceList;
        /**
         */
        Step::RefLinkedList< IfcApplication > m_refIfcApplicationList;
        /**
         */
        Step::RefLinkedList< IfcAppliedValue > m_refIfcAppliedValueList;
        /**
         */
        Step::RefLinkedList< IfcAppliedValueRelationship > m_refIfcAppliedValueRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcApproval > m_refIfcApprovalList;
        /**
         */
        Step::RefLinkedList< IfcApprovalActorRelationship > m_refIfcApprovalActorRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcApprovalPropertyRelationship > m_refIfcApprovalPropertyRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcApprovalRelationship > m_refIfcApprovalRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcArbitraryClosedProfileDef > m_refIfcArbitraryClosedProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcArbitraryOpenProfileDef > m_refIfcArbitraryOpenProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcArbitraryProfileDefWithVoids > m_refIfcArbitraryProfileDefWithVoidsList;
        /**
         */
        Step::RefLinkedList< IfcAsset > m_refIfcAssetList;
        /**
         */
        Step::RefLinkedList< IfcAsymmetricIShapeProfileDef > m_refIfcAsymmetricIShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcAxis1Placement > m_refIfcAxis1PlacementList;
        /**
         */
        Step::RefLinkedList< IfcAxis2Placement2D > m_refIfcAxis2Placement2DList;
        /**
         */
        Step::RefLinkedList< IfcAxis2Placement3D > m_refIfcAxis2Placement3DList;
        /**
         */
        Step::RefLinkedList< IfcBSplineCurve > m_refIfcBSplineCurveList;
        /**
         */
        Step::RefLinkedList< IfcBeam > m_refIfcBeamList;
        /**
         */
        Step::RefLinkedList< IfcBeamType > m_refIfcBeamTypeList;
        /**
         */
        Step::RefLinkedList< IfcBezierCurve > m_refIfcBezierCurveList;
        /**
         */
        Step::RefLinkedList< IfcBlobTexture > m_refIfcBlobTextureList;
        /**
         */
        Step::RefLinkedList< IfcBlock > m_refIfcBlockList;
        /**
         */
        Step::RefLinkedList< IfcBoilerType > m_refIfcBoilerTypeList;
        /**
         */
        Step::RefLinkedList< IfcBooleanClippingResult > m_refIfcBooleanClippingResultList;
        /**
         */
        Step::RefLinkedList< IfcBooleanResult > m_refIfcBooleanResultList;
        /**
         */
        Step::RefLinkedList< IfcBoundaryCondition > m_refIfcBoundaryConditionList;
        /**
         */
        Step::RefLinkedList< IfcBoundaryEdgeCondition > m_refIfcBoundaryEdgeConditionList;
        /**
         */
        Step::RefLinkedList< IfcBoundaryFaceCondition > m_refIfcBoundaryFaceConditionList;
        /**
         */
        Step::RefLinkedList< IfcBoundaryNodeCondition > m_refIfcBoundaryNodeConditionList;
        /**
         */
        Step::RefLinkedList< IfcBoundaryNodeConditionWarping > m_refIfcBoundaryNodeConditionWarpingList;
        /**
         */
        Step::RefLinkedList< IfcBoundedCurve > m_refIfcBoundedCurveList;
        /**
         */
        Step::RefLinkedList< IfcBoundedSurface > m_refIfcBoundedSurfaceList;
        /**
         */
        Step::RefLinkedList< IfcBoundingBox > m_refIfcBoundingBoxList;
        /**
         */
        Step::RefLinkedList< IfcBoxedHalfSpace > m_refIfcBoxedHalfSpaceList;
        /**
         */
        Step::RefLinkedList< IfcBuilding > m_refIfcBuildingList;
        /**
         */
        Step::RefLinkedList< IfcBuildingElement > m_refIfcBuildingElementList;
        /**
         */
        Step::RefLinkedList< IfcBuildingElementComponent > m_refIfcBuildingElementComponentList;
        /**
         */
        Step::RefLinkedList< IfcBuildingElementPart > m_refIfcBuildingElementPartList;
        /**
         */
        Step::RefLinkedList< IfcBuildingElementProxy > m_refIfcBuildingElementProxyList;
        /**
         */
        Step::RefLinkedList< IfcBuildingElementProxyType > m_refIfcBuildingElementProxyTypeList;
        /**
         */
        Step::RefLinkedList< IfcBuildingElementType > m_refIfcBuildingElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcBuildingStorey > m_refIfcBuildingStoreyList;
        /**
         */
        Step::RefLinkedList< IfcCShapeProfileDef > m_refIfcCShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcCableCarrierFittingType > m_refIfcCableCarrierFittingTypeList;
        /**
         */
        Step::RefLinkedList< IfcCableCarrierSegmentType > m_refIfcCableCarrierSegmentTypeList;
        /**
         */
        Step::RefLinkedList< IfcCableSegmentType > m_refIfcCableSegmentTypeList;
        /**
         */
        Step::RefLinkedList< IfcCalendarDate > m_refIfcCalendarDateList;
        /**
         */
        Step::RefLinkedList< IfcCartesianPoint > m_refIfcCartesianPointList;
        /**
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator > m_refIfcCartesianTransformationOperatorList;
        /**
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator2D > m_refIfcCartesianTransformationOperator2DList;
        /**
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator2DnonUniform > m_refIfcCartesianTransformationOperator2DnonUniformList;
        /**
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator3D > m_refIfcCartesianTransformationOperator3DList;
        /**
         */
        Step::RefLinkedList< IfcCartesianTransformationOperator3DnonUniform > m_refIfcCartesianTransformationOperator3DnonUniformList;
        /**
         */
        Step::RefLinkedList< IfcCenterLineProfileDef > m_refIfcCenterLineProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcChamferEdgeFeature > m_refIfcChamferEdgeFeatureList;
        /**
         */
        Step::RefLinkedList< IfcChillerType > m_refIfcChillerTypeList;
        /**
         */
        Step::RefLinkedList< IfcCircle > m_refIfcCircleList;
        /**
         */
        Step::RefLinkedList< IfcCircleHollowProfileDef > m_refIfcCircleHollowProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcCircleProfileDef > m_refIfcCircleProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcClassification > m_refIfcClassificationList;
        /**
         */
        Step::RefLinkedList< IfcClassificationItem > m_refIfcClassificationItemList;
        /**
         */
        Step::RefLinkedList< IfcClassificationItemRelationship > m_refIfcClassificationItemRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcClassificationNotation > m_refIfcClassificationNotationList;
        /**
         */
        Step::RefLinkedList< IfcClassificationNotationFacet > m_refIfcClassificationNotationFacetList;
        /**
         */
        Step::RefLinkedList< IfcClassificationReference > m_refIfcClassificationReferenceList;
        /**
         */
        Step::RefLinkedList< IfcClosedShell > m_refIfcClosedShellList;
        /**
         */
        Step::RefLinkedList< IfcCoilType > m_refIfcCoilTypeList;
        /**
         */
        Step::RefLinkedList< IfcColourRgb > m_refIfcColourRgbList;
        /**
         */
        Step::RefLinkedList< IfcColourSpecification > m_refIfcColourSpecificationList;
        /**
         */
        Step::RefLinkedList< IfcColumn > m_refIfcColumnList;
        /**
         */
        Step::RefLinkedList< IfcColumnType > m_refIfcColumnTypeList;
        /**
         */
        Step::RefLinkedList< IfcComplexProperty > m_refIfcComplexPropertyList;
        /**
         */
        Step::RefLinkedList< IfcCompositeCurve > m_refIfcCompositeCurveList;
        /**
         */
        Step::RefLinkedList< IfcCompositeCurveSegment > m_refIfcCompositeCurveSegmentList;
        /**
         */
        Step::RefLinkedList< IfcCompositeProfileDef > m_refIfcCompositeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcCompressorType > m_refIfcCompressorTypeList;
        /**
         */
        Step::RefLinkedList< IfcCondenserType > m_refIfcCondenserTypeList;
        /**
         */
        Step::RefLinkedList< IfcCondition > m_refIfcConditionList;
        /**
         */
        Step::RefLinkedList< IfcConditionCriterion > m_refIfcConditionCriterionList;
        /**
         */
        Step::RefLinkedList< IfcConic > m_refIfcConicList;
        /**
         */
        Step::RefLinkedList< IfcConnectedFaceSet > m_refIfcConnectedFaceSetList;
        /**
         */
        Step::RefLinkedList< IfcConnectionCurveGeometry > m_refIfcConnectionCurveGeometryList;
        /**
         */
        Step::RefLinkedList< IfcConnectionGeometry > m_refIfcConnectionGeometryList;
        /**
         */
        Step::RefLinkedList< IfcConnectionPointEccentricity > m_refIfcConnectionPointEccentricityList;
        /**
         */
        Step::RefLinkedList< IfcConnectionPointGeometry > m_refIfcConnectionPointGeometryList;
        /**
         */
        Step::RefLinkedList< IfcConnectionPortGeometry > m_refIfcConnectionPortGeometryList;
        /**
         */
        Step::RefLinkedList< IfcConnectionSurfaceGeometry > m_refIfcConnectionSurfaceGeometryList;
        /**
         */
        Step::RefLinkedList< IfcConstraint > m_refIfcConstraintList;
        /**
         */
        Step::RefLinkedList< IfcConstraintAggregationRelationship > m_refIfcConstraintAggregationRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcConstraintClassificationRelationship > m_refIfcConstraintClassificationRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcConstraintRelationship > m_refIfcConstraintRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcConstructionEquipmentResource > m_refIfcConstructionEquipmentResourceList;
        /**
         */
        Step::RefLinkedList< IfcConstructionMaterialResource > m_refIfcConstructionMaterialResourceList;
        /**
         */
        Step::RefLinkedList< IfcConstructionProductResource > m_refIfcConstructionProductResourceList;
        /**
         */
        Step::RefLinkedList< IfcConstructionResource > m_refIfcConstructionResourceList;
        /**
         */
        Step::RefLinkedList< IfcContextDependentUnit > m_refIfcContextDependentUnitList;
        /**
         */
        Step::RefLinkedList< IfcControl > m_refIfcControlList;
        /**
         */
        Step::RefLinkedList< IfcControllerType > m_refIfcControllerTypeList;
        /**
         */
        Step::RefLinkedList< IfcConversionBasedUnit > m_refIfcConversionBasedUnitList;
        /**
         */
        Step::RefLinkedList< IfcCooledBeamType > m_refIfcCooledBeamTypeList;
        /**
         */
        Step::RefLinkedList< IfcCoolingTowerType > m_refIfcCoolingTowerTypeList;
        /**
         */
        Step::RefLinkedList< IfcCoordinatedUniversalTimeOffset > m_refIfcCoordinatedUniversalTimeOffsetList;
        /**
         */
        Step::RefLinkedList< IfcCostItem > m_refIfcCostItemList;
        /**
         */
        Step::RefLinkedList< IfcCostSchedule > m_refIfcCostScheduleList;
        /**
         */
        Step::RefLinkedList< IfcCostValue > m_refIfcCostValueList;
        /**
         */
        Step::RefLinkedList< IfcCovering > m_refIfcCoveringList;
        /**
         */
        Step::RefLinkedList< IfcCoveringType > m_refIfcCoveringTypeList;
        /**
         */
        Step::RefLinkedList< IfcCraneRailAShapeProfileDef > m_refIfcCraneRailAShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcCraneRailFShapeProfileDef > m_refIfcCraneRailFShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcCrewResource > m_refIfcCrewResourceList;
        /**
         */
        Step::RefLinkedList< IfcCsgPrimitive3D > m_refIfcCsgPrimitive3DList;
        /**
         */
        Step::RefLinkedList< IfcCsgSolid > m_refIfcCsgSolidList;
        /**
         */
        Step::RefLinkedList< IfcCurrencyRelationship > m_refIfcCurrencyRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcCurtainWall > m_refIfcCurtainWallList;
        /**
         */
        Step::RefLinkedList< IfcCurtainWallType > m_refIfcCurtainWallTypeList;
        /**
         */
        Step::RefLinkedList< IfcCurve > m_refIfcCurveList;
        /**
         */
        Step::RefLinkedList< IfcCurveBoundedPlane > m_refIfcCurveBoundedPlaneList;
        /**
         */
        Step::RefLinkedList< IfcCurveStyle > m_refIfcCurveStyleList;
        /**
         */
        Step::RefLinkedList< IfcCurveStyleFont > m_refIfcCurveStyleFontList;
        /**
         */
        Step::RefLinkedList< IfcCurveStyleFontAndScaling > m_refIfcCurveStyleFontAndScalingList;
        /**
         */
        Step::RefLinkedList< IfcCurveStyleFontPattern > m_refIfcCurveStyleFontPatternList;
        /**
         */
        Step::RefLinkedList< IfcDamperType > m_refIfcDamperTypeList;
        /**
         */
        Step::RefLinkedList< IfcDateAndTime > m_refIfcDateAndTimeList;
        /**
         */
        Step::RefLinkedList< IfcDefinedSymbol > m_refIfcDefinedSymbolList;
        /**
         */
        Step::RefLinkedList< IfcDerivedProfileDef > m_refIfcDerivedProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcDerivedUnit > m_refIfcDerivedUnitList;
        /**
         */
        Step::RefLinkedList< IfcDerivedUnitElement > m_refIfcDerivedUnitElementList;
        /**
         */
        Step::RefLinkedList< IfcDiameterDimension > m_refIfcDiameterDimensionList;
        /**
         */
        Step::RefLinkedList< IfcDimensionCalloutRelationship > m_refIfcDimensionCalloutRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcDimensionCurve > m_refIfcDimensionCurveList;
        /**
         */
        Step::RefLinkedList< IfcDimensionCurveDirectedCallout > m_refIfcDimensionCurveDirectedCalloutList;
        /**
         */
        Step::RefLinkedList< IfcDimensionCurveTerminator > m_refIfcDimensionCurveTerminatorList;
        /**
         */
        Step::RefLinkedList< IfcDimensionPair > m_refIfcDimensionPairList;
        /**
         */
        Step::RefLinkedList< IfcDimensionalExponents > m_refIfcDimensionalExponentsList;
        /**
         */
        Step::RefLinkedList< IfcDirection > m_refIfcDirectionList;
        /**
         */
        Step::RefLinkedList< IfcDiscreteAccessory > m_refIfcDiscreteAccessoryList;
        /**
         */
        Step::RefLinkedList< IfcDiscreteAccessoryType > m_refIfcDiscreteAccessoryTypeList;
        /**
         */
        Step::RefLinkedList< IfcDistributionChamberElement > m_refIfcDistributionChamberElementList;
        /**
         */
        Step::RefLinkedList< IfcDistributionChamberElementType > m_refIfcDistributionChamberElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcDistributionControlElement > m_refIfcDistributionControlElementList;
        /**
         */
        Step::RefLinkedList< IfcDistributionControlElementType > m_refIfcDistributionControlElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcDistributionElement > m_refIfcDistributionElementList;
        /**
         */
        Step::RefLinkedList< IfcDistributionElementType > m_refIfcDistributionElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcDistributionFlowElement > m_refIfcDistributionFlowElementList;
        /**
         */
        Step::RefLinkedList< IfcDistributionFlowElementType > m_refIfcDistributionFlowElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcDistributionPort > m_refIfcDistributionPortList;
        /**
         */
        Step::RefLinkedList< IfcDocumentElectronicFormat > m_refIfcDocumentElectronicFormatList;
        /**
         */
        Step::RefLinkedList< IfcDocumentInformation > m_refIfcDocumentInformationList;
        /**
         */
        Step::RefLinkedList< IfcDocumentInformationRelationship > m_refIfcDocumentInformationRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcDocumentReference > m_refIfcDocumentReferenceList;
        /**
         */
        Step::RefLinkedList< IfcDoor > m_refIfcDoorList;
        /**
         */
        Step::RefLinkedList< IfcDoorLiningProperties > m_refIfcDoorLiningPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcDoorPanelProperties > m_refIfcDoorPanelPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcDoorStyle > m_refIfcDoorStyleList;
        /**
         */
        Step::RefLinkedList< IfcDraughtingCallout > m_refIfcDraughtingCalloutList;
        /**
         */
        Step::RefLinkedList< IfcDraughtingCalloutRelationship > m_refIfcDraughtingCalloutRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcDraughtingPreDefinedColour > m_refIfcDraughtingPreDefinedColourList;
        /**
         */
        Step::RefLinkedList< IfcDraughtingPreDefinedCurveFont > m_refIfcDraughtingPreDefinedCurveFontList;
        /**
         */
        Step::RefLinkedList< IfcDraughtingPreDefinedTextFont > m_refIfcDraughtingPreDefinedTextFontList;
        /**
         */
        Step::RefLinkedList< IfcDuctFittingType > m_refIfcDuctFittingTypeList;
        /**
         */
        Step::RefLinkedList< IfcDuctSegmentType > m_refIfcDuctSegmentTypeList;
        /**
         */
        Step::RefLinkedList< IfcDuctSilencerType > m_refIfcDuctSilencerTypeList;
        /**
         */
        Step::RefLinkedList< IfcEdge > m_refIfcEdgeList;
        /**
         */
        Step::RefLinkedList< IfcEdgeCurve > m_refIfcEdgeCurveList;
        /**
         */
        Step::RefLinkedList< IfcEdgeFeature > m_refIfcEdgeFeatureList;
        /**
         */
        Step::RefLinkedList< IfcEdgeLoop > m_refIfcEdgeLoopList;
        /**
         */
        Step::RefLinkedList< IfcElectricApplianceType > m_refIfcElectricApplianceTypeList;
        /**
         */
        Step::RefLinkedList< IfcElectricDistributionPoint > m_refIfcElectricDistributionPointList;
        /**
         */
        Step::RefLinkedList< IfcElectricFlowStorageDeviceType > m_refIfcElectricFlowStorageDeviceTypeList;
        /**
         */
        Step::RefLinkedList< IfcElectricGeneratorType > m_refIfcElectricGeneratorTypeList;
        /**
         */
        Step::RefLinkedList< IfcElectricHeaterType > m_refIfcElectricHeaterTypeList;
        /**
         */
        Step::RefLinkedList< IfcElectricMotorType > m_refIfcElectricMotorTypeList;
        /**
         */
        Step::RefLinkedList< IfcElectricTimeControlType > m_refIfcElectricTimeControlTypeList;
        /**
         */
        Step::RefLinkedList< IfcElectricalBaseProperties > m_refIfcElectricalBasePropertiesList;
        /**
         */
        Step::RefLinkedList< IfcElectricalCircuit > m_refIfcElectricalCircuitList;
        /**
         */
        Step::RefLinkedList< IfcElectricalElement > m_refIfcElectricalElementList;
        /**
         */
        Step::RefLinkedList< IfcElement > m_refIfcElementList;
        /**
         */
        Step::RefLinkedList< IfcElementAssembly > m_refIfcElementAssemblyList;
        /**
         */
        Step::RefLinkedList< IfcElementComponent > m_refIfcElementComponentList;
        /**
         */
        Step::RefLinkedList< IfcElementComponentType > m_refIfcElementComponentTypeList;
        /**
         */
        Step::RefLinkedList< IfcElementQuantity > m_refIfcElementQuantityList;
        /**
         */
        Step::RefLinkedList< IfcElementType > m_refIfcElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcElementarySurface > m_refIfcElementarySurfaceList;
        /**
         */
        Step::RefLinkedList< IfcEllipse > m_refIfcEllipseList;
        /**
         */
        Step::RefLinkedList< IfcEllipseProfileDef > m_refIfcEllipseProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcEnergyConversionDevice > m_refIfcEnergyConversionDeviceList;
        /**
         */
        Step::RefLinkedList< IfcEnergyConversionDeviceType > m_refIfcEnergyConversionDeviceTypeList;
        /**
         */
        Step::RefLinkedList< IfcEnergyProperties > m_refIfcEnergyPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcEnvironmentalImpactValue > m_refIfcEnvironmentalImpactValueList;
        /**
         */
        Step::RefLinkedList< IfcEquipmentElement > m_refIfcEquipmentElementList;
        /**
         */
        Step::RefLinkedList< IfcEquipmentStandard > m_refIfcEquipmentStandardList;
        /**
         */
        Step::RefLinkedList< IfcEvaporativeCoolerType > m_refIfcEvaporativeCoolerTypeList;
        /**
         */
        Step::RefLinkedList< IfcEvaporatorType > m_refIfcEvaporatorTypeList;
        /**
         */
        Step::RefLinkedList< IfcExtendedMaterialProperties > m_refIfcExtendedMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcExternalReference > m_refIfcExternalReferenceList;
        /**
         */
        Step::RefLinkedList< IfcExternallyDefinedHatchStyle > m_refIfcExternallyDefinedHatchStyleList;
        /**
         */
        Step::RefLinkedList< IfcExternallyDefinedSurfaceStyle > m_refIfcExternallyDefinedSurfaceStyleList;
        /**
         */
        Step::RefLinkedList< IfcExternallyDefinedSymbol > m_refIfcExternallyDefinedSymbolList;
        /**
         */
        Step::RefLinkedList< IfcExternallyDefinedTextFont > m_refIfcExternallyDefinedTextFontList;
        /**
         */
        Step::RefLinkedList< IfcExtrudedAreaSolid > m_refIfcExtrudedAreaSolidList;
        /**
         */
        Step::RefLinkedList< IfcFace > m_refIfcFaceList;
        /**
         */
        Step::RefLinkedList< IfcFaceBasedSurfaceModel > m_refIfcFaceBasedSurfaceModelList;
        /**
         */
        Step::RefLinkedList< IfcFaceBound > m_refIfcFaceBoundList;
        /**
         */
        Step::RefLinkedList< IfcFaceOuterBound > m_refIfcFaceOuterBoundList;
        /**
         */
        Step::RefLinkedList< IfcFaceSurface > m_refIfcFaceSurfaceList;
        /**
         */
        Step::RefLinkedList< IfcFacetedBrep > m_refIfcFacetedBrepList;
        /**
         */
        Step::RefLinkedList< IfcFacetedBrepWithVoids > m_refIfcFacetedBrepWithVoidsList;
        /**
         */
        Step::RefLinkedList< IfcFailureConnectionCondition > m_refIfcFailureConnectionConditionList;
        /**
         */
        Step::RefLinkedList< IfcFanType > m_refIfcFanTypeList;
        /**
         */
        Step::RefLinkedList< IfcFastener > m_refIfcFastenerList;
        /**
         */
        Step::RefLinkedList< IfcFastenerType > m_refIfcFastenerTypeList;
        /**
         */
        Step::RefLinkedList< IfcFeatureElement > m_refIfcFeatureElementList;
        /**
         */
        Step::RefLinkedList< IfcFeatureElementAddition > m_refIfcFeatureElementAdditionList;
        /**
         */
        Step::RefLinkedList< IfcFeatureElementSubtraction > m_refIfcFeatureElementSubtractionList;
        /**
         */
        Step::RefLinkedList< IfcFillAreaStyle > m_refIfcFillAreaStyleList;
        /**
         */
        Step::RefLinkedList< IfcFillAreaStyleHatching > m_refIfcFillAreaStyleHatchingList;
        /**
         */
        Step::RefLinkedList< IfcFillAreaStyleTileSymbolWithStyle > m_refIfcFillAreaStyleTileSymbolWithStyleList;
        /**
         */
        Step::RefLinkedList< IfcFillAreaStyleTiles > m_refIfcFillAreaStyleTilesList;
        /**
         */
        Step::RefLinkedList< IfcFilterType > m_refIfcFilterTypeList;
        /**
         */
        Step::RefLinkedList< IfcFireSuppressionTerminalType > m_refIfcFireSuppressionTerminalTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowController > m_refIfcFlowControllerList;
        /**
         */
        Step::RefLinkedList< IfcFlowControllerType > m_refIfcFlowControllerTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowFitting > m_refIfcFlowFittingList;
        /**
         */
        Step::RefLinkedList< IfcFlowFittingType > m_refIfcFlowFittingTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowInstrumentType > m_refIfcFlowInstrumentTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowMeterType > m_refIfcFlowMeterTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowMovingDevice > m_refIfcFlowMovingDeviceList;
        /**
         */
        Step::RefLinkedList< IfcFlowMovingDeviceType > m_refIfcFlowMovingDeviceTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowSegment > m_refIfcFlowSegmentList;
        /**
         */
        Step::RefLinkedList< IfcFlowSegmentType > m_refIfcFlowSegmentTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowStorageDevice > m_refIfcFlowStorageDeviceList;
        /**
         */
        Step::RefLinkedList< IfcFlowStorageDeviceType > m_refIfcFlowStorageDeviceTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowTerminal > m_refIfcFlowTerminalList;
        /**
         */
        Step::RefLinkedList< IfcFlowTerminalType > m_refIfcFlowTerminalTypeList;
        /**
         */
        Step::RefLinkedList< IfcFlowTreatmentDevice > m_refIfcFlowTreatmentDeviceList;
        /**
         */
        Step::RefLinkedList< IfcFlowTreatmentDeviceType > m_refIfcFlowTreatmentDeviceTypeList;
        /**
         */
        Step::RefLinkedList< IfcFluidFlowProperties > m_refIfcFluidFlowPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcFooting > m_refIfcFootingList;
        /**
         */
        Step::RefLinkedList< IfcFuelProperties > m_refIfcFuelPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcFurnishingElement > m_refIfcFurnishingElementList;
        /**
         */
        Step::RefLinkedList< IfcFurnishingElementType > m_refIfcFurnishingElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcFurnitureStandard > m_refIfcFurnitureStandardList;
        /**
         */
        Step::RefLinkedList< IfcFurnitureType > m_refIfcFurnitureTypeList;
        /**
         */
        Step::RefLinkedList< IfcGasTerminalType > m_refIfcGasTerminalTypeList;
        /**
         */
        Step::RefLinkedList< IfcGeneralMaterialProperties > m_refIfcGeneralMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcGeneralProfileProperties > m_refIfcGeneralProfilePropertiesList;
        /**
         */
        Step::RefLinkedList< IfcGeometricCurveSet > m_refIfcGeometricCurveSetList;
        /**
         */
        Step::RefLinkedList< IfcGeometricRepresentationContext > m_refIfcGeometricRepresentationContextList;
        /**
         */
        Step::RefLinkedList< IfcGeometricRepresentationItem > m_refIfcGeometricRepresentationItemList;
        /**
         */
        Step::RefLinkedList< IfcGeometricRepresentationSubContext > m_refIfcGeometricRepresentationSubContextList;
        /**
         */
        Step::RefLinkedList< IfcGeometricSet > m_refIfcGeometricSetList;
        /**
         */
        Step::RefLinkedList< IfcGrid > m_refIfcGridList;
        /**
         */
        Step::RefLinkedList< IfcGridAxis > m_refIfcGridAxisList;
        /**
         */
        Step::RefLinkedList< IfcGridPlacement > m_refIfcGridPlacementList;
        /**
         */
        Step::RefLinkedList< IfcGroup > m_refIfcGroupList;
        /**
         */
        Step::RefLinkedList< IfcHalfSpaceSolid > m_refIfcHalfSpaceSolidList;
        /**
         */
        Step::RefLinkedList< IfcHeatExchangerType > m_refIfcHeatExchangerTypeList;
        /**
         */
        Step::RefLinkedList< IfcHumidifierType > m_refIfcHumidifierTypeList;
        /**
         */
        Step::RefLinkedList< IfcHygroscopicMaterialProperties > m_refIfcHygroscopicMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcIShapeProfileDef > m_refIfcIShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcImageTexture > m_refIfcImageTextureList;
        /**
         */
        Step::RefLinkedList< IfcInventory > m_refIfcInventoryList;
        /**
         */
        Step::RefLinkedList< IfcIrregularTimeSeries > m_refIfcIrregularTimeSeriesList;
        /**
         */
        Step::RefLinkedList< IfcIrregularTimeSeriesValue > m_refIfcIrregularTimeSeriesValueList;
        /**
         */
        Step::RefLinkedList< IfcJunctionBoxType > m_refIfcJunctionBoxTypeList;
        /**
         */
        Step::RefLinkedList< IfcLShapeProfileDef > m_refIfcLShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcLaborResource > m_refIfcLaborResourceList;
        /**
         */
        Step::RefLinkedList< IfcLampType > m_refIfcLampTypeList;
        /**
         */
        Step::RefLinkedList< IfcLibraryInformation > m_refIfcLibraryInformationList;
        /**
         */
        Step::RefLinkedList< IfcLibraryReference > m_refIfcLibraryReferenceList;
        /**
         */
        Step::RefLinkedList< IfcLightDistributionData > m_refIfcLightDistributionDataList;
        /**
         */
        Step::RefLinkedList< IfcLightFixtureType > m_refIfcLightFixtureTypeList;
        /**
         */
        Step::RefLinkedList< IfcLightIntensityDistribution > m_refIfcLightIntensityDistributionList;
        /**
         */
        Step::RefLinkedList< IfcLightSource > m_refIfcLightSourceList;
        /**
         */
        Step::RefLinkedList< IfcLightSourceAmbient > m_refIfcLightSourceAmbientList;
        /**
         */
        Step::RefLinkedList< IfcLightSourceDirectional > m_refIfcLightSourceDirectionalList;
        /**
         */
        Step::RefLinkedList< IfcLightSourceGoniometric > m_refIfcLightSourceGoniometricList;
        /**
         */
        Step::RefLinkedList< IfcLightSourcePositional > m_refIfcLightSourcePositionalList;
        /**
         */
        Step::RefLinkedList< IfcLightSourceSpot > m_refIfcLightSourceSpotList;
        /**
         */
        Step::RefLinkedList< IfcLine > m_refIfcLineList;
        /**
         */
        Step::RefLinkedList< IfcLinearDimension > m_refIfcLinearDimensionList;
        /**
         */
        Step::RefLinkedList< IfcLocalPlacement > m_refIfcLocalPlacementList;
        /**
         */
        Step::RefLinkedList< IfcLocalTime > m_refIfcLocalTimeList;
        /**
         */
        Step::RefLinkedList< IfcLoop > m_refIfcLoopList;
        /**
         */
        Step::RefLinkedList< IfcManifoldSolidBrep > m_refIfcManifoldSolidBrepList;
        /**
         */
        Step::RefLinkedList< IfcMappedItem > m_refIfcMappedItemList;
        /**
         */
        Step::RefLinkedList< IfcMaterial > m_refIfcMaterialList;
        /**
         */
        Step::RefLinkedList< IfcMaterialClassificationRelationship > m_refIfcMaterialClassificationRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcMaterialDefinitionRepresentation > m_refIfcMaterialDefinitionRepresentationList;
        /**
         */
        Step::RefLinkedList< IfcMaterialLayer > m_refIfcMaterialLayerList;
        /**
         */
        Step::RefLinkedList< IfcMaterialLayerSet > m_refIfcMaterialLayerSetList;
        /**
         */
        Step::RefLinkedList< IfcMaterialLayerSetUsage > m_refIfcMaterialLayerSetUsageList;
        /**
         */
        Step::RefLinkedList< IfcMaterialList > m_refIfcMaterialListList;
        /**
         */
        Step::RefLinkedList< IfcMaterialProperties > m_refIfcMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcMeasureWithUnit > m_refIfcMeasureWithUnitList;
        /**
         */
        Step::RefLinkedList< IfcMechanicalConcreteMaterialProperties > m_refIfcMechanicalConcreteMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcMechanicalFastener > m_refIfcMechanicalFastenerList;
        /**
         */
        Step::RefLinkedList< IfcMechanicalFastenerType > m_refIfcMechanicalFastenerTypeList;
        /**
         */
        Step::RefLinkedList< IfcMechanicalMaterialProperties > m_refIfcMechanicalMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcMechanicalSteelMaterialProperties > m_refIfcMechanicalSteelMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcMember > m_refIfcMemberList;
        /**
         */
        Step::RefLinkedList< IfcMemberType > m_refIfcMemberTypeList;
        /**
         */
        Step::RefLinkedList< IfcMetric > m_refIfcMetricList;
        /**
         */
        Step::RefLinkedList< IfcMonetaryUnit > m_refIfcMonetaryUnitList;
        /**
         */
        Step::RefLinkedList< IfcMotorConnectionType > m_refIfcMotorConnectionTypeList;
        /**
         */
        Step::RefLinkedList< IfcMove > m_refIfcMoveList;
        /**
         */
        Step::RefLinkedList< IfcNamedUnit > m_refIfcNamedUnitList;
        /**
         */
        Step::RefLinkedList< IfcObject > m_refIfcObjectList;
        /**
         */
        Step::RefLinkedList< IfcObjectDefinition > m_refIfcObjectDefinitionList;
        /**
         */
        Step::RefLinkedList< IfcObjectPlacement > m_refIfcObjectPlacementList;
        /**
         */
        Step::RefLinkedList< IfcObjective > m_refIfcObjectiveList;
        /**
         */
        Step::RefLinkedList< IfcOccupant > m_refIfcOccupantList;
        /**
         */
        Step::RefLinkedList< IfcOffsetCurve2D > m_refIfcOffsetCurve2DList;
        /**
         */
        Step::RefLinkedList< IfcOffsetCurve3D > m_refIfcOffsetCurve3DList;
        /**
         */
        Step::RefLinkedList< IfcOneDirectionRepeatFactor > m_refIfcOneDirectionRepeatFactorList;
        /**
         */
        Step::RefLinkedList< IfcOpenShell > m_refIfcOpenShellList;
        /**
         */
        Step::RefLinkedList< IfcOpeningElement > m_refIfcOpeningElementList;
        /**
         */
        Step::RefLinkedList< IfcOpticalMaterialProperties > m_refIfcOpticalMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcOrderAction > m_refIfcOrderActionList;
        /**
         */
        Step::RefLinkedList< IfcOrganization > m_refIfcOrganizationList;
        /**
         */
        Step::RefLinkedList< IfcOrganizationRelationship > m_refIfcOrganizationRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcOrientedEdge > m_refIfcOrientedEdgeList;
        /**
         */
        Step::RefLinkedList< IfcOutletType > m_refIfcOutletTypeList;
        /**
         */
        Step::RefLinkedList< IfcOwnerHistory > m_refIfcOwnerHistoryList;
        /**
         */
        Step::RefLinkedList< IfcParameterizedProfileDef > m_refIfcParameterizedProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcPath > m_refIfcPathList;
        /**
         */
        Step::RefLinkedList< IfcPerformanceHistory > m_refIfcPerformanceHistoryList;
        /**
         */
        Step::RefLinkedList< IfcPermeableCoveringProperties > m_refIfcPermeableCoveringPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcPermit > m_refIfcPermitList;
        /**
         */
        Step::RefLinkedList< IfcPerson > m_refIfcPersonList;
        /**
         */
        Step::RefLinkedList< IfcPersonAndOrganization > m_refIfcPersonAndOrganizationList;
        /**
         */
        Step::RefLinkedList< IfcPhysicalComplexQuantity > m_refIfcPhysicalComplexQuantityList;
        /**
         */
        Step::RefLinkedList< IfcPhysicalQuantity > m_refIfcPhysicalQuantityList;
        /**
         */
        Step::RefLinkedList< IfcPhysicalSimpleQuantity > m_refIfcPhysicalSimpleQuantityList;
        /**
         */
        Step::RefLinkedList< IfcPile > m_refIfcPileList;
        /**
         */
        Step::RefLinkedList< IfcPipeFittingType > m_refIfcPipeFittingTypeList;
        /**
         */
        Step::RefLinkedList< IfcPipeSegmentType > m_refIfcPipeSegmentTypeList;
        /**
         */
        Step::RefLinkedList< IfcPixelTexture > m_refIfcPixelTextureList;
        /**
         */
        Step::RefLinkedList< IfcPlacement > m_refIfcPlacementList;
        /**
         */
        Step::RefLinkedList< IfcPlanarBox > m_refIfcPlanarBoxList;
        /**
         */
        Step::RefLinkedList< IfcPlanarExtent > m_refIfcPlanarExtentList;
        /**
         */
        Step::RefLinkedList< IfcPlane > m_refIfcPlaneList;
        /**
         */
        Step::RefLinkedList< IfcPlate > m_refIfcPlateList;
        /**
         */
        Step::RefLinkedList< IfcPlateType > m_refIfcPlateTypeList;
        /**
         */
        Step::RefLinkedList< IfcPoint > m_refIfcPointList;
        /**
         */
        Step::RefLinkedList< IfcPointOnCurve > m_refIfcPointOnCurveList;
        /**
         */
        Step::RefLinkedList< IfcPointOnSurface > m_refIfcPointOnSurfaceList;
        /**
         */
        Step::RefLinkedList< IfcPolyLoop > m_refIfcPolyLoopList;
        /**
         */
        Step::RefLinkedList< IfcPolygonalBoundedHalfSpace > m_refIfcPolygonalBoundedHalfSpaceList;
        /**
         */
        Step::RefLinkedList< IfcPolyline > m_refIfcPolylineList;
        /**
         */
        Step::RefLinkedList< IfcPort > m_refIfcPortList;
        /**
         */
        Step::RefLinkedList< IfcPostalAddress > m_refIfcPostalAddressList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedColour > m_refIfcPreDefinedColourList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedCurveFont > m_refIfcPreDefinedCurveFontList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedDimensionSymbol > m_refIfcPreDefinedDimensionSymbolList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedItem > m_refIfcPreDefinedItemList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedPointMarkerSymbol > m_refIfcPreDefinedPointMarkerSymbolList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedSymbol > m_refIfcPreDefinedSymbolList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedTerminatorSymbol > m_refIfcPreDefinedTerminatorSymbolList;
        /**
         */
        Step::RefLinkedList< IfcPreDefinedTextFont > m_refIfcPreDefinedTextFontList;
        /**
         */
        Step::RefLinkedList< IfcPresentationLayerAssignment > m_refIfcPresentationLayerAssignmentList;
        /**
         */
        Step::RefLinkedList< IfcPresentationLayerWithStyle > m_refIfcPresentationLayerWithStyleList;
        /**
         */
        Step::RefLinkedList< IfcPresentationStyle > m_refIfcPresentationStyleList;
        /**
         */
        Step::RefLinkedList< IfcPresentationStyleAssignment > m_refIfcPresentationStyleAssignmentList;
        /**
         */
        Step::RefLinkedList< IfcProcedure > m_refIfcProcedureList;
        /**
         */
        Step::RefLinkedList< IfcProcess > m_refIfcProcessList;
        /**
         */
        Step::RefLinkedList< IfcProduct > m_refIfcProductList;
        /**
         */
        Step::RefLinkedList< IfcProductDefinitionShape > m_refIfcProductDefinitionShapeList;
        /**
         */
        Step::RefLinkedList< IfcProductRepresentation > m_refIfcProductRepresentationList;
        /**
         */
        Step::RefLinkedList< IfcProductsOfCombustionProperties > m_refIfcProductsOfCombustionPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcProfileDef > m_refIfcProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcProfileProperties > m_refIfcProfilePropertiesList;
        /**
         */
        Step::RefLinkedList< IfcProject > m_refIfcProjectList;
        /**
         */
        Step::RefLinkedList< IfcProjectOrder > m_refIfcProjectOrderList;
        /**
         */
        Step::RefLinkedList< IfcProjectOrderRecord > m_refIfcProjectOrderRecordList;
        /**
         */
        Step::RefLinkedList< IfcProjectionCurve > m_refIfcProjectionCurveList;
        /**
         */
        Step::RefLinkedList< IfcProjectionElement > m_refIfcProjectionElementList;
        /**
         */
        Step::RefLinkedList< IfcProperty > m_refIfcPropertyList;
        /**
         */
        Step::RefLinkedList< IfcPropertyBoundedValue > m_refIfcPropertyBoundedValueList;
        /**
         */
        Step::RefLinkedList< IfcPropertyConstraintRelationship > m_refIfcPropertyConstraintRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcPropertyDefinition > m_refIfcPropertyDefinitionList;
        /**
         */
        Step::RefLinkedList< IfcPropertyDependencyRelationship > m_refIfcPropertyDependencyRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcPropertyEnumeratedValue > m_refIfcPropertyEnumeratedValueList;
        /**
         */
        Step::RefLinkedList< IfcPropertyEnumeration > m_refIfcPropertyEnumerationList;
        /**
         */
        Step::RefLinkedList< IfcPropertyListValue > m_refIfcPropertyListValueList;
        /**
         */
        Step::RefLinkedList< IfcPropertyReferenceValue > m_refIfcPropertyReferenceValueList;
        /**
         */
        Step::RefLinkedList< IfcPropertySet > m_refIfcPropertySetList;
        /**
         */
        Step::RefLinkedList< IfcPropertySetDefinition > m_refIfcPropertySetDefinitionList;
        /**
         */
        Step::RefLinkedList< IfcPropertySingleValue > m_refIfcPropertySingleValueList;
        /**
         */
        Step::RefLinkedList< IfcPropertyTableValue > m_refIfcPropertyTableValueList;
        /**
         */
        Step::RefLinkedList< IfcProtectiveDeviceType > m_refIfcProtectiveDeviceTypeList;
        /**
         */
        Step::RefLinkedList< IfcProxy > m_refIfcProxyList;
        /**
         */
        Step::RefLinkedList< IfcPumpType > m_refIfcPumpTypeList;
        /**
         */
        Step::RefLinkedList< IfcQuantityArea > m_refIfcQuantityAreaList;
        /**
         */
        Step::RefLinkedList< IfcQuantityCount > m_refIfcQuantityCountList;
        /**
         */
        Step::RefLinkedList< IfcQuantityLength > m_refIfcQuantityLengthList;
        /**
         */
        Step::RefLinkedList< IfcQuantityTime > m_refIfcQuantityTimeList;
        /**
         */
        Step::RefLinkedList< IfcQuantityVolume > m_refIfcQuantityVolumeList;
        /**
         */
        Step::RefLinkedList< IfcQuantityWeight > m_refIfcQuantityWeightList;
        /**
         */
        Step::RefLinkedList< IfcRadiusDimension > m_refIfcRadiusDimensionList;
        /**
         */
        Step::RefLinkedList< IfcRailing > m_refIfcRailingList;
        /**
         */
        Step::RefLinkedList< IfcRailingType > m_refIfcRailingTypeList;
        /**
         */
        Step::RefLinkedList< IfcRamp > m_refIfcRampList;
        /**
         */
        Step::RefLinkedList< IfcRampFlight > m_refIfcRampFlightList;
        /**
         */
        Step::RefLinkedList< IfcRampFlightType > m_refIfcRampFlightTypeList;
        /**
         */
        Step::RefLinkedList< IfcRationalBezierCurve > m_refIfcRationalBezierCurveList;
        /**
         */
        Step::RefLinkedList< IfcRectangleHollowProfileDef > m_refIfcRectangleHollowProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcRectangleProfileDef > m_refIfcRectangleProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcRectangularPyramid > m_refIfcRectangularPyramidList;
        /**
         */
        Step::RefLinkedList< IfcRectangularTrimmedSurface > m_refIfcRectangularTrimmedSurfaceList;
        /**
         */
        Step::RefLinkedList< IfcReferencesValueDocument > m_refIfcReferencesValueDocumentList;
        /**
         */
        Step::RefLinkedList< IfcRegularTimeSeries > m_refIfcRegularTimeSeriesList;
        /**
         */
        Step::RefLinkedList< IfcReinforcementBarProperties > m_refIfcReinforcementBarPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcReinforcementDefinitionProperties > m_refIfcReinforcementDefinitionPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcReinforcingBar > m_refIfcReinforcingBarList;
        /**
         */
        Step::RefLinkedList< IfcReinforcingElement > m_refIfcReinforcingElementList;
        /**
         */
        Step::RefLinkedList< IfcReinforcingMesh > m_refIfcReinforcingMeshList;
        /**
         */
        Step::RefLinkedList< IfcRelAggregates > m_refIfcRelAggregatesList;
        /**
         */
        Step::RefLinkedList< IfcRelAssigns > m_refIfcRelAssignsList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsTasks > m_refIfcRelAssignsTasksList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsToActor > m_refIfcRelAssignsToActorList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsToControl > m_refIfcRelAssignsToControlList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsToGroup > m_refIfcRelAssignsToGroupList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsToProcess > m_refIfcRelAssignsToProcessList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsToProduct > m_refIfcRelAssignsToProductList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsToProjectOrder > m_refIfcRelAssignsToProjectOrderList;
        /**
         */
        Step::RefLinkedList< IfcRelAssignsToResource > m_refIfcRelAssignsToResourceList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociates > m_refIfcRelAssociatesList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesAppliedValue > m_refIfcRelAssociatesAppliedValueList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesApproval > m_refIfcRelAssociatesApprovalList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesClassification > m_refIfcRelAssociatesClassificationList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesConstraint > m_refIfcRelAssociatesConstraintList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesDocument > m_refIfcRelAssociatesDocumentList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesLibrary > m_refIfcRelAssociatesLibraryList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesMaterial > m_refIfcRelAssociatesMaterialList;
        /**
         */
        Step::RefLinkedList< IfcRelAssociatesProfileProperties > m_refIfcRelAssociatesProfilePropertiesList;
        /**
         */
        Step::RefLinkedList< IfcRelConnects > m_refIfcRelConnectsList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsElements > m_refIfcRelConnectsElementsList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsPathElements > m_refIfcRelConnectsPathElementsList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsPortToElement > m_refIfcRelConnectsPortToElementList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsPorts > m_refIfcRelConnectsPortsList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsStructuralActivity > m_refIfcRelConnectsStructuralActivityList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsStructuralElement > m_refIfcRelConnectsStructuralElementList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsStructuralMember > m_refIfcRelConnectsStructuralMemberList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsWithEccentricity > m_refIfcRelConnectsWithEccentricityList;
        /**
         */
        Step::RefLinkedList< IfcRelConnectsWithRealizingElements > m_refIfcRelConnectsWithRealizingElementsList;
        /**
         */
        Step::RefLinkedList< IfcRelContainedInSpatialStructure > m_refIfcRelContainedInSpatialStructureList;
        /**
         */
        Step::RefLinkedList< IfcRelCoversBldgElements > m_refIfcRelCoversBldgElementsList;
        /**
         */
        Step::RefLinkedList< IfcRelCoversSpaces > m_refIfcRelCoversSpacesList;
        /**
         */
        Step::RefLinkedList< IfcRelDecomposes > m_refIfcRelDecomposesList;
        /**
         */
        Step::RefLinkedList< IfcRelDefines > m_refIfcRelDefinesList;
        /**
         */
        Step::RefLinkedList< IfcRelDefinesByProperties > m_refIfcRelDefinesByPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcRelDefinesByType > m_refIfcRelDefinesByTypeList;
        /**
         */
        Step::RefLinkedList< IfcRelFillsElement > m_refIfcRelFillsElementList;
        /**
         */
        Step::RefLinkedList< IfcRelFlowControlElements > m_refIfcRelFlowControlElementsList;
        /**
         */
        Step::RefLinkedList< IfcRelInteractionRequirements > m_refIfcRelInteractionRequirementsList;
        /**
         */
        Step::RefLinkedList< IfcRelNests > m_refIfcRelNestsList;
        /**
         */
        Step::RefLinkedList< IfcRelOccupiesSpaces > m_refIfcRelOccupiesSpacesList;
        /**
         */
        Step::RefLinkedList< IfcRelOverridesProperties > m_refIfcRelOverridesPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcRelProjectsElement > m_refIfcRelProjectsElementList;
        /**
         */
        Step::RefLinkedList< IfcRelReferencedInSpatialStructure > m_refIfcRelReferencedInSpatialStructureList;
        /**
         */
        Step::RefLinkedList< IfcRelSchedulesCostItems > m_refIfcRelSchedulesCostItemsList;
        /**
         */
        Step::RefLinkedList< IfcRelSequence > m_refIfcRelSequenceList;
        /**
         */
        Step::RefLinkedList< IfcRelServicesBuildings > m_refIfcRelServicesBuildingsList;
        /**
         */
        Step::RefLinkedList< IfcRelSpaceBoundary > m_refIfcRelSpaceBoundaryList;
        /**
         */
        Step::RefLinkedList< IfcRelVoidsElement > m_refIfcRelVoidsElementList;
        /**
         */
        Step::RefLinkedList< IfcRelationship > m_refIfcRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcRelaxation > m_refIfcRelaxationList;
        /**
         */
        Step::RefLinkedList< IfcRepresentation > m_refIfcRepresentationList;
        /**
         */
        Step::RefLinkedList< IfcRepresentationContext > m_refIfcRepresentationContextList;
        /**
         */
        Step::RefLinkedList< IfcRepresentationItem > m_refIfcRepresentationItemList;
        /**
         */
        Step::RefLinkedList< IfcRepresentationMap > m_refIfcRepresentationMapList;
        /**
         */
        Step::RefLinkedList< IfcResource > m_refIfcResourceList;
        /**
         */
        Step::RefLinkedList< IfcRevolvedAreaSolid > m_refIfcRevolvedAreaSolidList;
        /**
         */
        Step::RefLinkedList< IfcRibPlateProfileProperties > m_refIfcRibPlateProfilePropertiesList;
        /**
         */
        Step::RefLinkedList< IfcRightCircularCone > m_refIfcRightCircularConeList;
        /**
         */
        Step::RefLinkedList< IfcRightCircularCylinder > m_refIfcRightCircularCylinderList;
        /**
         */
        Step::RefLinkedList< IfcRoof > m_refIfcRoofList;
        /**
         */
        Step::RefLinkedList< IfcRoot > m_refIfcRootList;
        /**
         */
        Step::RefLinkedList< IfcRoundedEdgeFeature > m_refIfcRoundedEdgeFeatureList;
        /**
         */
        Step::RefLinkedList< IfcRoundedRectangleProfileDef > m_refIfcRoundedRectangleProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcSIUnit > m_refIfcSIUnitList;
        /**
         */
        Step::RefLinkedList< IfcSanitaryTerminalType > m_refIfcSanitaryTerminalTypeList;
        /**
         */
        Step::RefLinkedList< IfcScheduleTimeControl > m_refIfcScheduleTimeControlList;
        /**
         */
        Step::RefLinkedList< IfcSectionProperties > m_refIfcSectionPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcSectionReinforcementProperties > m_refIfcSectionReinforcementPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcSectionedSpine > m_refIfcSectionedSpineList;
        /**
         */
        Step::RefLinkedList< IfcSensorType > m_refIfcSensorTypeList;
        /**
         */
        Step::RefLinkedList< IfcServiceLife > m_refIfcServiceLifeList;
        /**
         */
        Step::RefLinkedList< IfcServiceLifeFactor > m_refIfcServiceLifeFactorList;
        /**
         */
        Step::RefLinkedList< IfcShapeAspect > m_refIfcShapeAspectList;
        /**
         */
        Step::RefLinkedList< IfcShapeModel > m_refIfcShapeModelList;
        /**
         */
        Step::RefLinkedList< IfcShapeRepresentation > m_refIfcShapeRepresentationList;
        /**
         */
        Step::RefLinkedList< IfcShellBasedSurfaceModel > m_refIfcShellBasedSurfaceModelList;
        /**
         */
        Step::RefLinkedList< IfcSimpleProperty > m_refIfcSimplePropertyList;
        /**
         */
        Step::RefLinkedList< IfcSite > m_refIfcSiteList;
        /**
         */
        Step::RefLinkedList< IfcSlab > m_refIfcSlabList;
        /**
         */
        Step::RefLinkedList< IfcSlabType > m_refIfcSlabTypeList;
        /**
         */
        Step::RefLinkedList< IfcSlippageConnectionCondition > m_refIfcSlippageConnectionConditionList;
        /**
         */
        Step::RefLinkedList< IfcSolidModel > m_refIfcSolidModelList;
        /**
         */
        Step::RefLinkedList< IfcSoundProperties > m_refIfcSoundPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcSoundValue > m_refIfcSoundValueList;
        /**
         */
        Step::RefLinkedList< IfcSpace > m_refIfcSpaceList;
        /**
         */
        Step::RefLinkedList< IfcSpaceHeaterType > m_refIfcSpaceHeaterTypeList;
        /**
         */
        Step::RefLinkedList< IfcSpaceProgram > m_refIfcSpaceProgramList;
        /**
         */
        Step::RefLinkedList< IfcSpaceThermalLoadProperties > m_refIfcSpaceThermalLoadPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcSpaceType > m_refIfcSpaceTypeList;
        /**
         */
        Step::RefLinkedList< IfcSpatialStructureElement > m_refIfcSpatialStructureElementList;
        /**
         */
        Step::RefLinkedList< IfcSpatialStructureElementType > m_refIfcSpatialStructureElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcSphere > m_refIfcSphereList;
        /**
         */
        Step::RefLinkedList< IfcStackTerminalType > m_refIfcStackTerminalTypeList;
        /**
         */
        Step::RefLinkedList< IfcStair > m_refIfcStairList;
        /**
         */
        Step::RefLinkedList< IfcStairFlight > m_refIfcStairFlightList;
        /**
         */
        Step::RefLinkedList< IfcStairFlightType > m_refIfcStairFlightTypeList;
        /**
         */
        Step::RefLinkedList< IfcStructuralAction > m_refIfcStructuralActionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralActivity > m_refIfcStructuralActivityList;
        /**
         */
        Step::RefLinkedList< IfcStructuralAnalysisModel > m_refIfcStructuralAnalysisModelList;
        /**
         */
        Step::RefLinkedList< IfcStructuralConnection > m_refIfcStructuralConnectionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralConnectionCondition > m_refIfcStructuralConnectionConditionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralCurveConnection > m_refIfcStructuralCurveConnectionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralCurveMember > m_refIfcStructuralCurveMemberList;
        /**
         */
        Step::RefLinkedList< IfcStructuralCurveMemberVarying > m_refIfcStructuralCurveMemberVaryingList;
        /**
         */
        Step::RefLinkedList< IfcStructuralItem > m_refIfcStructuralItemList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLinearAction > m_refIfcStructuralLinearActionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLinearActionVarying > m_refIfcStructuralLinearActionVaryingList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoad > m_refIfcStructuralLoadList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadGroup > m_refIfcStructuralLoadGroupList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadLinearForce > m_refIfcStructuralLoadLinearForceList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadPlanarForce > m_refIfcStructuralLoadPlanarForceList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadSingleDisplacement > m_refIfcStructuralLoadSingleDisplacementList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadSingleDisplacementDistortion > m_refIfcStructuralLoadSingleDisplacementDistortionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadSingleForce > m_refIfcStructuralLoadSingleForceList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadSingleForceWarping > m_refIfcStructuralLoadSingleForceWarpingList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadStatic > m_refIfcStructuralLoadStaticList;
        /**
         */
        Step::RefLinkedList< IfcStructuralLoadTemperature > m_refIfcStructuralLoadTemperatureList;
        /**
         */
        Step::RefLinkedList< IfcStructuralMember > m_refIfcStructuralMemberList;
        /**
         */
        Step::RefLinkedList< IfcStructuralPlanarAction > m_refIfcStructuralPlanarActionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralPlanarActionVarying > m_refIfcStructuralPlanarActionVaryingList;
        /**
         */
        Step::RefLinkedList< IfcStructuralPointAction > m_refIfcStructuralPointActionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralPointConnection > m_refIfcStructuralPointConnectionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralPointReaction > m_refIfcStructuralPointReactionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralProfileProperties > m_refIfcStructuralProfilePropertiesList;
        /**
         */
        Step::RefLinkedList< IfcStructuralReaction > m_refIfcStructuralReactionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralResultGroup > m_refIfcStructuralResultGroupList;
        /**
         */
        Step::RefLinkedList< IfcStructuralSteelProfileProperties > m_refIfcStructuralSteelProfilePropertiesList;
        /**
         */
        Step::RefLinkedList< IfcStructuralSurfaceConnection > m_refIfcStructuralSurfaceConnectionList;
        /**
         */
        Step::RefLinkedList< IfcStructuralSurfaceMember > m_refIfcStructuralSurfaceMemberList;
        /**
         */
        Step::RefLinkedList< IfcStructuralSurfaceMemberVarying > m_refIfcStructuralSurfaceMemberVaryingList;
        /**
         */
        Step::RefLinkedList< IfcStructuredDimensionCallout > m_refIfcStructuredDimensionCalloutList;
        /**
         */
        Step::RefLinkedList< IfcStyleModel > m_refIfcStyleModelList;
        /**
         */
        Step::RefLinkedList< IfcStyledItem > m_refIfcStyledItemList;
        /**
         */
        Step::RefLinkedList< IfcStyledRepresentation > m_refIfcStyledRepresentationList;
        /**
         */
        Step::RefLinkedList< IfcSubContractResource > m_refIfcSubContractResourceList;
        /**
         */
        Step::RefLinkedList< IfcSubedge > m_refIfcSubedgeList;
        /**
         */
        Step::RefLinkedList< IfcSurface > m_refIfcSurfaceList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceCurveSweptAreaSolid > m_refIfcSurfaceCurveSweptAreaSolidList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceOfLinearExtrusion > m_refIfcSurfaceOfLinearExtrusionList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceOfRevolution > m_refIfcSurfaceOfRevolutionList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceStyle > m_refIfcSurfaceStyleList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceStyleLighting > m_refIfcSurfaceStyleLightingList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceStyleRefraction > m_refIfcSurfaceStyleRefractionList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceStyleRendering > m_refIfcSurfaceStyleRenderingList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceStyleShading > m_refIfcSurfaceStyleShadingList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceStyleWithTextures > m_refIfcSurfaceStyleWithTexturesList;
        /**
         */
        Step::RefLinkedList< IfcSurfaceTexture > m_refIfcSurfaceTextureList;
        /**
         */
        Step::RefLinkedList< IfcSweptAreaSolid > m_refIfcSweptAreaSolidList;
        /**
         */
        Step::RefLinkedList< IfcSweptDiskSolid > m_refIfcSweptDiskSolidList;
        /**
         */
        Step::RefLinkedList< IfcSweptSurface > m_refIfcSweptSurfaceList;
        /**
         */
        Step::RefLinkedList< IfcSwitchingDeviceType > m_refIfcSwitchingDeviceTypeList;
        /**
         */
        Step::RefLinkedList< IfcSymbolStyle > m_refIfcSymbolStyleList;
        /**
         */
        Step::RefLinkedList< IfcSystem > m_refIfcSystemList;
        /**
         */
        Step::RefLinkedList< IfcSystemFurnitureElementType > m_refIfcSystemFurnitureElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcTShapeProfileDef > m_refIfcTShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcTable > m_refIfcTableList;
        /**
         */
        Step::RefLinkedList< IfcTableRow > m_refIfcTableRowList;
        /**
         */
        Step::RefLinkedList< IfcTankType > m_refIfcTankTypeList;
        /**
         */
        Step::RefLinkedList< IfcTask > m_refIfcTaskList;
        /**
         */
        Step::RefLinkedList< IfcTelecomAddress > m_refIfcTelecomAddressList;
        /**
         */
        Step::RefLinkedList< IfcTendon > m_refIfcTendonList;
        /**
         */
        Step::RefLinkedList< IfcTendonAnchor > m_refIfcTendonAnchorList;
        /**
         */
        Step::RefLinkedList< IfcTerminatorSymbol > m_refIfcTerminatorSymbolList;
        /**
         */
        Step::RefLinkedList< IfcTextLiteral > m_refIfcTextLiteralList;
        /**
         */
        Step::RefLinkedList< IfcTextLiteralWithExtent > m_refIfcTextLiteralWithExtentList;
        /**
         */
        Step::RefLinkedList< IfcTextStyle > m_refIfcTextStyleList;
        /**
         */
        Step::RefLinkedList< IfcTextStyleFontModel > m_refIfcTextStyleFontModelList;
        /**
         */
        Step::RefLinkedList< IfcTextStyleForDefinedFont > m_refIfcTextStyleForDefinedFontList;
        /**
         */
        Step::RefLinkedList< IfcTextStyleTextModel > m_refIfcTextStyleTextModelList;
        /**
         */
        Step::RefLinkedList< IfcTextStyleWithBoxCharacteristics > m_refIfcTextStyleWithBoxCharacteristicsList;
        /**
         */
        Step::RefLinkedList< IfcTextureCoordinate > m_refIfcTextureCoordinateList;
        /**
         */
        Step::RefLinkedList< IfcTextureCoordinateGenerator > m_refIfcTextureCoordinateGeneratorList;
        /**
         */
        Step::RefLinkedList< IfcTextureMap > m_refIfcTextureMapList;
        /**
         */
        Step::RefLinkedList< IfcTextureVertex > m_refIfcTextureVertexList;
        /**
         */
        Step::RefLinkedList< IfcThermalMaterialProperties > m_refIfcThermalMaterialPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcTimeSeries > m_refIfcTimeSeriesList;
        /**
         */
        Step::RefLinkedList< IfcTimeSeriesReferenceRelationship > m_refIfcTimeSeriesReferenceRelationshipList;
        /**
         */
        Step::RefLinkedList< IfcTimeSeriesSchedule > m_refIfcTimeSeriesScheduleList;
        /**
         */
        Step::RefLinkedList< IfcTimeSeriesValue > m_refIfcTimeSeriesValueList;
        /**
         */
        Step::RefLinkedList< IfcTopologicalRepresentationItem > m_refIfcTopologicalRepresentationItemList;
        /**
         */
        Step::RefLinkedList< IfcTopologyRepresentation > m_refIfcTopologyRepresentationList;
        /**
         */
        Step::RefLinkedList< IfcTransformerType > m_refIfcTransformerTypeList;
        /**
         */
        Step::RefLinkedList< IfcTransportElement > m_refIfcTransportElementList;
        /**
         */
        Step::RefLinkedList< IfcTransportElementType > m_refIfcTransportElementTypeList;
        /**
         */
        Step::RefLinkedList< IfcTrapeziumProfileDef > m_refIfcTrapeziumProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcTrimmedCurve > m_refIfcTrimmedCurveList;
        /**
         */
        Step::RefLinkedList< IfcTubeBundleType > m_refIfcTubeBundleTypeList;
        /**
         */
        Step::RefLinkedList< IfcTwoDirectionRepeatFactor > m_refIfcTwoDirectionRepeatFactorList;
        /**
         */
        Step::RefLinkedList< IfcTypeObject > m_refIfcTypeObjectList;
        /**
         */
        Step::RefLinkedList< IfcTypeProduct > m_refIfcTypeProductList;
        /**
         */
        Step::RefLinkedList< IfcUShapeProfileDef > m_refIfcUShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcUnitAssignment > m_refIfcUnitAssignmentList;
        /**
         */
        Step::RefLinkedList< IfcUnitaryEquipmentType > m_refIfcUnitaryEquipmentTypeList;
        /**
         */
        Step::RefLinkedList< IfcValveType > m_refIfcValveTypeList;
        /**
         */
        Step::RefLinkedList< IfcVector > m_refIfcVectorList;
        /**
         */
        Step::RefLinkedList< IfcVertex > m_refIfcVertexList;
        /**
         */
        Step::RefLinkedList< IfcVertexBasedTextureMap > m_refIfcVertexBasedTextureMapList;
        /**
         */
        Step::RefLinkedList< IfcVertexLoop > m_refIfcVertexLoopList;
        /**
         */
        Step::RefLinkedList< IfcVertexPoint > m_refIfcVertexPointList;
        /**
         */
        Step::RefLinkedList< IfcVibrationIsolatorType > m_refIfcVibrationIsolatorTypeList;
        /**
         */
        Step::RefLinkedList< IfcVirtualElement > m_refIfcVirtualElementList;
        /**
         */
        Step::RefLinkedList< IfcVirtualGridIntersection > m_refIfcVirtualGridIntersectionList;
        /**
         */
        Step::RefLinkedList< IfcWall > m_refIfcWallList;
        /**
         */
        Step::RefLinkedList< IfcWallStandardCase > m_refIfcWallStandardCaseList;
        /**
         */
        Step::RefLinkedList< IfcWallType > m_refIfcWallTypeList;
        /**
         */
        Step::RefLinkedList< IfcWasteTerminalType > m_refIfcWasteTerminalTypeList;
        /**
         */
        Step::RefLinkedList< IfcWaterProperties > m_refIfcWaterPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcWindow > m_refIfcWindowList;
        /**
         */
        Step::RefLinkedList< IfcWindowLiningProperties > m_refIfcWindowLiningPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcWindowPanelProperties > m_refIfcWindowPanelPropertiesList;
        /**
         */
        Step::RefLinkedList< IfcWindowStyle > m_refIfcWindowStyleList;
        /**
         */
        Step::RefLinkedList< IfcWorkControl > m_refIfcWorkControlList;
        /**
         */
        Step::RefLinkedList< IfcWorkPlan > m_refIfcWorkPlanList;
        /**
         */
        Step::RefLinkedList< IfcWorkSchedule > m_refIfcWorkScheduleList;
        /**
         */
        Step::RefLinkedList< IfcZShapeProfileDef > m_refIfcZShapeProfileDefList;
        /**
         */
        Step::RefLinkedList< IfcZone > m_refIfcZoneList;
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfc2DCompositeCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static Ifc2DCompositeCurve *cloneIfc2DCompositeCurve(ExpressDataSet *expressDataSet, const Ifc2DCompositeCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcActionRequest(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcActionRequest *cloneIfcActionRequest(ExpressDataSet *expressDataSet, const IfcActionRequest &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcActor(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcActor *cloneIfcActor(ExpressDataSet *expressDataSet, const IfcActor &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcActorRole(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcActorRole *cloneIfcActorRole(ExpressDataSet *expressDataSet, const IfcActorRole &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcActuatorType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcActuatorType *cloneIfcActuatorType(ExpressDataSet *expressDataSet, const IfcActuatorType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAirTerminalBoxType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAirTerminalBoxType *cloneIfcAirTerminalBoxType(ExpressDataSet *expressDataSet, const IfcAirTerminalBoxType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAirTerminalType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAirTerminalType *cloneIfcAirTerminalType(ExpressDataSet *expressDataSet, const IfcAirTerminalType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAirToAirHeatRecoveryType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAirToAirHeatRecoveryType *cloneIfcAirToAirHeatRecoveryType(ExpressDataSet *expressDataSet, const IfcAirToAirHeatRecoveryType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAlarmType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAlarmType *cloneIfcAlarmType(ExpressDataSet *expressDataSet, const IfcAlarmType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAngularDimension(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAngularDimension *cloneIfcAngularDimension(ExpressDataSet *expressDataSet, const IfcAngularDimension &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotation *cloneIfcAnnotation(ExpressDataSet *expressDataSet, const IfcAnnotation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotationCurveOccurrence(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotationCurveOccurrence *cloneIfcAnnotationCurveOccurrence(ExpressDataSet *expressDataSet, const IfcAnnotationCurveOccurrence &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotationFillArea(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotationFillArea *cloneIfcAnnotationFillArea(ExpressDataSet *expressDataSet, const IfcAnnotationFillArea &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotationFillAreaOccurrence(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotationFillAreaOccurrence *cloneIfcAnnotationFillAreaOccurrence(ExpressDataSet *expressDataSet, const IfcAnnotationFillAreaOccurrence &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotationSurface(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotationSurface *cloneIfcAnnotationSurface(ExpressDataSet *expressDataSet, const IfcAnnotationSurface &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotationSurfaceOccurrence(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotationSurfaceOccurrence *cloneIfcAnnotationSurfaceOccurrence(ExpressDataSet *expressDataSet, const IfcAnnotationSurfaceOccurrence &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotationSymbolOccurrence(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotationSymbolOccurrence *cloneIfcAnnotationSymbolOccurrence(ExpressDataSet *expressDataSet, const IfcAnnotationSymbolOccurrence &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAnnotationTextOccurrence(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAnnotationTextOccurrence *cloneIfcAnnotationTextOccurrence(ExpressDataSet *expressDataSet, const IfcAnnotationTextOccurrence &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcApplication(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcApplication *cloneIfcApplication(ExpressDataSet *expressDataSet, const IfcApplication &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAppliedValueRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAppliedValueRelationship *cloneIfcAppliedValueRelationship(ExpressDataSet *expressDataSet, const IfcAppliedValueRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcApproval(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcApproval *cloneIfcApproval(ExpressDataSet *expressDataSet, const IfcApproval &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcApprovalActorRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcApprovalActorRelationship *cloneIfcApprovalActorRelationship(ExpressDataSet *expressDataSet, const IfcApprovalActorRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcApprovalPropertyRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcApprovalPropertyRelationship *cloneIfcApprovalPropertyRelationship(ExpressDataSet *expressDataSet, const IfcApprovalPropertyRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcApprovalRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcApprovalRelationship *cloneIfcApprovalRelationship(ExpressDataSet *expressDataSet, const IfcApprovalRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcArbitraryClosedProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcArbitraryClosedProfileDef *cloneIfcArbitraryClosedProfileDef(ExpressDataSet *expressDataSet, const IfcArbitraryClosedProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcArbitraryOpenProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcArbitraryOpenProfileDef *cloneIfcArbitraryOpenProfileDef(ExpressDataSet *expressDataSet, const IfcArbitraryOpenProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcArbitraryProfileDefWithVoids(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcArbitraryProfileDefWithVoids *cloneIfcArbitraryProfileDefWithVoids(ExpressDataSet *expressDataSet, const IfcArbitraryProfileDefWithVoids &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAsset(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAsset *cloneIfcAsset(ExpressDataSet *expressDataSet, const IfcAsset &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAsymmetricIShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAsymmetricIShapeProfileDef *cloneIfcAsymmetricIShapeProfileDef(ExpressDataSet *expressDataSet, const IfcAsymmetricIShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAxis1Placement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAxis1Placement *cloneIfcAxis1Placement(ExpressDataSet *expressDataSet, const IfcAxis1Placement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAxis2Placement2D(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAxis2Placement2D *cloneIfcAxis2Placement2D(ExpressDataSet *expressDataSet, const IfcAxis2Placement2D &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcAxis2Placement3D(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcAxis2Placement3D *cloneIfcAxis2Placement3D(ExpressDataSet *expressDataSet, const IfcAxis2Placement3D &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBeam(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBeam *cloneIfcBeam(ExpressDataSet *expressDataSet, const IfcBeam &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBeamType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBeamType *cloneIfcBeamType(ExpressDataSet *expressDataSet, const IfcBeamType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBezierCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBezierCurve *cloneIfcBezierCurve(ExpressDataSet *expressDataSet, const IfcBezierCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBlobTexture(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBlobTexture *cloneIfcBlobTexture(ExpressDataSet *expressDataSet, const IfcBlobTexture &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBlock(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBlock *cloneIfcBlock(ExpressDataSet *expressDataSet, const IfcBlock &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoilerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoilerType *cloneIfcBoilerType(ExpressDataSet *expressDataSet, const IfcBoilerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBooleanClippingResult(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBooleanClippingResult *cloneIfcBooleanClippingResult(ExpressDataSet *expressDataSet, const IfcBooleanClippingResult &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBooleanResult(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBooleanResult *cloneIfcBooleanResult(ExpressDataSet *expressDataSet, const IfcBooleanResult &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoundaryEdgeCondition(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoundaryEdgeCondition *cloneIfcBoundaryEdgeCondition(ExpressDataSet *expressDataSet, const IfcBoundaryEdgeCondition &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoundaryFaceCondition(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoundaryFaceCondition *cloneIfcBoundaryFaceCondition(ExpressDataSet *expressDataSet, const IfcBoundaryFaceCondition &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoundaryNodeCondition(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoundaryNodeCondition *cloneIfcBoundaryNodeCondition(ExpressDataSet *expressDataSet, const IfcBoundaryNodeCondition &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoundaryNodeConditionWarping(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoundaryNodeConditionWarping *cloneIfcBoundaryNodeConditionWarping(ExpressDataSet *expressDataSet, const IfcBoundaryNodeConditionWarping &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoundedSurface(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoundedSurface *cloneIfcBoundedSurface(ExpressDataSet *expressDataSet, const IfcBoundedSurface &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoundingBox(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoundingBox *cloneIfcBoundingBox(ExpressDataSet *expressDataSet, const IfcBoundingBox &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBoxedHalfSpace(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBoxedHalfSpace *cloneIfcBoxedHalfSpace(ExpressDataSet *expressDataSet, const IfcBoxedHalfSpace &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBuilding(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBuilding *cloneIfcBuilding(ExpressDataSet *expressDataSet, const IfcBuilding &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBuildingElementPart(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBuildingElementPart *cloneIfcBuildingElementPart(ExpressDataSet *expressDataSet, const IfcBuildingElementPart &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBuildingElementProxy(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBuildingElementProxy *cloneIfcBuildingElementProxy(ExpressDataSet *expressDataSet, const IfcBuildingElementProxy &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBuildingElementProxyType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBuildingElementProxyType *cloneIfcBuildingElementProxyType(ExpressDataSet *expressDataSet, const IfcBuildingElementProxyType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcBuildingStorey(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcBuildingStorey *cloneIfcBuildingStorey(ExpressDataSet *expressDataSet, const IfcBuildingStorey &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCShapeProfileDef *cloneIfcCShapeProfileDef(ExpressDataSet *expressDataSet, const IfcCShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCableCarrierFittingType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCableCarrierFittingType *cloneIfcCableCarrierFittingType(ExpressDataSet *expressDataSet, const IfcCableCarrierFittingType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCableCarrierSegmentType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCableCarrierSegmentType *cloneIfcCableCarrierSegmentType(ExpressDataSet *expressDataSet, const IfcCableCarrierSegmentType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCableSegmentType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCableSegmentType *cloneIfcCableSegmentType(ExpressDataSet *expressDataSet, const IfcCableSegmentType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCalendarDate(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCalendarDate *cloneIfcCalendarDate(ExpressDataSet *expressDataSet, const IfcCalendarDate &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCartesianPoint(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCartesianPoint *cloneIfcCartesianPoint(ExpressDataSet *expressDataSet, const IfcCartesianPoint &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCartesianTransformationOperator2D(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCartesianTransformationOperator2D *cloneIfcCartesianTransformationOperator2D(ExpressDataSet *expressDataSet, const IfcCartesianTransformationOperator2D &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCartesianTransformationOperator2DnonUniform(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCartesianTransformationOperator2DnonUniform *cloneIfcCartesianTransformationOperator2DnonUniform(ExpressDataSet *expressDataSet, const IfcCartesianTransformationOperator2DnonUniform &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCartesianTransformationOperator3D(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCartesianTransformationOperator3D *cloneIfcCartesianTransformationOperator3D(ExpressDataSet *expressDataSet, const IfcCartesianTransformationOperator3D &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCartesianTransformationOperator3DnonUniform(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCartesianTransformationOperator3DnonUniform *cloneIfcCartesianTransformationOperator3DnonUniform(ExpressDataSet *expressDataSet, const IfcCartesianTransformationOperator3DnonUniform &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCenterLineProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCenterLineProfileDef *cloneIfcCenterLineProfileDef(ExpressDataSet *expressDataSet, const IfcCenterLineProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcChamferEdgeFeature(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcChamferEdgeFeature *cloneIfcChamferEdgeFeature(ExpressDataSet *expressDataSet, const IfcChamferEdgeFeature &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcChillerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcChillerType *cloneIfcChillerType(ExpressDataSet *expressDataSet, const IfcChillerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCircle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCircle *cloneIfcCircle(ExpressDataSet *expressDataSet, const IfcCircle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCircleHollowProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCircleHollowProfileDef *cloneIfcCircleHollowProfileDef(ExpressDataSet *expressDataSet, const IfcCircleHollowProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCircleProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCircleProfileDef *cloneIfcCircleProfileDef(ExpressDataSet *expressDataSet, const IfcCircleProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcClassification(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcClassification *cloneIfcClassification(ExpressDataSet *expressDataSet, const IfcClassification &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcClassificationItem(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcClassificationItem *cloneIfcClassificationItem(ExpressDataSet *expressDataSet, const IfcClassificationItem &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcClassificationItemRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcClassificationItemRelationship *cloneIfcClassificationItemRelationship(ExpressDataSet *expressDataSet, const IfcClassificationItemRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcClassificationNotation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcClassificationNotation *cloneIfcClassificationNotation(ExpressDataSet *expressDataSet, const IfcClassificationNotation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcClassificationNotationFacet(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcClassificationNotationFacet *cloneIfcClassificationNotationFacet(ExpressDataSet *expressDataSet, const IfcClassificationNotationFacet &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcClassificationReference(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcClassificationReference *cloneIfcClassificationReference(ExpressDataSet *expressDataSet, const IfcClassificationReference &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcClosedShell(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcClosedShell *cloneIfcClosedShell(ExpressDataSet *expressDataSet, const IfcClosedShell &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCoilType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCoilType *cloneIfcCoilType(ExpressDataSet *expressDataSet, const IfcCoilType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcColourRgb(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcColourRgb *cloneIfcColourRgb(ExpressDataSet *expressDataSet, const IfcColourRgb &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcColumn(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcColumn *cloneIfcColumn(ExpressDataSet *expressDataSet, const IfcColumn &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcColumnType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcColumnType *cloneIfcColumnType(ExpressDataSet *expressDataSet, const IfcColumnType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcComplexProperty(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcComplexProperty *cloneIfcComplexProperty(ExpressDataSet *expressDataSet, const IfcComplexProperty &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCompositeCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCompositeCurve *cloneIfcCompositeCurve(ExpressDataSet *expressDataSet, const IfcCompositeCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCompositeCurveSegment(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCompositeCurveSegment *cloneIfcCompositeCurveSegment(ExpressDataSet *expressDataSet, const IfcCompositeCurveSegment &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCompositeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCompositeProfileDef *cloneIfcCompositeProfileDef(ExpressDataSet *expressDataSet, const IfcCompositeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCompressorType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCompressorType *cloneIfcCompressorType(ExpressDataSet *expressDataSet, const IfcCompressorType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCondenserType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCondenserType *cloneIfcCondenserType(ExpressDataSet *expressDataSet, const IfcCondenserType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCondition(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCondition *cloneIfcCondition(ExpressDataSet *expressDataSet, const IfcCondition &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConditionCriterion(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConditionCriterion *cloneIfcConditionCriterion(ExpressDataSet *expressDataSet, const IfcConditionCriterion &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConnectedFaceSet(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConnectedFaceSet *cloneIfcConnectedFaceSet(ExpressDataSet *expressDataSet, const IfcConnectedFaceSet &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConnectionCurveGeometry(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConnectionCurveGeometry *cloneIfcConnectionCurveGeometry(ExpressDataSet *expressDataSet, const IfcConnectionCurveGeometry &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConnectionPointEccentricity(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConnectionPointEccentricity *cloneIfcConnectionPointEccentricity(ExpressDataSet *expressDataSet, const IfcConnectionPointEccentricity &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConnectionPointGeometry(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConnectionPointGeometry *cloneIfcConnectionPointGeometry(ExpressDataSet *expressDataSet, const IfcConnectionPointGeometry &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConnectionPortGeometry(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConnectionPortGeometry *cloneIfcConnectionPortGeometry(ExpressDataSet *expressDataSet, const IfcConnectionPortGeometry &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConnectionSurfaceGeometry(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConnectionSurfaceGeometry *cloneIfcConnectionSurfaceGeometry(ExpressDataSet *expressDataSet, const IfcConnectionSurfaceGeometry &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConstraintAggregationRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConstraintAggregationRelationship *cloneIfcConstraintAggregationRelationship(ExpressDataSet *expressDataSet, const IfcConstraintAggregationRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConstraintClassificationRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConstraintClassificationRelationship *cloneIfcConstraintClassificationRelationship(ExpressDataSet *expressDataSet, const IfcConstraintClassificationRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConstraintRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConstraintRelationship *cloneIfcConstraintRelationship(ExpressDataSet *expressDataSet, const IfcConstraintRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConstructionEquipmentResource(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConstructionEquipmentResource *cloneIfcConstructionEquipmentResource(ExpressDataSet *expressDataSet, const IfcConstructionEquipmentResource &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConstructionMaterialResource(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConstructionMaterialResource *cloneIfcConstructionMaterialResource(ExpressDataSet *expressDataSet, const IfcConstructionMaterialResource &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConstructionProductResource(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConstructionProductResource *cloneIfcConstructionProductResource(ExpressDataSet *expressDataSet, const IfcConstructionProductResource &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcContextDependentUnit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcContextDependentUnit *cloneIfcContextDependentUnit(ExpressDataSet *expressDataSet, const IfcContextDependentUnit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcControllerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcControllerType *cloneIfcControllerType(ExpressDataSet *expressDataSet, const IfcControllerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcConversionBasedUnit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcConversionBasedUnit *cloneIfcConversionBasedUnit(ExpressDataSet *expressDataSet, const IfcConversionBasedUnit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCooledBeamType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCooledBeamType *cloneIfcCooledBeamType(ExpressDataSet *expressDataSet, const IfcCooledBeamType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCoolingTowerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCoolingTowerType *cloneIfcCoolingTowerType(ExpressDataSet *expressDataSet, const IfcCoolingTowerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCoordinatedUniversalTimeOffset(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCoordinatedUniversalTimeOffset *cloneIfcCoordinatedUniversalTimeOffset(ExpressDataSet *expressDataSet, const IfcCoordinatedUniversalTimeOffset &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCostItem(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCostItem *cloneIfcCostItem(ExpressDataSet *expressDataSet, const IfcCostItem &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCostSchedule(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCostSchedule *cloneIfcCostSchedule(ExpressDataSet *expressDataSet, const IfcCostSchedule &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCostValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCostValue *cloneIfcCostValue(ExpressDataSet *expressDataSet, const IfcCostValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCovering(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCovering *cloneIfcCovering(ExpressDataSet *expressDataSet, const IfcCovering &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCoveringType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCoveringType *cloneIfcCoveringType(ExpressDataSet *expressDataSet, const IfcCoveringType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCraneRailAShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCraneRailAShapeProfileDef *cloneIfcCraneRailAShapeProfileDef(ExpressDataSet *expressDataSet, const IfcCraneRailAShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCraneRailFShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCraneRailFShapeProfileDef *cloneIfcCraneRailFShapeProfileDef(ExpressDataSet *expressDataSet, const IfcCraneRailFShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCrewResource(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCrewResource *cloneIfcCrewResource(ExpressDataSet *expressDataSet, const IfcCrewResource &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCsgSolid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCsgSolid *cloneIfcCsgSolid(ExpressDataSet *expressDataSet, const IfcCsgSolid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurrencyRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurrencyRelationship *cloneIfcCurrencyRelationship(ExpressDataSet *expressDataSet, const IfcCurrencyRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurtainWall(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurtainWall *cloneIfcCurtainWall(ExpressDataSet *expressDataSet, const IfcCurtainWall &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurtainWallType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurtainWallType *cloneIfcCurtainWallType(ExpressDataSet *expressDataSet, const IfcCurtainWallType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurveBoundedPlane(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurveBoundedPlane *cloneIfcCurveBoundedPlane(ExpressDataSet *expressDataSet, const IfcCurveBoundedPlane &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurveStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurveStyle *cloneIfcCurveStyle(ExpressDataSet *expressDataSet, const IfcCurveStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurveStyleFont(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurveStyleFont *cloneIfcCurveStyleFont(ExpressDataSet *expressDataSet, const IfcCurveStyleFont &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurveStyleFontAndScaling(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurveStyleFontAndScaling *cloneIfcCurveStyleFontAndScaling(ExpressDataSet *expressDataSet, const IfcCurveStyleFontAndScaling &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcCurveStyleFontPattern(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcCurveStyleFontPattern *cloneIfcCurveStyleFontPattern(ExpressDataSet *expressDataSet, const IfcCurveStyleFontPattern &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDamperType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDamperType *cloneIfcDamperType(ExpressDataSet *expressDataSet, const IfcDamperType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDateAndTime(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDateAndTime *cloneIfcDateAndTime(ExpressDataSet *expressDataSet, const IfcDateAndTime &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDefinedSymbol(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDefinedSymbol *cloneIfcDefinedSymbol(ExpressDataSet *expressDataSet, const IfcDefinedSymbol &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDerivedProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDerivedProfileDef *cloneIfcDerivedProfileDef(ExpressDataSet *expressDataSet, const IfcDerivedProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDerivedUnit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDerivedUnit *cloneIfcDerivedUnit(ExpressDataSet *expressDataSet, const IfcDerivedUnit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDerivedUnitElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDerivedUnitElement *cloneIfcDerivedUnitElement(ExpressDataSet *expressDataSet, const IfcDerivedUnitElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDiameterDimension(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDiameterDimension *cloneIfcDiameterDimension(ExpressDataSet *expressDataSet, const IfcDiameterDimension &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDimensionCalloutRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDimensionCalloutRelationship *cloneIfcDimensionCalloutRelationship(ExpressDataSet *expressDataSet, const IfcDimensionCalloutRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDimensionCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDimensionCurve *cloneIfcDimensionCurve(ExpressDataSet *expressDataSet, const IfcDimensionCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDimensionCurveDirectedCallout(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDimensionCurveDirectedCallout *cloneIfcDimensionCurveDirectedCallout(ExpressDataSet *expressDataSet, const IfcDimensionCurveDirectedCallout &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDimensionCurveTerminator(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDimensionCurveTerminator *cloneIfcDimensionCurveTerminator(ExpressDataSet *expressDataSet, const IfcDimensionCurveTerminator &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDimensionPair(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDimensionPair *cloneIfcDimensionPair(ExpressDataSet *expressDataSet, const IfcDimensionPair &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDimensionalExponents(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDimensionalExponents *cloneIfcDimensionalExponents(ExpressDataSet *expressDataSet, const IfcDimensionalExponents &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDirection(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDirection *cloneIfcDirection(ExpressDataSet *expressDataSet, const IfcDirection &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDiscreteAccessory(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDiscreteAccessory *cloneIfcDiscreteAccessory(ExpressDataSet *expressDataSet, const IfcDiscreteAccessory &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDiscreteAccessoryType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDiscreteAccessoryType *cloneIfcDiscreteAccessoryType(ExpressDataSet *expressDataSet, const IfcDiscreteAccessoryType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDistributionChamberElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDistributionChamberElement *cloneIfcDistributionChamberElement(ExpressDataSet *expressDataSet, const IfcDistributionChamberElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDistributionChamberElementType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDistributionChamberElementType *cloneIfcDistributionChamberElementType(ExpressDataSet *expressDataSet, const IfcDistributionChamberElementType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDistributionControlElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDistributionControlElement *cloneIfcDistributionControlElement(ExpressDataSet *expressDataSet, const IfcDistributionControlElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDistributionElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDistributionElement *cloneIfcDistributionElement(ExpressDataSet *expressDataSet, const IfcDistributionElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDistributionElementType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDistributionElementType *cloneIfcDistributionElementType(ExpressDataSet *expressDataSet, const IfcDistributionElementType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDistributionFlowElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDistributionFlowElement *cloneIfcDistributionFlowElement(ExpressDataSet *expressDataSet, const IfcDistributionFlowElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDistributionPort(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDistributionPort *cloneIfcDistributionPort(ExpressDataSet *expressDataSet, const IfcDistributionPort &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDocumentElectronicFormat(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDocumentElectronicFormat *cloneIfcDocumentElectronicFormat(ExpressDataSet *expressDataSet, const IfcDocumentElectronicFormat &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDocumentInformation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDocumentInformation *cloneIfcDocumentInformation(ExpressDataSet *expressDataSet, const IfcDocumentInformation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDocumentInformationRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDocumentInformationRelationship *cloneIfcDocumentInformationRelationship(ExpressDataSet *expressDataSet, const IfcDocumentInformationRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDocumentReference(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDocumentReference *cloneIfcDocumentReference(ExpressDataSet *expressDataSet, const IfcDocumentReference &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDoor(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDoor *cloneIfcDoor(ExpressDataSet *expressDataSet, const IfcDoor &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDoorLiningProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDoorLiningProperties *cloneIfcDoorLiningProperties(ExpressDataSet *expressDataSet, const IfcDoorLiningProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDoorPanelProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDoorPanelProperties *cloneIfcDoorPanelProperties(ExpressDataSet *expressDataSet, const IfcDoorPanelProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDoorStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDoorStyle *cloneIfcDoorStyle(ExpressDataSet *expressDataSet, const IfcDoorStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDraughtingCallout(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDraughtingCallout *cloneIfcDraughtingCallout(ExpressDataSet *expressDataSet, const IfcDraughtingCallout &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDraughtingCalloutRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDraughtingCalloutRelationship *cloneIfcDraughtingCalloutRelationship(ExpressDataSet *expressDataSet, const IfcDraughtingCalloutRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDraughtingPreDefinedColour(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDraughtingPreDefinedColour *cloneIfcDraughtingPreDefinedColour(ExpressDataSet *expressDataSet, const IfcDraughtingPreDefinedColour &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDraughtingPreDefinedCurveFont(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDraughtingPreDefinedCurveFont *cloneIfcDraughtingPreDefinedCurveFont(ExpressDataSet *expressDataSet, const IfcDraughtingPreDefinedCurveFont &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDraughtingPreDefinedTextFont(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDraughtingPreDefinedTextFont *cloneIfcDraughtingPreDefinedTextFont(ExpressDataSet *expressDataSet, const IfcDraughtingPreDefinedTextFont &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDuctFittingType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDuctFittingType *cloneIfcDuctFittingType(ExpressDataSet *expressDataSet, const IfcDuctFittingType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDuctSegmentType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDuctSegmentType *cloneIfcDuctSegmentType(ExpressDataSet *expressDataSet, const IfcDuctSegmentType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcDuctSilencerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcDuctSilencerType *cloneIfcDuctSilencerType(ExpressDataSet *expressDataSet, const IfcDuctSilencerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEdge(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEdge *cloneIfcEdge(ExpressDataSet *expressDataSet, const IfcEdge &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEdgeCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEdgeCurve *cloneIfcEdgeCurve(ExpressDataSet *expressDataSet, const IfcEdgeCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEdgeLoop(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEdgeLoop *cloneIfcEdgeLoop(ExpressDataSet *expressDataSet, const IfcEdgeLoop &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricApplianceType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricApplianceType *cloneIfcElectricApplianceType(ExpressDataSet *expressDataSet, const IfcElectricApplianceType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricDistributionPoint(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricDistributionPoint *cloneIfcElectricDistributionPoint(ExpressDataSet *expressDataSet, const IfcElectricDistributionPoint &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricFlowStorageDeviceType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricFlowStorageDeviceType *cloneIfcElectricFlowStorageDeviceType(ExpressDataSet *expressDataSet, const IfcElectricFlowStorageDeviceType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricGeneratorType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricGeneratorType *cloneIfcElectricGeneratorType(ExpressDataSet *expressDataSet, const IfcElectricGeneratorType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricHeaterType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricHeaterType *cloneIfcElectricHeaterType(ExpressDataSet *expressDataSet, const IfcElectricHeaterType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricMotorType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricMotorType *cloneIfcElectricMotorType(ExpressDataSet *expressDataSet, const IfcElectricMotorType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricTimeControlType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricTimeControlType *cloneIfcElectricTimeControlType(ExpressDataSet *expressDataSet, const IfcElectricTimeControlType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricalBaseProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricalBaseProperties *cloneIfcElectricalBaseProperties(ExpressDataSet *expressDataSet, const IfcElectricalBaseProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricalCircuit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricalCircuit *cloneIfcElectricalCircuit(ExpressDataSet *expressDataSet, const IfcElectricalCircuit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElectricalElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElectricalElement *cloneIfcElectricalElement(ExpressDataSet *expressDataSet, const IfcElectricalElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElementAssembly(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElementAssembly *cloneIfcElementAssembly(ExpressDataSet *expressDataSet, const IfcElementAssembly &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcElementQuantity(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcElementQuantity *cloneIfcElementQuantity(ExpressDataSet *expressDataSet, const IfcElementQuantity &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEllipse(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEllipse *cloneIfcEllipse(ExpressDataSet *expressDataSet, const IfcEllipse &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEllipseProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEllipseProfileDef *cloneIfcEllipseProfileDef(ExpressDataSet *expressDataSet, const IfcEllipseProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEnergyConversionDevice(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEnergyConversionDevice *cloneIfcEnergyConversionDevice(ExpressDataSet *expressDataSet, const IfcEnergyConversionDevice &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEnergyProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEnergyProperties *cloneIfcEnergyProperties(ExpressDataSet *expressDataSet, const IfcEnergyProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEnvironmentalImpactValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEnvironmentalImpactValue *cloneIfcEnvironmentalImpactValue(ExpressDataSet *expressDataSet, const IfcEnvironmentalImpactValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEquipmentElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEquipmentElement *cloneIfcEquipmentElement(ExpressDataSet *expressDataSet, const IfcEquipmentElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEquipmentStandard(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEquipmentStandard *cloneIfcEquipmentStandard(ExpressDataSet *expressDataSet, const IfcEquipmentStandard &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEvaporativeCoolerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEvaporativeCoolerType *cloneIfcEvaporativeCoolerType(ExpressDataSet *expressDataSet, const IfcEvaporativeCoolerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcEvaporatorType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcEvaporatorType *cloneIfcEvaporatorType(ExpressDataSet *expressDataSet, const IfcEvaporatorType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcExtendedMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcExtendedMaterialProperties *cloneIfcExtendedMaterialProperties(ExpressDataSet *expressDataSet, const IfcExtendedMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcExternallyDefinedHatchStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcExternallyDefinedHatchStyle *cloneIfcExternallyDefinedHatchStyle(ExpressDataSet *expressDataSet, const IfcExternallyDefinedHatchStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcExternallyDefinedSurfaceStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcExternallyDefinedSurfaceStyle *cloneIfcExternallyDefinedSurfaceStyle(ExpressDataSet *expressDataSet, const IfcExternallyDefinedSurfaceStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcExternallyDefinedSymbol(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcExternallyDefinedSymbol *cloneIfcExternallyDefinedSymbol(ExpressDataSet *expressDataSet, const IfcExternallyDefinedSymbol &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcExternallyDefinedTextFont(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcExternallyDefinedTextFont *cloneIfcExternallyDefinedTextFont(ExpressDataSet *expressDataSet, const IfcExternallyDefinedTextFont &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcExtrudedAreaSolid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcExtrudedAreaSolid *cloneIfcExtrudedAreaSolid(ExpressDataSet *expressDataSet, const IfcExtrudedAreaSolid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFace(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFace *cloneIfcFace(ExpressDataSet *expressDataSet, const IfcFace &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFaceBasedSurfaceModel(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFaceBasedSurfaceModel *cloneIfcFaceBasedSurfaceModel(ExpressDataSet *expressDataSet, const IfcFaceBasedSurfaceModel &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFaceBound(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFaceBound *cloneIfcFaceBound(ExpressDataSet *expressDataSet, const IfcFaceBound &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFaceOuterBound(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFaceOuterBound *cloneIfcFaceOuterBound(ExpressDataSet *expressDataSet, const IfcFaceOuterBound &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFaceSurface(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFaceSurface *cloneIfcFaceSurface(ExpressDataSet *expressDataSet, const IfcFaceSurface &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFacetedBrep(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFacetedBrep *cloneIfcFacetedBrep(ExpressDataSet *expressDataSet, const IfcFacetedBrep &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFacetedBrepWithVoids(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFacetedBrepWithVoids *cloneIfcFacetedBrepWithVoids(ExpressDataSet *expressDataSet, const IfcFacetedBrepWithVoids &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFailureConnectionCondition(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFailureConnectionCondition *cloneIfcFailureConnectionCondition(ExpressDataSet *expressDataSet, const IfcFailureConnectionCondition &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFanType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFanType *cloneIfcFanType(ExpressDataSet *expressDataSet, const IfcFanType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFastener(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFastener *cloneIfcFastener(ExpressDataSet *expressDataSet, const IfcFastener &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFastenerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFastenerType *cloneIfcFastenerType(ExpressDataSet *expressDataSet, const IfcFastenerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFillAreaStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFillAreaStyle *cloneIfcFillAreaStyle(ExpressDataSet *expressDataSet, const IfcFillAreaStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFillAreaStyleHatching(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFillAreaStyleHatching *cloneIfcFillAreaStyleHatching(ExpressDataSet *expressDataSet, const IfcFillAreaStyleHatching &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFillAreaStyleTileSymbolWithStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFillAreaStyleTileSymbolWithStyle *cloneIfcFillAreaStyleTileSymbolWithStyle(ExpressDataSet *expressDataSet, const IfcFillAreaStyleTileSymbolWithStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFillAreaStyleTiles(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFillAreaStyleTiles *cloneIfcFillAreaStyleTiles(ExpressDataSet *expressDataSet, const IfcFillAreaStyleTiles &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFilterType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFilterType *cloneIfcFilterType(ExpressDataSet *expressDataSet, const IfcFilterType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFireSuppressionTerminalType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFireSuppressionTerminalType *cloneIfcFireSuppressionTerminalType(ExpressDataSet *expressDataSet, const IfcFireSuppressionTerminalType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowController(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowController *cloneIfcFlowController(ExpressDataSet *expressDataSet, const IfcFlowController &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowFitting(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowFitting *cloneIfcFlowFitting(ExpressDataSet *expressDataSet, const IfcFlowFitting &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowInstrumentType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowInstrumentType *cloneIfcFlowInstrumentType(ExpressDataSet *expressDataSet, const IfcFlowInstrumentType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowMeterType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowMeterType *cloneIfcFlowMeterType(ExpressDataSet *expressDataSet, const IfcFlowMeterType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowMovingDevice(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowMovingDevice *cloneIfcFlowMovingDevice(ExpressDataSet *expressDataSet, const IfcFlowMovingDevice &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowSegment(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowSegment *cloneIfcFlowSegment(ExpressDataSet *expressDataSet, const IfcFlowSegment &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowStorageDevice(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowStorageDevice *cloneIfcFlowStorageDevice(ExpressDataSet *expressDataSet, const IfcFlowStorageDevice &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowTerminal(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowTerminal *cloneIfcFlowTerminal(ExpressDataSet *expressDataSet, const IfcFlowTerminal &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFlowTreatmentDevice(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFlowTreatmentDevice *cloneIfcFlowTreatmentDevice(ExpressDataSet *expressDataSet, const IfcFlowTreatmentDevice &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFluidFlowProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFluidFlowProperties *cloneIfcFluidFlowProperties(ExpressDataSet *expressDataSet, const IfcFluidFlowProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFooting(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFooting *cloneIfcFooting(ExpressDataSet *expressDataSet, const IfcFooting &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFuelProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFuelProperties *cloneIfcFuelProperties(ExpressDataSet *expressDataSet, const IfcFuelProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFurnishingElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFurnishingElement *cloneIfcFurnishingElement(ExpressDataSet *expressDataSet, const IfcFurnishingElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFurnishingElementType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFurnishingElementType *cloneIfcFurnishingElementType(ExpressDataSet *expressDataSet, const IfcFurnishingElementType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFurnitureStandard(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFurnitureStandard *cloneIfcFurnitureStandard(ExpressDataSet *expressDataSet, const IfcFurnitureStandard &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcFurnitureType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcFurnitureType *cloneIfcFurnitureType(ExpressDataSet *expressDataSet, const IfcFurnitureType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGasTerminalType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGasTerminalType *cloneIfcGasTerminalType(ExpressDataSet *expressDataSet, const IfcGasTerminalType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGeneralMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGeneralMaterialProperties *cloneIfcGeneralMaterialProperties(ExpressDataSet *expressDataSet, const IfcGeneralMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGeneralProfileProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGeneralProfileProperties *cloneIfcGeneralProfileProperties(ExpressDataSet *expressDataSet, const IfcGeneralProfileProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGeometricCurveSet(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGeometricCurveSet *cloneIfcGeometricCurveSet(ExpressDataSet *expressDataSet, const IfcGeometricCurveSet &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGeometricRepresentationContext(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGeometricRepresentationContext *cloneIfcGeometricRepresentationContext(ExpressDataSet *expressDataSet, const IfcGeometricRepresentationContext &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGeometricRepresentationSubContext(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGeometricRepresentationSubContext *cloneIfcGeometricRepresentationSubContext(ExpressDataSet *expressDataSet, const IfcGeometricRepresentationSubContext &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGeometricSet(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGeometricSet *cloneIfcGeometricSet(ExpressDataSet *expressDataSet, const IfcGeometricSet &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGrid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGrid *cloneIfcGrid(ExpressDataSet *expressDataSet, const IfcGrid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGridAxis(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGridAxis *cloneIfcGridAxis(ExpressDataSet *expressDataSet, const IfcGridAxis &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGridPlacement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGridPlacement *cloneIfcGridPlacement(ExpressDataSet *expressDataSet, const IfcGridPlacement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcGroup(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcGroup *cloneIfcGroup(ExpressDataSet *expressDataSet, const IfcGroup &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcHalfSpaceSolid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcHalfSpaceSolid *cloneIfcHalfSpaceSolid(ExpressDataSet *expressDataSet, const IfcHalfSpaceSolid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcHeatExchangerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcHeatExchangerType *cloneIfcHeatExchangerType(ExpressDataSet *expressDataSet, const IfcHeatExchangerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcHumidifierType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcHumidifierType *cloneIfcHumidifierType(ExpressDataSet *expressDataSet, const IfcHumidifierType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcHygroscopicMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcHygroscopicMaterialProperties *cloneIfcHygroscopicMaterialProperties(ExpressDataSet *expressDataSet, const IfcHygroscopicMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcIShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcIShapeProfileDef *cloneIfcIShapeProfileDef(ExpressDataSet *expressDataSet, const IfcIShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcImageTexture(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcImageTexture *cloneIfcImageTexture(ExpressDataSet *expressDataSet, const IfcImageTexture &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcInventory(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcInventory *cloneIfcInventory(ExpressDataSet *expressDataSet, const IfcInventory &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcIrregularTimeSeries(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcIrregularTimeSeries *cloneIfcIrregularTimeSeries(ExpressDataSet *expressDataSet, const IfcIrregularTimeSeries &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcIrregularTimeSeriesValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcIrregularTimeSeriesValue *cloneIfcIrregularTimeSeriesValue(ExpressDataSet *expressDataSet, const IfcIrregularTimeSeriesValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcJunctionBoxType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcJunctionBoxType *cloneIfcJunctionBoxType(ExpressDataSet *expressDataSet, const IfcJunctionBoxType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLShapeProfileDef *cloneIfcLShapeProfileDef(ExpressDataSet *expressDataSet, const IfcLShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLaborResource(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLaborResource *cloneIfcLaborResource(ExpressDataSet *expressDataSet, const IfcLaborResource &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLampType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLampType *cloneIfcLampType(ExpressDataSet *expressDataSet, const IfcLampType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLibraryInformation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLibraryInformation *cloneIfcLibraryInformation(ExpressDataSet *expressDataSet, const IfcLibraryInformation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLibraryReference(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLibraryReference *cloneIfcLibraryReference(ExpressDataSet *expressDataSet, const IfcLibraryReference &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightDistributionData(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightDistributionData *cloneIfcLightDistributionData(ExpressDataSet *expressDataSet, const IfcLightDistributionData &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightFixtureType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightFixtureType *cloneIfcLightFixtureType(ExpressDataSet *expressDataSet, const IfcLightFixtureType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightIntensityDistribution(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightIntensityDistribution *cloneIfcLightIntensityDistribution(ExpressDataSet *expressDataSet, const IfcLightIntensityDistribution &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightSourceAmbient(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightSourceAmbient *cloneIfcLightSourceAmbient(ExpressDataSet *expressDataSet, const IfcLightSourceAmbient &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightSourceDirectional(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightSourceDirectional *cloneIfcLightSourceDirectional(ExpressDataSet *expressDataSet, const IfcLightSourceDirectional &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightSourceGoniometric(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightSourceGoniometric *cloneIfcLightSourceGoniometric(ExpressDataSet *expressDataSet, const IfcLightSourceGoniometric &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightSourcePositional(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightSourcePositional *cloneIfcLightSourcePositional(ExpressDataSet *expressDataSet, const IfcLightSourcePositional &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLightSourceSpot(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLightSourceSpot *cloneIfcLightSourceSpot(ExpressDataSet *expressDataSet, const IfcLightSourceSpot &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLine(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLine *cloneIfcLine(ExpressDataSet *expressDataSet, const IfcLine &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLinearDimension(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLinearDimension *cloneIfcLinearDimension(ExpressDataSet *expressDataSet, const IfcLinearDimension &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLocalPlacement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLocalPlacement *cloneIfcLocalPlacement(ExpressDataSet *expressDataSet, const IfcLocalPlacement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLocalTime(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLocalTime *cloneIfcLocalTime(ExpressDataSet *expressDataSet, const IfcLocalTime &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcLoop(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcLoop *cloneIfcLoop(ExpressDataSet *expressDataSet, const IfcLoop &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMappedItem(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMappedItem *cloneIfcMappedItem(ExpressDataSet *expressDataSet, const IfcMappedItem &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMaterial(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMaterial *cloneIfcMaterial(ExpressDataSet *expressDataSet, const IfcMaterial &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMaterialClassificationRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMaterialClassificationRelationship *cloneIfcMaterialClassificationRelationship(ExpressDataSet *expressDataSet, const IfcMaterialClassificationRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMaterialDefinitionRepresentation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMaterialDefinitionRepresentation *cloneIfcMaterialDefinitionRepresentation(ExpressDataSet *expressDataSet, const IfcMaterialDefinitionRepresentation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMaterialLayer(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMaterialLayer *cloneIfcMaterialLayer(ExpressDataSet *expressDataSet, const IfcMaterialLayer &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMaterialLayerSet(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMaterialLayerSet *cloneIfcMaterialLayerSet(ExpressDataSet *expressDataSet, const IfcMaterialLayerSet &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMaterialLayerSetUsage(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMaterialLayerSetUsage *cloneIfcMaterialLayerSetUsage(ExpressDataSet *expressDataSet, const IfcMaterialLayerSetUsage &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMaterialList(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMaterialList *cloneIfcMaterialList(ExpressDataSet *expressDataSet, const IfcMaterialList &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMeasureWithUnit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMeasureWithUnit *cloneIfcMeasureWithUnit(ExpressDataSet *expressDataSet, const IfcMeasureWithUnit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMechanicalConcreteMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMechanicalConcreteMaterialProperties *cloneIfcMechanicalConcreteMaterialProperties(ExpressDataSet *expressDataSet, const IfcMechanicalConcreteMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMechanicalFastener(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMechanicalFastener *cloneIfcMechanicalFastener(ExpressDataSet *expressDataSet, const IfcMechanicalFastener &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMechanicalFastenerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMechanicalFastenerType *cloneIfcMechanicalFastenerType(ExpressDataSet *expressDataSet, const IfcMechanicalFastenerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMechanicalMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMechanicalMaterialProperties *cloneIfcMechanicalMaterialProperties(ExpressDataSet *expressDataSet, const IfcMechanicalMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMechanicalSteelMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMechanicalSteelMaterialProperties *cloneIfcMechanicalSteelMaterialProperties(ExpressDataSet *expressDataSet, const IfcMechanicalSteelMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMember(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMember *cloneIfcMember(ExpressDataSet *expressDataSet, const IfcMember &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMemberType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMemberType *cloneIfcMemberType(ExpressDataSet *expressDataSet, const IfcMemberType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMetric(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMetric *cloneIfcMetric(ExpressDataSet *expressDataSet, const IfcMetric &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMonetaryUnit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMonetaryUnit *cloneIfcMonetaryUnit(ExpressDataSet *expressDataSet, const IfcMonetaryUnit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMotorConnectionType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMotorConnectionType *cloneIfcMotorConnectionType(ExpressDataSet *expressDataSet, const IfcMotorConnectionType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcMove(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcMove *cloneIfcMove(ExpressDataSet *expressDataSet, const IfcMove &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcObjective(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcObjective *cloneIfcObjective(ExpressDataSet *expressDataSet, const IfcObjective &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOccupant(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOccupant *cloneIfcOccupant(ExpressDataSet *expressDataSet, const IfcOccupant &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOffsetCurve2D(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOffsetCurve2D *cloneIfcOffsetCurve2D(ExpressDataSet *expressDataSet, const IfcOffsetCurve2D &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOffsetCurve3D(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOffsetCurve3D *cloneIfcOffsetCurve3D(ExpressDataSet *expressDataSet, const IfcOffsetCurve3D &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOneDirectionRepeatFactor(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOneDirectionRepeatFactor *cloneIfcOneDirectionRepeatFactor(ExpressDataSet *expressDataSet, const IfcOneDirectionRepeatFactor &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOpenShell(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOpenShell *cloneIfcOpenShell(ExpressDataSet *expressDataSet, const IfcOpenShell &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOpeningElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOpeningElement *cloneIfcOpeningElement(ExpressDataSet *expressDataSet, const IfcOpeningElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOpticalMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOpticalMaterialProperties *cloneIfcOpticalMaterialProperties(ExpressDataSet *expressDataSet, const IfcOpticalMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOrderAction(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOrderAction *cloneIfcOrderAction(ExpressDataSet *expressDataSet, const IfcOrderAction &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOrganization(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOrganization *cloneIfcOrganization(ExpressDataSet *expressDataSet, const IfcOrganization &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOrganizationRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOrganizationRelationship *cloneIfcOrganizationRelationship(ExpressDataSet *expressDataSet, const IfcOrganizationRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOrientedEdge(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOrientedEdge *cloneIfcOrientedEdge(ExpressDataSet *expressDataSet, const IfcOrientedEdge &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOutletType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOutletType *cloneIfcOutletType(ExpressDataSet *expressDataSet, const IfcOutletType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcOwnerHistory(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcOwnerHistory *cloneIfcOwnerHistory(ExpressDataSet *expressDataSet, const IfcOwnerHistory &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPath(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPath *cloneIfcPath(ExpressDataSet *expressDataSet, const IfcPath &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPerformanceHistory(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPerformanceHistory *cloneIfcPerformanceHistory(ExpressDataSet *expressDataSet, const IfcPerformanceHistory &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPermeableCoveringProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPermeableCoveringProperties *cloneIfcPermeableCoveringProperties(ExpressDataSet *expressDataSet, const IfcPermeableCoveringProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPermit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPermit *cloneIfcPermit(ExpressDataSet *expressDataSet, const IfcPermit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPerson(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPerson *cloneIfcPerson(ExpressDataSet *expressDataSet, const IfcPerson &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPersonAndOrganization(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPersonAndOrganization *cloneIfcPersonAndOrganization(ExpressDataSet *expressDataSet, const IfcPersonAndOrganization &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPhysicalComplexQuantity(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPhysicalComplexQuantity *cloneIfcPhysicalComplexQuantity(ExpressDataSet *expressDataSet, const IfcPhysicalComplexQuantity &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPile(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPile *cloneIfcPile(ExpressDataSet *expressDataSet, const IfcPile &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPipeFittingType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPipeFittingType *cloneIfcPipeFittingType(ExpressDataSet *expressDataSet, const IfcPipeFittingType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPipeSegmentType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPipeSegmentType *cloneIfcPipeSegmentType(ExpressDataSet *expressDataSet, const IfcPipeSegmentType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPixelTexture(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPixelTexture *cloneIfcPixelTexture(ExpressDataSet *expressDataSet, const IfcPixelTexture &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPlanarBox(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPlanarBox *cloneIfcPlanarBox(ExpressDataSet *expressDataSet, const IfcPlanarBox &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPlanarExtent(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPlanarExtent *cloneIfcPlanarExtent(ExpressDataSet *expressDataSet, const IfcPlanarExtent &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPlane(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPlane *cloneIfcPlane(ExpressDataSet *expressDataSet, const IfcPlane &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPlate(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPlate *cloneIfcPlate(ExpressDataSet *expressDataSet, const IfcPlate &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPlateType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPlateType *cloneIfcPlateType(ExpressDataSet *expressDataSet, const IfcPlateType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPointOnCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPointOnCurve *cloneIfcPointOnCurve(ExpressDataSet *expressDataSet, const IfcPointOnCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPointOnSurface(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPointOnSurface *cloneIfcPointOnSurface(ExpressDataSet *expressDataSet, const IfcPointOnSurface &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPolyLoop(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPolyLoop *cloneIfcPolyLoop(ExpressDataSet *expressDataSet, const IfcPolyLoop &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPolygonalBoundedHalfSpace(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPolygonalBoundedHalfSpace *cloneIfcPolygonalBoundedHalfSpace(ExpressDataSet *expressDataSet, const IfcPolygonalBoundedHalfSpace &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPolyline(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPolyline *cloneIfcPolyline(ExpressDataSet *expressDataSet, const IfcPolyline &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPostalAddress(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPostalAddress *cloneIfcPostalAddress(ExpressDataSet *expressDataSet, const IfcPostalAddress &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPreDefinedDimensionSymbol(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPreDefinedDimensionSymbol *cloneIfcPreDefinedDimensionSymbol(ExpressDataSet *expressDataSet, const IfcPreDefinedDimensionSymbol &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPreDefinedPointMarkerSymbol(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPreDefinedPointMarkerSymbol *cloneIfcPreDefinedPointMarkerSymbol(ExpressDataSet *expressDataSet, const IfcPreDefinedPointMarkerSymbol &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPreDefinedTerminatorSymbol(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPreDefinedTerminatorSymbol *cloneIfcPreDefinedTerminatorSymbol(ExpressDataSet *expressDataSet, const IfcPreDefinedTerminatorSymbol &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPresentationLayerAssignment(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPresentationLayerAssignment *cloneIfcPresentationLayerAssignment(ExpressDataSet *expressDataSet, const IfcPresentationLayerAssignment &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPresentationLayerWithStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPresentationLayerWithStyle *cloneIfcPresentationLayerWithStyle(ExpressDataSet *expressDataSet, const IfcPresentationLayerWithStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPresentationStyleAssignment(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPresentationStyleAssignment *cloneIfcPresentationStyleAssignment(ExpressDataSet *expressDataSet, const IfcPresentationStyleAssignment &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProcedure(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProcedure *cloneIfcProcedure(ExpressDataSet *expressDataSet, const IfcProcedure &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProductDefinitionShape(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProductDefinitionShape *cloneIfcProductDefinitionShape(ExpressDataSet *expressDataSet, const IfcProductDefinitionShape &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProductRepresentation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProductRepresentation *cloneIfcProductRepresentation(ExpressDataSet *expressDataSet, const IfcProductRepresentation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProductsOfCombustionProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProductsOfCombustionProperties *cloneIfcProductsOfCombustionProperties(ExpressDataSet *expressDataSet, const IfcProductsOfCombustionProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProject(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProject *cloneIfcProject(ExpressDataSet *expressDataSet, const IfcProject &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProjectOrder(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProjectOrder *cloneIfcProjectOrder(ExpressDataSet *expressDataSet, const IfcProjectOrder &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProjectOrderRecord(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProjectOrderRecord *cloneIfcProjectOrderRecord(ExpressDataSet *expressDataSet, const IfcProjectOrderRecord &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProjectionCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProjectionCurve *cloneIfcProjectionCurve(ExpressDataSet *expressDataSet, const IfcProjectionCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProjectionElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProjectionElement *cloneIfcProjectionElement(ExpressDataSet *expressDataSet, const IfcProjectionElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyBoundedValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyBoundedValue *cloneIfcPropertyBoundedValue(ExpressDataSet *expressDataSet, const IfcPropertyBoundedValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyConstraintRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyConstraintRelationship *cloneIfcPropertyConstraintRelationship(ExpressDataSet *expressDataSet, const IfcPropertyConstraintRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyDependencyRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyDependencyRelationship *cloneIfcPropertyDependencyRelationship(ExpressDataSet *expressDataSet, const IfcPropertyDependencyRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyEnumeratedValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyEnumeratedValue *cloneIfcPropertyEnumeratedValue(ExpressDataSet *expressDataSet, const IfcPropertyEnumeratedValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyEnumeration(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyEnumeration *cloneIfcPropertyEnumeration(ExpressDataSet *expressDataSet, const IfcPropertyEnumeration &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyListValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyListValue *cloneIfcPropertyListValue(ExpressDataSet *expressDataSet, const IfcPropertyListValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyReferenceValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyReferenceValue *cloneIfcPropertyReferenceValue(ExpressDataSet *expressDataSet, const IfcPropertyReferenceValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertySet(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertySet *cloneIfcPropertySet(ExpressDataSet *expressDataSet, const IfcPropertySet &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertySingleValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertySingleValue *cloneIfcPropertySingleValue(ExpressDataSet *expressDataSet, const IfcPropertySingleValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPropertyTableValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPropertyTableValue *cloneIfcPropertyTableValue(ExpressDataSet *expressDataSet, const IfcPropertyTableValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProtectiveDeviceType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProtectiveDeviceType *cloneIfcProtectiveDeviceType(ExpressDataSet *expressDataSet, const IfcProtectiveDeviceType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcProxy(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcProxy *cloneIfcProxy(ExpressDataSet *expressDataSet, const IfcProxy &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcPumpType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcPumpType *cloneIfcPumpType(ExpressDataSet *expressDataSet, const IfcPumpType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcQuantityArea(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcQuantityArea *cloneIfcQuantityArea(ExpressDataSet *expressDataSet, const IfcQuantityArea &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcQuantityCount(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcQuantityCount *cloneIfcQuantityCount(ExpressDataSet *expressDataSet, const IfcQuantityCount &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcQuantityLength(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcQuantityLength *cloneIfcQuantityLength(ExpressDataSet *expressDataSet, const IfcQuantityLength &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcQuantityTime(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcQuantityTime *cloneIfcQuantityTime(ExpressDataSet *expressDataSet, const IfcQuantityTime &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcQuantityVolume(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcQuantityVolume *cloneIfcQuantityVolume(ExpressDataSet *expressDataSet, const IfcQuantityVolume &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcQuantityWeight(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcQuantityWeight *cloneIfcQuantityWeight(ExpressDataSet *expressDataSet, const IfcQuantityWeight &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRadiusDimension(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRadiusDimension *cloneIfcRadiusDimension(ExpressDataSet *expressDataSet, const IfcRadiusDimension &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRailing(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRailing *cloneIfcRailing(ExpressDataSet *expressDataSet, const IfcRailing &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRailingType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRailingType *cloneIfcRailingType(ExpressDataSet *expressDataSet, const IfcRailingType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRamp(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRamp *cloneIfcRamp(ExpressDataSet *expressDataSet, const IfcRamp &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRampFlight(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRampFlight *cloneIfcRampFlight(ExpressDataSet *expressDataSet, const IfcRampFlight &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRampFlightType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRampFlightType *cloneIfcRampFlightType(ExpressDataSet *expressDataSet, const IfcRampFlightType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRationalBezierCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRationalBezierCurve *cloneIfcRationalBezierCurve(ExpressDataSet *expressDataSet, const IfcRationalBezierCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRectangleHollowProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRectangleHollowProfileDef *cloneIfcRectangleHollowProfileDef(ExpressDataSet *expressDataSet, const IfcRectangleHollowProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRectangleProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRectangleProfileDef *cloneIfcRectangleProfileDef(ExpressDataSet *expressDataSet, const IfcRectangleProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRectangularPyramid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRectangularPyramid *cloneIfcRectangularPyramid(ExpressDataSet *expressDataSet, const IfcRectangularPyramid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRectangularTrimmedSurface(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRectangularTrimmedSurface *cloneIfcRectangularTrimmedSurface(ExpressDataSet *expressDataSet, const IfcRectangularTrimmedSurface &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcReferencesValueDocument(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcReferencesValueDocument *cloneIfcReferencesValueDocument(ExpressDataSet *expressDataSet, const IfcReferencesValueDocument &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRegularTimeSeries(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRegularTimeSeries *cloneIfcRegularTimeSeries(ExpressDataSet *expressDataSet, const IfcRegularTimeSeries &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcReinforcementBarProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcReinforcementBarProperties *cloneIfcReinforcementBarProperties(ExpressDataSet *expressDataSet, const IfcReinforcementBarProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcReinforcementDefinitionProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcReinforcementDefinitionProperties *cloneIfcReinforcementDefinitionProperties(ExpressDataSet *expressDataSet, const IfcReinforcementDefinitionProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcReinforcingBar(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcReinforcingBar *cloneIfcReinforcingBar(ExpressDataSet *expressDataSet, const IfcReinforcingBar &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcReinforcingMesh(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcReinforcingMesh *cloneIfcReinforcingMesh(ExpressDataSet *expressDataSet, const IfcReinforcingMesh &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAggregates(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAggregates *cloneIfcRelAggregates(ExpressDataSet *expressDataSet, const IfcRelAggregates &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsTasks(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsTasks *cloneIfcRelAssignsTasks(ExpressDataSet *expressDataSet, const IfcRelAssignsTasks &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsToActor(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsToActor *cloneIfcRelAssignsToActor(ExpressDataSet *expressDataSet, const IfcRelAssignsToActor &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsToControl(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsToControl *cloneIfcRelAssignsToControl(ExpressDataSet *expressDataSet, const IfcRelAssignsToControl &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsToGroup(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsToGroup *cloneIfcRelAssignsToGroup(ExpressDataSet *expressDataSet, const IfcRelAssignsToGroup &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsToProcess(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsToProcess *cloneIfcRelAssignsToProcess(ExpressDataSet *expressDataSet, const IfcRelAssignsToProcess &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsToProduct(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsToProduct *cloneIfcRelAssignsToProduct(ExpressDataSet *expressDataSet, const IfcRelAssignsToProduct &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsToProjectOrder(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsToProjectOrder *cloneIfcRelAssignsToProjectOrder(ExpressDataSet *expressDataSet, const IfcRelAssignsToProjectOrder &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssignsToResource(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssignsToResource *cloneIfcRelAssignsToResource(ExpressDataSet *expressDataSet, const IfcRelAssignsToResource &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociates(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociates *cloneIfcRelAssociates(ExpressDataSet *expressDataSet, const IfcRelAssociates &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesAppliedValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesAppliedValue *cloneIfcRelAssociatesAppliedValue(ExpressDataSet *expressDataSet, const IfcRelAssociatesAppliedValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesApproval(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesApproval *cloneIfcRelAssociatesApproval(ExpressDataSet *expressDataSet, const IfcRelAssociatesApproval &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesClassification(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesClassification *cloneIfcRelAssociatesClassification(ExpressDataSet *expressDataSet, const IfcRelAssociatesClassification &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesConstraint(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesConstraint *cloneIfcRelAssociatesConstraint(ExpressDataSet *expressDataSet, const IfcRelAssociatesConstraint &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesDocument(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesDocument *cloneIfcRelAssociatesDocument(ExpressDataSet *expressDataSet, const IfcRelAssociatesDocument &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesLibrary(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesLibrary *cloneIfcRelAssociatesLibrary(ExpressDataSet *expressDataSet, const IfcRelAssociatesLibrary &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesMaterial(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesMaterial *cloneIfcRelAssociatesMaterial(ExpressDataSet *expressDataSet, const IfcRelAssociatesMaterial &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelAssociatesProfileProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelAssociatesProfileProperties *cloneIfcRelAssociatesProfileProperties(ExpressDataSet *expressDataSet, const IfcRelAssociatesProfileProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsElements(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsElements *cloneIfcRelConnectsElements(ExpressDataSet *expressDataSet, const IfcRelConnectsElements &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsPathElements(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsPathElements *cloneIfcRelConnectsPathElements(ExpressDataSet *expressDataSet, const IfcRelConnectsPathElements &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsPortToElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsPortToElement *cloneIfcRelConnectsPortToElement(ExpressDataSet *expressDataSet, const IfcRelConnectsPortToElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsPorts(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsPorts *cloneIfcRelConnectsPorts(ExpressDataSet *expressDataSet, const IfcRelConnectsPorts &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsStructuralActivity(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsStructuralActivity *cloneIfcRelConnectsStructuralActivity(ExpressDataSet *expressDataSet, const IfcRelConnectsStructuralActivity &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsStructuralElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsStructuralElement *cloneIfcRelConnectsStructuralElement(ExpressDataSet *expressDataSet, const IfcRelConnectsStructuralElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsStructuralMember(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsStructuralMember *cloneIfcRelConnectsStructuralMember(ExpressDataSet *expressDataSet, const IfcRelConnectsStructuralMember &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsWithEccentricity(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsWithEccentricity *cloneIfcRelConnectsWithEccentricity(ExpressDataSet *expressDataSet, const IfcRelConnectsWithEccentricity &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelConnectsWithRealizingElements(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelConnectsWithRealizingElements *cloneIfcRelConnectsWithRealizingElements(ExpressDataSet *expressDataSet, const IfcRelConnectsWithRealizingElements &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelContainedInSpatialStructure(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelContainedInSpatialStructure *cloneIfcRelContainedInSpatialStructure(ExpressDataSet *expressDataSet, const IfcRelContainedInSpatialStructure &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelCoversBldgElements(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelCoversBldgElements *cloneIfcRelCoversBldgElements(ExpressDataSet *expressDataSet, const IfcRelCoversBldgElements &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelCoversSpaces(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelCoversSpaces *cloneIfcRelCoversSpaces(ExpressDataSet *expressDataSet, const IfcRelCoversSpaces &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelDefinesByProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelDefinesByProperties *cloneIfcRelDefinesByProperties(ExpressDataSet *expressDataSet, const IfcRelDefinesByProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelDefinesByType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelDefinesByType *cloneIfcRelDefinesByType(ExpressDataSet *expressDataSet, const IfcRelDefinesByType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelFillsElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelFillsElement *cloneIfcRelFillsElement(ExpressDataSet *expressDataSet, const IfcRelFillsElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelFlowControlElements(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelFlowControlElements *cloneIfcRelFlowControlElements(ExpressDataSet *expressDataSet, const IfcRelFlowControlElements &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelInteractionRequirements(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelInteractionRequirements *cloneIfcRelInteractionRequirements(ExpressDataSet *expressDataSet, const IfcRelInteractionRequirements &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelNests(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelNests *cloneIfcRelNests(ExpressDataSet *expressDataSet, const IfcRelNests &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelOccupiesSpaces(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelOccupiesSpaces *cloneIfcRelOccupiesSpaces(ExpressDataSet *expressDataSet, const IfcRelOccupiesSpaces &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelOverridesProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelOverridesProperties *cloneIfcRelOverridesProperties(ExpressDataSet *expressDataSet, const IfcRelOverridesProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelProjectsElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelProjectsElement *cloneIfcRelProjectsElement(ExpressDataSet *expressDataSet, const IfcRelProjectsElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelReferencedInSpatialStructure(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelReferencedInSpatialStructure *cloneIfcRelReferencedInSpatialStructure(ExpressDataSet *expressDataSet, const IfcRelReferencedInSpatialStructure &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelSchedulesCostItems(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelSchedulesCostItems *cloneIfcRelSchedulesCostItems(ExpressDataSet *expressDataSet, const IfcRelSchedulesCostItems &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelSequence(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelSequence *cloneIfcRelSequence(ExpressDataSet *expressDataSet, const IfcRelSequence &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelServicesBuildings(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelServicesBuildings *cloneIfcRelServicesBuildings(ExpressDataSet *expressDataSet, const IfcRelServicesBuildings &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelSpaceBoundary(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelSpaceBoundary *cloneIfcRelSpaceBoundary(ExpressDataSet *expressDataSet, const IfcRelSpaceBoundary &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelVoidsElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelVoidsElement *cloneIfcRelVoidsElement(ExpressDataSet *expressDataSet, const IfcRelVoidsElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRelaxation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRelaxation *cloneIfcRelaxation(ExpressDataSet *expressDataSet, const IfcRelaxation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRepresentation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRepresentation *cloneIfcRepresentation(ExpressDataSet *expressDataSet, const IfcRepresentation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRepresentationContext(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRepresentationContext *cloneIfcRepresentationContext(ExpressDataSet *expressDataSet, const IfcRepresentationContext &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRepresentationMap(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRepresentationMap *cloneIfcRepresentationMap(ExpressDataSet *expressDataSet, const IfcRepresentationMap &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRevolvedAreaSolid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRevolvedAreaSolid *cloneIfcRevolvedAreaSolid(ExpressDataSet *expressDataSet, const IfcRevolvedAreaSolid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRibPlateProfileProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRibPlateProfileProperties *cloneIfcRibPlateProfileProperties(ExpressDataSet *expressDataSet, const IfcRibPlateProfileProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRightCircularCone(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRightCircularCone *cloneIfcRightCircularCone(ExpressDataSet *expressDataSet, const IfcRightCircularCone &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRightCircularCylinder(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRightCircularCylinder *cloneIfcRightCircularCylinder(ExpressDataSet *expressDataSet, const IfcRightCircularCylinder &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRoof(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRoof *cloneIfcRoof(ExpressDataSet *expressDataSet, const IfcRoof &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRoundedEdgeFeature(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRoundedEdgeFeature *cloneIfcRoundedEdgeFeature(ExpressDataSet *expressDataSet, const IfcRoundedEdgeFeature &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcRoundedRectangleProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcRoundedRectangleProfileDef *cloneIfcRoundedRectangleProfileDef(ExpressDataSet *expressDataSet, const IfcRoundedRectangleProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSIUnit(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSIUnit *cloneIfcSIUnit(ExpressDataSet *expressDataSet, const IfcSIUnit &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSanitaryTerminalType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSanitaryTerminalType *cloneIfcSanitaryTerminalType(ExpressDataSet *expressDataSet, const IfcSanitaryTerminalType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcScheduleTimeControl(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcScheduleTimeControl *cloneIfcScheduleTimeControl(ExpressDataSet *expressDataSet, const IfcScheduleTimeControl &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSectionProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSectionProperties *cloneIfcSectionProperties(ExpressDataSet *expressDataSet, const IfcSectionProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSectionReinforcementProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSectionReinforcementProperties *cloneIfcSectionReinforcementProperties(ExpressDataSet *expressDataSet, const IfcSectionReinforcementProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSectionedSpine(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSectionedSpine *cloneIfcSectionedSpine(ExpressDataSet *expressDataSet, const IfcSectionedSpine &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSensorType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSensorType *cloneIfcSensorType(ExpressDataSet *expressDataSet, const IfcSensorType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcServiceLife(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcServiceLife *cloneIfcServiceLife(ExpressDataSet *expressDataSet, const IfcServiceLife &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcServiceLifeFactor(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcServiceLifeFactor *cloneIfcServiceLifeFactor(ExpressDataSet *expressDataSet, const IfcServiceLifeFactor &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcShapeAspect(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcShapeAspect *cloneIfcShapeAspect(ExpressDataSet *expressDataSet, const IfcShapeAspect &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcShapeRepresentation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcShapeRepresentation *cloneIfcShapeRepresentation(ExpressDataSet *expressDataSet, const IfcShapeRepresentation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcShellBasedSurfaceModel(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcShellBasedSurfaceModel *cloneIfcShellBasedSurfaceModel(ExpressDataSet *expressDataSet, const IfcShellBasedSurfaceModel &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSite(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSite *cloneIfcSite(ExpressDataSet *expressDataSet, const IfcSite &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSlab(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSlab *cloneIfcSlab(ExpressDataSet *expressDataSet, const IfcSlab &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSlabType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSlabType *cloneIfcSlabType(ExpressDataSet *expressDataSet, const IfcSlabType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSlippageConnectionCondition(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSlippageConnectionCondition *cloneIfcSlippageConnectionCondition(ExpressDataSet *expressDataSet, const IfcSlippageConnectionCondition &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSoundProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSoundProperties *cloneIfcSoundProperties(ExpressDataSet *expressDataSet, const IfcSoundProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSoundValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSoundValue *cloneIfcSoundValue(ExpressDataSet *expressDataSet, const IfcSoundValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSpace(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSpace *cloneIfcSpace(ExpressDataSet *expressDataSet, const IfcSpace &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSpaceHeaterType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSpaceHeaterType *cloneIfcSpaceHeaterType(ExpressDataSet *expressDataSet, const IfcSpaceHeaterType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSpaceProgram(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSpaceProgram *cloneIfcSpaceProgram(ExpressDataSet *expressDataSet, const IfcSpaceProgram &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSpaceThermalLoadProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSpaceThermalLoadProperties *cloneIfcSpaceThermalLoadProperties(ExpressDataSet *expressDataSet, const IfcSpaceThermalLoadProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSpaceType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSpaceType *cloneIfcSpaceType(ExpressDataSet *expressDataSet, const IfcSpaceType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSphere(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSphere *cloneIfcSphere(ExpressDataSet *expressDataSet, const IfcSphere &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStackTerminalType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStackTerminalType *cloneIfcStackTerminalType(ExpressDataSet *expressDataSet, const IfcStackTerminalType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStair(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStair *cloneIfcStair(ExpressDataSet *expressDataSet, const IfcStair &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStairFlight(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStairFlight *cloneIfcStairFlight(ExpressDataSet *expressDataSet, const IfcStairFlight &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStairFlightType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStairFlightType *cloneIfcStairFlightType(ExpressDataSet *expressDataSet, const IfcStairFlightType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralAnalysisModel(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralAnalysisModel *cloneIfcStructuralAnalysisModel(ExpressDataSet *expressDataSet, const IfcStructuralAnalysisModel &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralCurveConnection(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralCurveConnection *cloneIfcStructuralCurveConnection(ExpressDataSet *expressDataSet, const IfcStructuralCurveConnection &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralCurveMember(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralCurveMember *cloneIfcStructuralCurveMember(ExpressDataSet *expressDataSet, const IfcStructuralCurveMember &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralCurveMemberVarying(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralCurveMemberVarying *cloneIfcStructuralCurveMemberVarying(ExpressDataSet *expressDataSet, const IfcStructuralCurveMemberVarying &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLinearAction(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLinearAction *cloneIfcStructuralLinearAction(ExpressDataSet *expressDataSet, const IfcStructuralLinearAction &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLinearActionVarying(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLinearActionVarying *cloneIfcStructuralLinearActionVarying(ExpressDataSet *expressDataSet, const IfcStructuralLinearActionVarying &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadGroup(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadGroup *cloneIfcStructuralLoadGroup(ExpressDataSet *expressDataSet, const IfcStructuralLoadGroup &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadLinearForce(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadLinearForce *cloneIfcStructuralLoadLinearForce(ExpressDataSet *expressDataSet, const IfcStructuralLoadLinearForce &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadPlanarForce(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadPlanarForce *cloneIfcStructuralLoadPlanarForce(ExpressDataSet *expressDataSet, const IfcStructuralLoadPlanarForce &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadSingleDisplacement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadSingleDisplacement *cloneIfcStructuralLoadSingleDisplacement(ExpressDataSet *expressDataSet, const IfcStructuralLoadSingleDisplacement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadSingleDisplacementDistortion(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadSingleDisplacementDistortion *cloneIfcStructuralLoadSingleDisplacementDistortion(ExpressDataSet *expressDataSet, const IfcStructuralLoadSingleDisplacementDistortion &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadSingleForce(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadSingleForce *cloneIfcStructuralLoadSingleForce(ExpressDataSet *expressDataSet, const IfcStructuralLoadSingleForce &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadSingleForceWarping(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadSingleForceWarping *cloneIfcStructuralLoadSingleForceWarping(ExpressDataSet *expressDataSet, const IfcStructuralLoadSingleForceWarping &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralLoadTemperature(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralLoadTemperature *cloneIfcStructuralLoadTemperature(ExpressDataSet *expressDataSet, const IfcStructuralLoadTemperature &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralPlanarAction(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralPlanarAction *cloneIfcStructuralPlanarAction(ExpressDataSet *expressDataSet, const IfcStructuralPlanarAction &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralPlanarActionVarying(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralPlanarActionVarying *cloneIfcStructuralPlanarActionVarying(ExpressDataSet *expressDataSet, const IfcStructuralPlanarActionVarying &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralPointAction(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralPointAction *cloneIfcStructuralPointAction(ExpressDataSet *expressDataSet, const IfcStructuralPointAction &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralPointConnection(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralPointConnection *cloneIfcStructuralPointConnection(ExpressDataSet *expressDataSet, const IfcStructuralPointConnection &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralPointReaction(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralPointReaction *cloneIfcStructuralPointReaction(ExpressDataSet *expressDataSet, const IfcStructuralPointReaction &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralProfileProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralProfileProperties *cloneIfcStructuralProfileProperties(ExpressDataSet *expressDataSet, const IfcStructuralProfileProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralResultGroup(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralResultGroup *cloneIfcStructuralResultGroup(ExpressDataSet *expressDataSet, const IfcStructuralResultGroup &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralSteelProfileProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralSteelProfileProperties *cloneIfcStructuralSteelProfileProperties(ExpressDataSet *expressDataSet, const IfcStructuralSteelProfileProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralSurfaceConnection(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralSurfaceConnection *cloneIfcStructuralSurfaceConnection(ExpressDataSet *expressDataSet, const IfcStructuralSurfaceConnection &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralSurfaceMember(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralSurfaceMember *cloneIfcStructuralSurfaceMember(ExpressDataSet *expressDataSet, const IfcStructuralSurfaceMember &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuralSurfaceMemberVarying(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuralSurfaceMemberVarying *cloneIfcStructuralSurfaceMemberVarying(ExpressDataSet *expressDataSet, const IfcStructuralSurfaceMemberVarying &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStructuredDimensionCallout(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStructuredDimensionCallout *cloneIfcStructuredDimensionCallout(ExpressDataSet *expressDataSet, const IfcStructuredDimensionCallout &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStyledItem(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStyledItem *cloneIfcStyledItem(ExpressDataSet *expressDataSet, const IfcStyledItem &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcStyledRepresentation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcStyledRepresentation *cloneIfcStyledRepresentation(ExpressDataSet *expressDataSet, const IfcStyledRepresentation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSubContractResource(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSubContractResource *cloneIfcSubContractResource(ExpressDataSet *expressDataSet, const IfcSubContractResource &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSubedge(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSubedge *cloneIfcSubedge(ExpressDataSet *expressDataSet, const IfcSubedge &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceCurveSweptAreaSolid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceCurveSweptAreaSolid *cloneIfcSurfaceCurveSweptAreaSolid(ExpressDataSet *expressDataSet, const IfcSurfaceCurveSweptAreaSolid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceOfLinearExtrusion(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceOfLinearExtrusion *cloneIfcSurfaceOfLinearExtrusion(ExpressDataSet *expressDataSet, const IfcSurfaceOfLinearExtrusion &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceOfRevolution(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceOfRevolution *cloneIfcSurfaceOfRevolution(ExpressDataSet *expressDataSet, const IfcSurfaceOfRevolution &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceStyle *cloneIfcSurfaceStyle(ExpressDataSet *expressDataSet, const IfcSurfaceStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceStyleLighting(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceStyleLighting *cloneIfcSurfaceStyleLighting(ExpressDataSet *expressDataSet, const IfcSurfaceStyleLighting &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceStyleRefraction(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceStyleRefraction *cloneIfcSurfaceStyleRefraction(ExpressDataSet *expressDataSet, const IfcSurfaceStyleRefraction &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceStyleRendering(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceStyleRendering *cloneIfcSurfaceStyleRendering(ExpressDataSet *expressDataSet, const IfcSurfaceStyleRendering &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceStyleShading(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceStyleShading *cloneIfcSurfaceStyleShading(ExpressDataSet *expressDataSet, const IfcSurfaceStyleShading &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSurfaceStyleWithTextures(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSurfaceStyleWithTextures *cloneIfcSurfaceStyleWithTextures(ExpressDataSet *expressDataSet, const IfcSurfaceStyleWithTextures &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSweptDiskSolid(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSweptDiskSolid *cloneIfcSweptDiskSolid(ExpressDataSet *expressDataSet, const IfcSweptDiskSolid &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSwitchingDeviceType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSwitchingDeviceType *cloneIfcSwitchingDeviceType(ExpressDataSet *expressDataSet, const IfcSwitchingDeviceType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSymbolStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSymbolStyle *cloneIfcSymbolStyle(ExpressDataSet *expressDataSet, const IfcSymbolStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSystem(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSystem *cloneIfcSystem(ExpressDataSet *expressDataSet, const IfcSystem &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcSystemFurnitureElementType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcSystemFurnitureElementType *cloneIfcSystemFurnitureElementType(ExpressDataSet *expressDataSet, const IfcSystemFurnitureElementType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTShapeProfileDef *cloneIfcTShapeProfileDef(ExpressDataSet *expressDataSet, const IfcTShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTable(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTable *cloneIfcTable(ExpressDataSet *expressDataSet, const IfcTable &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTableRow(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTableRow *cloneIfcTableRow(ExpressDataSet *expressDataSet, const IfcTableRow &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTankType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTankType *cloneIfcTankType(ExpressDataSet *expressDataSet, const IfcTankType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTask(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTask *cloneIfcTask(ExpressDataSet *expressDataSet, const IfcTask &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTelecomAddress(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTelecomAddress *cloneIfcTelecomAddress(ExpressDataSet *expressDataSet, const IfcTelecomAddress &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTendon(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTendon *cloneIfcTendon(ExpressDataSet *expressDataSet, const IfcTendon &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTendonAnchor(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTendonAnchor *cloneIfcTendonAnchor(ExpressDataSet *expressDataSet, const IfcTendonAnchor &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTerminatorSymbol(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTerminatorSymbol *cloneIfcTerminatorSymbol(ExpressDataSet *expressDataSet, const IfcTerminatorSymbol &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextLiteral(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextLiteral *cloneIfcTextLiteral(ExpressDataSet *expressDataSet, const IfcTextLiteral &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextLiteralWithExtent(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextLiteralWithExtent *cloneIfcTextLiteralWithExtent(ExpressDataSet *expressDataSet, const IfcTextLiteralWithExtent &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextStyle *cloneIfcTextStyle(ExpressDataSet *expressDataSet, const IfcTextStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextStyleFontModel(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextStyleFontModel *cloneIfcTextStyleFontModel(ExpressDataSet *expressDataSet, const IfcTextStyleFontModel &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextStyleForDefinedFont(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextStyleForDefinedFont *cloneIfcTextStyleForDefinedFont(ExpressDataSet *expressDataSet, const IfcTextStyleForDefinedFont &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextStyleTextModel(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextStyleTextModel *cloneIfcTextStyleTextModel(ExpressDataSet *expressDataSet, const IfcTextStyleTextModel &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextStyleWithBoxCharacteristics(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextStyleWithBoxCharacteristics *cloneIfcTextStyleWithBoxCharacteristics(ExpressDataSet *expressDataSet, const IfcTextStyleWithBoxCharacteristics &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextureCoordinateGenerator(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextureCoordinateGenerator *cloneIfcTextureCoordinateGenerator(ExpressDataSet *expressDataSet, const IfcTextureCoordinateGenerator &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextureMap(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextureMap *cloneIfcTextureMap(ExpressDataSet *expressDataSet, const IfcTextureMap &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTextureVertex(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTextureVertex *cloneIfcTextureVertex(ExpressDataSet *expressDataSet, const IfcTextureVertex &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcThermalMaterialProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcThermalMaterialProperties *cloneIfcThermalMaterialProperties(ExpressDataSet *expressDataSet, const IfcThermalMaterialProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTimeSeriesReferenceRelationship(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTimeSeriesReferenceRelationship *cloneIfcTimeSeriesReferenceRelationship(ExpressDataSet *expressDataSet, const IfcTimeSeriesReferenceRelationship &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTimeSeriesSchedule(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTimeSeriesSchedule *cloneIfcTimeSeriesSchedule(ExpressDataSet *expressDataSet, const IfcTimeSeriesSchedule &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTimeSeriesValue(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTimeSeriesValue *cloneIfcTimeSeriesValue(ExpressDataSet *expressDataSet, const IfcTimeSeriesValue &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTopologyRepresentation(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTopologyRepresentation *cloneIfcTopologyRepresentation(ExpressDataSet *expressDataSet, const IfcTopologyRepresentation &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTransformerType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTransformerType *cloneIfcTransformerType(ExpressDataSet *expressDataSet, const IfcTransformerType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTransportElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTransportElement *cloneIfcTransportElement(ExpressDataSet *expressDataSet, const IfcTransportElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTransportElementType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTransportElementType *cloneIfcTransportElementType(ExpressDataSet *expressDataSet, const IfcTransportElementType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTrapeziumProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTrapeziumProfileDef *cloneIfcTrapeziumProfileDef(ExpressDataSet *expressDataSet, const IfcTrapeziumProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTrimmedCurve(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTrimmedCurve *cloneIfcTrimmedCurve(ExpressDataSet *expressDataSet, const IfcTrimmedCurve &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTubeBundleType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTubeBundleType *cloneIfcTubeBundleType(ExpressDataSet *expressDataSet, const IfcTubeBundleType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTwoDirectionRepeatFactor(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTwoDirectionRepeatFactor *cloneIfcTwoDirectionRepeatFactor(ExpressDataSet *expressDataSet, const IfcTwoDirectionRepeatFactor &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTypeObject(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTypeObject *cloneIfcTypeObject(ExpressDataSet *expressDataSet, const IfcTypeObject &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcTypeProduct(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcTypeProduct *cloneIfcTypeProduct(ExpressDataSet *expressDataSet, const IfcTypeProduct &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcUShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcUShapeProfileDef *cloneIfcUShapeProfileDef(ExpressDataSet *expressDataSet, const IfcUShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcUnitAssignment(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcUnitAssignment *cloneIfcUnitAssignment(ExpressDataSet *expressDataSet, const IfcUnitAssignment &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcUnitaryEquipmentType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcUnitaryEquipmentType *cloneIfcUnitaryEquipmentType(ExpressDataSet *expressDataSet, const IfcUnitaryEquipmentType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcValveType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcValveType *cloneIfcValveType(ExpressDataSet *expressDataSet, const IfcValveType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVector(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVector *cloneIfcVector(ExpressDataSet *expressDataSet, const IfcVector &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVertex(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVertex *cloneIfcVertex(ExpressDataSet *expressDataSet, const IfcVertex &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVertexBasedTextureMap(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVertexBasedTextureMap *cloneIfcVertexBasedTextureMap(ExpressDataSet *expressDataSet, const IfcVertexBasedTextureMap &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVertexLoop(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVertexLoop *cloneIfcVertexLoop(ExpressDataSet *expressDataSet, const IfcVertexLoop &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVertexPoint(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVertexPoint *cloneIfcVertexPoint(ExpressDataSet *expressDataSet, const IfcVertexPoint &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVibrationIsolatorType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVibrationIsolatorType *cloneIfcVibrationIsolatorType(ExpressDataSet *expressDataSet, const IfcVibrationIsolatorType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVirtualElement(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVirtualElement *cloneIfcVirtualElement(ExpressDataSet *expressDataSet, const IfcVirtualElement &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcVirtualGridIntersection(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcVirtualGridIntersection *cloneIfcVirtualGridIntersection(ExpressDataSet *expressDataSet, const IfcVirtualGridIntersection &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWall(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWall *cloneIfcWall(ExpressDataSet *expressDataSet, const IfcWall &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWallStandardCase(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWallStandardCase *cloneIfcWallStandardCase(ExpressDataSet *expressDataSet, const IfcWallStandardCase &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWallType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWallType *cloneIfcWallType(ExpressDataSet *expressDataSet, const IfcWallType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWasteTerminalType(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWasteTerminalType *cloneIfcWasteTerminalType(ExpressDataSet *expressDataSet, const IfcWasteTerminalType &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWaterProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWaterProperties *cloneIfcWaterProperties(ExpressDataSet *expressDataSet, const IfcWaterProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWindow(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWindow *cloneIfcWindow(ExpressDataSet *expressDataSet, const IfcWindow &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWindowLiningProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWindowLiningProperties *cloneIfcWindowLiningProperties(ExpressDataSet *expressDataSet, const IfcWindowLiningProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWindowPanelProperties(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWindowPanelProperties *cloneIfcWindowPanelProperties(ExpressDataSet *expressDataSet, const IfcWindowPanelProperties &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWindowStyle(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWindowStyle *cloneIfcWindowStyle(ExpressDataSet *expressDataSet, const IfcWindowStyle &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWorkPlan(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWorkPlan *cloneIfcWorkPlan(ExpressDataSet *expressDataSet, const IfcWorkPlan &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcWorkSchedule(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcWorkSchedule *cloneIfcWorkSchedule(ExpressDataSet *expressDataSet, const IfcWorkSchedule &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcZShapeProfileDef(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcZShapeProfileDef *cloneIfcZShapeProfileDef(ExpressDataSet *expressDataSet, const IfcZShapeProfileDef &obj, const CopyOp &copyop);
        /**
         * @param expressDataSet
         * @param id The Id of the Entity.
         */
        static Step::BaseEntity *allocateIfcZone(Step::BaseExpressDataSet *expressDataSet, Step::Id id);
        /**
         * @param expressDataSet
         * @param obj The Entity to clone.
         * @param copyop The copy operator to use when cloning obj.
         */
        static IfcZone *cloneIfcZone(ExpressDataSet *expressDataSet, const IfcZone &obj, const CopyOp &copyop);

    };

}

#endif // IFC2X3_EXPRESSDATASET_H
